#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void dodajdole(int x,vector<int> &bit){
    for(;x<bit.size();x+=x&-x) bit[x]++;
}

void sklonidole(int x,vector<int> &bit){
    for(;x<bit.size();x+=x&-x) bit[x]--;
}

int upitdole(int x,vector<int> &bit){
    int ret=0;
    for(;x>0;x-=x&-x) ret+=bit[x];
    return ret;
}

int upitgore(int x,vector<int> &bit){
    int ret=upitdole(bit.size()-1,bit)-upitdole(x,bit);
    return ret;
}

int main(){
    int n;
    cin>>n;
    vector<int> niz(n+1,0);
    vector<int> gde(n+1);
    for(int i=0;i<n;i++){
        cin>>niz[i];
        gde[niz[i]]=i;
    }
    int koren=sqrt(n)+0.0001;
    vector<int> bit(n+1,0);
    vector<vector<int> > decomp(koren+2,bit);
    ///uradi pocetni
    ll res=0;
    for(int i=n-1;i>=0;i--){
        res+=upitdole(niz[i],bit);
        dodajdole(niz[i],bit);
    }
    for(int i=0;i<n;i++){
        dodajdole(niz[i],decomp[i/koren]);
    }
    cout<<res<<" ";
    //cout<<"koren: "<<koren<<"\n";
    ///
    for(int i=0;i<n-2;i++){
        int a;
        cin>>a;
        //cout<<"ovde je: "<<gde[a]<<"\n";
        for(int j=0;j<gde[a];){
            if(j+koren<=gde[a]){
                res-=upitgore(a,decomp[j/koren]);
                //cout<<"ovo: "<<j/koren*koren<<" "<<j/koren*koren+koren-1<<" "<<a<<" "<<upitgore(a,decomp[j/koren])<<"\n";
                j+=koren;
            }else{
                //cout<<"ovo drugo: "<<j<<"\n";
                if(niz[j]!=-1 && niz[j]>a) res--;
                j++;
            }
        }
        for(int j=gde[a]+1;j<n;){
            if(j%koren==0 && j+koren<=n){
                res-=upitdole(a,decomp[j/koren]);
                j+=koren;
            }else{
                if(niz[j]!=-1 && niz[j]<a) res--;
                j++;
            }
        }
        ///
        niz[gde[a]]=-1;
        sklonidole(a,decomp[gde[a]/koren]);
        ///
        cout<<res<<" ";
    }
    return 0;
}
