#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll inf = 2000000000000000000;

int n, niz[100099], pozs[100099], vadi[100099];
ll uk, levoVeci[400099], desnoManji[400099], mini[400099], maxi[400099];
ll permLevo[100099], permDesno[100099];
void updatel(int node, int poz, int tl, int tr) {
    if(tl==tr) {levoVeci[node]=1; return;}
    int mid=(tl+tr)/2;
    if(poz<=mid) updatel(2*node, poz, tl, mid);
    else updatel(2*node+1, poz, mid+1, tr);
    levoVeci[node]=levoVeci[2*node]+levoVeci[2*node+1];
}
ll queryl(int node, int gl, int gr, int tl, int tr) {
    if(tl>=gl && tr<=gr) return levoVeci[node];
    if(tl>gr || tr<gl) return 0;
    int mid=(tl+tr)/2;
    ll zbir=0LL;
    if(gl<=mid) zbir+=queryl(2*node, gl, gr, tl, mid);
    if(gr>=mid+1) zbir+=queryl(2*node+1, gl, gr, mid+1, tr);
    return zbir;
}
void updated(int node, int poz, int tl, int tr) {
    if(tl==tr) {desnoManji[node]=1; return;}
    int mid=(tl+tr)/2;
    if(poz<=mid) updated(2*node, poz, tl, mid);
    else updated(2*node+1, poz, mid+1, tr);
    desnoManji[node]=desnoManji[2*node]+desnoManji[2*node+1];
}
ll queryd(int node, int gl, int gr, int tl, int tr) {
    if(tl>=gl && tr<=gr) return desnoManji[node];
    if(tl>gr || tr<gl) return 0;
    int mid=(tl+tr)/2;
    ll zbir=0LL;
    if(gl<=mid) zbir+=queryd(2*node, gl, gr, tl, mid);
    if(gr>=mid+1) zbir+=queryd(2*node+1, gl, gr, mid+1, tr);
    return zbir;
}
void buildmini(int node, int tl, int tr) {
    if(tl==tr) {mini[node]=inf; return;}
    int mid=(tl+tr)/2;
    buildmini(2*node, tl, mid);
    buildmini(2*node+1, mid+1, tr);
    mini[node]=min(mini[2*node], mini[2*node+1]);
}
void buildmaxi(int node, int tl, int tr) {
    if(tl==tr) {maxi[node]=-1; return;}
    int mid=(tl+tr)/2;
    buildmaxi(2*node, tl, mid);
    buildmaxi(2*node+1, mid+1, tr);
    maxi[node]=max(maxi[2*node], maxi[2*node+1]);
}
void updatemini(int node, int poz, int vr, int tl, int tr) {
    if(tl==tr) {mini[node]=vr; return;}
    int mid=(tl+tr)/2;
    if(poz<=mid) updatemini(2*node, poz, vr, tl, mid);
    else updatemini(2*node+1, poz, vr, mid+1, tr);
    mini[node]=min(mini[2*node], mini[2*node+1]);
}
void updatemaxi(int node, int poz, int vr, int tl, int tr) {
    if(tl==tr) {maxi[node]=vr; return;}
    int mid=(tl+tr)/2;
    if(poz<=mid) updatemaxi(2*node, poz, vr, tl, mid);
    else updatemaxi(2*node+1, poz, vr, mid+1, tr);
    maxi[node]=max(maxi[2*node], maxi[2*node+1]);
}
ll querymanji(int node, int gl, int gr, int tl, int tr, int vr) {
    if(tl>gr || tr<gl) return 0;
    if(tl>tr) return 0;
    if(maxi[node]<mini[node]) return 0;
    if(vr<mini[node]) return 0;

    /// ako nije ispunjen drugi uslov, nema smisla dalje proveravati!
    ll ukk=0LL;
    int mid=(tl+tr)/2;
    if(tl>=gl && tr<=gr) {
        /// tek sad probam
        if(maxi[node]<=vr) ukk+=(tr-tl+1);
        else ukk+=querymanji(2*node, gl, gr, tl, mid, vr)+querymanji(2*node+1, gl, gr, mid+1, tr, vr);
    }
    else {
        if(mid+1<=gr) {
            ukk+=querymanji(2*node+1, gl, gr, mid+1, tr, vr);
        }
        if(mid>=gl) {
            ukk+=querymanji(2*node, gl, gr, tl, mid, vr);
        }
    }
    return ukk;
}
ll queryveci(int node, int gl, int gr, int tl, int tr, int vr) {
    if(tl>gr || tr<gl) return 0;
    if(tl>tr) return 0;
    if(maxi[node]<mini[node]) return 0;
    if(vr>maxi[node]) return 0;
    /// ako nije ispunjen drugi uslov, nema smisla dalje proveravati!
    ll ukk=0LL;
    int mid=(tl+tr)/2;
    if(tl>=gl && tr<=gr) {
        /// tek sad probam
        if(mini[node]>=vr) ukk+=(tr-tl+1);
        else ukk+=queryveci(2*node, gl, gr, tl, mid, vr)+queryveci(2*node+1, gl, gr, mid+1, tr, vr);
    }
    else {
        if(mid+1<=gr) {
            ukk+=queryveci(2*node+1, gl, gr, mid+1, tr, vr);
        }
        if(mid>=gl) {
            ukk+=queryveci(2*node, gl, gr, tl, mid, vr);
        }
    }
    return ukk;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i=1; i<=n; ++i) {
        cin >> niz[i];
        pozs[niz[i]]=i;
        updatel(1, niz[i], 1, n);
        permLevo[niz[i]]=queryl(1, niz[i]+1, n, 1, n);
        uk+=permLevo[niz[i]];
    }
    for(int i=n; i>=1; --i) {
        updated(1, niz[i], 1, n);
        permDesno[niz[i]]=queryd(1, 1, niz[i]-1, 1, n);
    }
    buildmini(1, 1, n);
    buildmaxi(1, 1, n);
    for(int i=1; i<=n-1; ++i) {
        cout << uk << ' ';
        if(i==n-1) break;
        cin >> vadi[i];
        uk+=querymanji(1, pozs[vadi[i]]+1, n, 1, n, vadi[i]);
        uk+=queryveci(1, 1, pozs[vadi[i]], 1, n, vadi[i]);
        updatemini(1, pozs[vadi[i]], vadi[i], 1, n);
        updatemaxi(1, pozs[vadi[i]], vadi[i], 1, n);
        uk-=permLevo[vadi[i]]+permDesno[vadi[i]];
    }
    return 0;
}
