#include <bits/stdc++.h>

using namespace std;

int n, a[100002], poz[100002];

struct meh {
  vector<int>v, aib;
  meh () {
    v.push_back(0);
    aib.push_back(0);
  }
} aint[400002];

void updateAIB (int ind, int sz, int poz, int val) {
  for (int i = poz; i <= sz; i += (i & -i))
    aint[ind].aib[i] += val;
}
int queryAIB (int nod, int x) {
  int s = 0;
  for (int i = x; i; i -= (i & -i))
    s += aint[nod].aib[i];
  return s;
}

void build (int nod, int st, int dr) {
  if (st == dr) {
    //aint[nod].v.push_back(0);
   // aint[nod].aib.push_back(0);
    aint[nod].aib.push_back(1);
    aint[nod].v.push_back(a[st]);
    return;
  }
  //aint[nod].v.push_back(0);
  //aint[nod].aib.push_back(0);
  for (int i = 1; i <= dr - st + 1; i++)
    aint[nod].aib.push_back(0);
  for (int i = st; i<= dr; i++) {
    aint[nod].v.push_back(a[i]);
    updateAIB(nod, dr - st + 1, i - st + 1, 1);
  }
  sort(aint[nod].v.begin(), aint[nod].v.end());
  int mid = (st + dr) / 2;
  build (2 * nod, st, mid);
  build (2 * nod + 1, mid + 1, dr);
  return;
}

void update (int nod, int st, int dr, int poz){
  if (st == dr) {
    updateAIB(nod, 1, 1, -1);
    return;
  }
  int x = lower_bound(aint[nod].v.begin(), aint[nod].v.end(), a[poz]) - aint[nod].v.begin();
  updateAIB(nod, dr - st + 1, x, -1);
  int mid = (st + dr) / 2;
  if (poz <= mid)
    update(2 * nod, st, mid, poz);
  else
    update(2 * nod + 1, mid + 1, dr, poz);
  return;
}
int ans = 0;

void query (int nod, int st, int dr, int a, int b, int val, bool ok) {
  if (a <= st && dr <= b) {
    int x = upper_bound(aint[nod].v.begin(), aint[nod].v.end(), val) - aint[nod].v.begin();
    if (ok) {
      ans += queryAIB(nod, x - 1);
    }
    else
      ans += queryAIB(nod, dr - st + 1) - queryAIB(nod, x - 1);
    return;
  }
  int mid = (st + dr) / 2;
  if (a <= mid)
    query(2 * nod, st, mid, a, b, val, ok);
  if (b > mid)
    query(2 * nod + 1, mid + 1, dr, a, b, val, ok);
}

int main()
{
  ios_base::sync_with_stdio(false);
  cin.tie(0); cout.tie(0);
  cin >> n;
  for (int i = 1; i <= n; i++) {
    cin >> a[i];
    poz[a[i]] = i;
  }
  build (1, 1, n);
  int total = 0;
  for (int i = 1; i <= n; i++) {
    ans = 0;
    if (i > 1)
    query(1, 1, n, 1, i - 1, a[i], 0);
    total += ans;
  }
  cout << total << " ";
  for (int i = 1; i <= n - 2; i++) {
    int x;
    cin >> x;
    ans = 0;
    if (poz[x] > 1)
    query(1, 1, n, 1, poz[x] - 1, x, 0);
    int y = ans;
    ans = 0;
    if (poz[x] < n)
    query(1, 1, n, poz[x] + 1, n, x, 1);
    y += ans;
    total -= y;
    update(1, 1, n, poz[x]);
    cout << total << " ";
  }
  return 0;
}
