#include <bits/stdc++.h>
#define ub(x) (x&(-x))

using namespace std;

constexpr int NMAX = 1e5 + 5;

int N;
int a[NMAX];
int cand[NMAX];
int cop[NMAX];
int infl[NMAX];

int aib[NMAX];

long long ans_total = 0;

void Update (int poz, int val) {
    for (int i = poz; i <= N; i += ub(i))
        aib[i] += val;
}

int Query (int poz) {
    int S = 0;

    for (int i = poz; i > 0; i -= ub(i))
        S += aib[i];

    return S;
}

void MergeSort (int st, int dr) {
    if (st >= dr) return;

    int mij = (st + dr) / 2;

    MergeSort(st, mij);
    MergeSort(mij+1, dr);

    int j = mij+1;
    int total = 0;
    for (int i = st; i <= mij; ++ i ) {
        while (j < dr + 1 && a[j] < a[i]) {
            Update(cand[a[j]], 1);
            ++ total;
            ++ j;
        }

        if (cand[a[i]] == N) continue;

        infl[cand[a[i]]] += (total - Query(cand[a[i]]-1));
    }
    for (int i = mij+1; i < j; ++ i )
        Update(cand[a[i]], -1);

    for (int i = st; i <= mij; ++ i )
        Update(cand[a[i]], 1);
    j = st;
    total = mij - st + 1;
    for (int i = mij+1; i <= dr; ++ i ) {
        while (j < mij+1 && a[j] < a[i]) {
            Update(cand[a[j]], -1);
            -- total;
            ++ j;
        }

        if (cand[a[i]] == N) continue;
        infl[cand[a[i]]] += (total - Query(cand[a[i]]-1));
    }
    for (int i = j; i <= mij; ++ i )
        Update(cand[a[i]], -1);

    int i = st;
    j = mij + 1;
    int vf = 0;
    while (i <= mij && j <= dr) {
        if (a[i] < a[j]) {
            ans_total += 1LL * ((j - 1) - (mij + 1) + 1);
            cop[++vf] = a[i];
            ++ i;
        }
        else if (a[i] > a[j]) {
            cop[++vf] = a[j];
            ++ j;
        }
    }
    while (i <= mij) {
        ans_total += 1LL*(dr - (mij+1) + 1);
        cop[++vf] = a[i];
        ++ i;
    }
    while (j <= dr) {
        cop[++vf] = a[j];
        ++ j;
    }

    for (int i = st; i <= dr; ++ i )
        a[i] = cop[i - st + 1];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i <= N; ++ i ) {
        cin >> a[i];
        cand[a[i]] = N;
    }

    for (int i = 1; i <= N-2; ++ i ) {
        int x;
        cin >> x;
        cand[x] = i;
    }

    MergeSort(1, N);

    cout << ans_total << " ";
    for (int i = 1; i <= N - 2; ++ i ) {
        ans_total -= 1LL*infl[i];

        cout << ans_total << " ";
    }
    return 0;
}
