#include "bits/stdc++.h"

#pragma GCC optimize("O3", "Ofast", "fast-math")
#pragma GCC target("sse", "sse2", "sse3", "sse4", "abm", "mmx", "avx", "avx2", "popcnt")
#define ios  ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define ll long long
#define sz(a) (int) a.size()
using namespace std;
int n;
int R = 1 << 3;
vector<int> ans;
vector<vector<int>> g(R * 2);
vector<int> pos;
vector<int> deleting;
vector<bool> used;
ll cur = 0;

ll rec1(int x, int xl, int xr, int ql, int qr, int position) {
    if (xr <= ql || xl >= qr)
        return 0;
    if (ql <= xl && xr <= qr) {
        int l = -1;
        int r = sz(g[x]);
        while (l + 1 < r) {
            int mid = (l + r) >> 1;
            if (g[x][mid] < position)
                l = mid;
            else
                r = mid;
        }
        return r;
    }
    int mid = (xl + xr) >> 1;
    return rec1(x * 2, xl, mid, ql, qr, position) + rec1(x * 2 + 1, mid, xr, ql, qr, position);
}

ll rec2(int x, int xl, int xr, int ql, int qr, int position) {
    if (xr <= ql || xl >= qr)
        return 0;
    if (ql <= xl && xr <= qr) {
        int l = -1;
        int r = sz(g[x]);
        while (l + 1 < r) {
            int mid = (l + r) >> 1;
            if (g[x][mid] < position)
                l = mid;
            else
                r = mid;
        }
        return sz(g[x]) - r;
    }
    int mid = (xl + xr) >> 1;
    return rec2(x * 2, xl, mid, ql, qr, position) + rec2(x * 2 + 1, mid, xr, ql, qr, position);
}

void sol(int x) {
    cur += rec1(1, 0, R, x + 1, n, pos[x]);
    cur += rec2(1, 0, R, 0, x, pos[x]);
    ans.push_back(cur);
    for (int i = R + x; i > 0; i /= 2) {
        vector<int> will;
        int j = 0;
        for (; j < sz(g[i]) && pos[x] > g[i][j]; ++j) {
            will.push_back(g[i][j]);
        }
        will.push_back(pos[x]);
        for (; j < sz(g[i]); ++j) {
            will.push_back(g[i][j]);
        }
        g[i] = will;
    }
}

int main() {
    cin >> n;
    pos.resize(n);
    used.resize(n);
    deleting.resize(n - 2);
    for (int i = 0; i < n; ++i) {
        int next;
        cin >> next;
        --next;
        pos[next] = i;
    }
    for (int i = 0; i < n - 2; ++i) {
        cin >> deleting[i];
        deleting[i]--;
        used[deleting[i]] = true;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i])
            deleting.push_back(i);
    }
    for (int i = n - 1; i >= 0; --i) {
        sol(deleting[i]);
    }
    for (int i = n-1; i >0; --i) {
        cout << ans[i] << " ";
    }
}
