#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct per {
    int t, l;

    bool operator<(per a) {
        return l < a.l;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    int k;
    cin >> k;
    vector<per> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].t >> a[i].l;
    if (n <= 10) {
        int mx = 0;
        for (int mask2 = 0; mask2 < (1 << n); ++mask2) {
            vector<int> now;
            int i = 0;
            int mask = mask2;
            while (mask > 0) {
                if (mask % 2 == 1)
                    now.push_back(i);
                ++i;
                mask /= 2;
            }
            vector<bool> used(n, false);
            int ans = 0;
            bool flag = true;
            for (i = 0; i < (int) now.size(); ++i) {

                if (used[now[i]] || used[a[now[i]].t]) {
                    flag = false;
                    break;
                }
                used[now[i]] = true;
                used[a[now[i]].t] = true;
                ans += a[now[i]].l;
            }
            if (!flag)
                continue;
            vector<int> all;
            for (i = 0; i < n; ++i)
                if (!used[i])
                    all.push_back(a[i].l);
            sort(all.rbegin(), all.rend());
            int cnt = 0;
            for (i = 0; i < all.size(); ++i) {
                if (cnt + i + 1 + k <= all.size()) {
                    ans += all[i];
                    cnt += k;
                } else
                    break;
            }
            mx = max(mx, ans);
        }
        cout << mx << endl;
        return 0;
    }
    sort(a.rbegin(), a.rend());
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int ans = 0;
            if (i + j * k * 2 + j <= n) {
                for (int p = 0; p < i + j; ++p)
                    ans += a[p].l;
                mx = max(mx, ans);
            }
        }
    }
    cout << mx;
}