#include<bits/stdc++.h>
using namespace std;


vector<bool> taken;
vector<bool> succeeded;
int N, K;
vector<int> target;
vector<int> L;
int freeBadges;


int dp(int participant) {
	if(participant == N) {
		int sum = 0;
		for(int i = 0; i < N; i++) {
			if(succeeded[i]) sum+=L[i];
		}
		return sum;
	}

	int result = 0;
	// participant fails
	result = max(result, dp(participant+1));

	succeeded[participant] = true;
	// participant succeeds by having his own + the target
	if(freeBadges >= 2 && !taken[participant] && !taken[target[participant]]) {
		taken[participant] = true;
		taken[target[participant]] = true;
		freeBadges-=2;
		result = max(result, dp(participant+1));
		freeBadges+=2;
		taken[participant] = false;
		taken[target[participant]]  = false;
	}

	// participant succeeds by having his own + K others
	if(freeBadges >= K + 1 && !taken[participant]) {
		taken[participant] = true;
		freeBadges-=(K+1);
		result = max(result, dp(participant+1));
		freeBadges+=(K+1);
		taken[participant] = false;
	}

	// participant succeeds by having the target + K others
	if(freeBadges >= K + 1 && !taken[target[participant]]) {
		taken[target[participant]] = true;
		freeBadges-=(K+1);
		result = max(result, dp(participant+1));
		freeBadges+=(K+1);
		taken[target[participant]] = false;
	}
	succeeded[participant] = false;

	return result;
}


int main() {
	cin >> N >> K;
	target.resize(N);
	succeeded.resize(N, false);
	taken.resize(N, false);
	L.resize(N);
	freeBadges = N;

	for(int i = 0; i < N; i++) {
		cin >> target[i] >> L[i];
	}

	cout << dp(0) << "\n";
}
