#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <cmath>

using namespace std;

typedef long long ll;

int main() {
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
    
    int n;
    cin >> n;
    vector <int> cards(n);
    vector <set<int>> a(n+1);
    for (int i=0; i<n; i++) {
        cin >> cards[i];
    }
    int ans=0;
    for (int i=0; i<n; i++) {
        for (int j=i+1; j<n; j++) {
            if (cards[i] > cards[j]) {
                a[cards[i]].insert(cards[j]);
                ans++;
            }
        }
    }
    cout << ans << " ";
    int x;
    while (cin >> x) {
        //cout << "a[x].size() = " << a[x].size() << endl;
        //cout << "x = " << x << endl;
        ans -= a[x].size();
        a[x].clear();
        for (int i=1; i<=n; i++) {
            if (a[i].find(x) != a[i].end()) {
                //cout << "i = " << i << endl;
                ans--;
                a[i].erase(x);
            }
        }
        cout << ans << " ";
    }
    return 0;
}