#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5;

int n;
int a[N];
oset<int> t1[N], t2[N];
int pos[N];
ll ans = 0;

void add_pref(int pos, int x) {
    while(pos < n) {
        t1[pos].insert(x);
        pos = pos | (pos + 1);
    }
}

void add_suff(int pos, int x) {
    while(pos < n) {
        t2[pos].insert(x);
        pos = pos | (pos + 1);
    }
}

void rem_pref(int pos, int x) {
    while(pos < n) {
        t1[pos].erase(x);
        pos = pos | (pos + 1);
    }
}

void rem_suff(int pos, int x) {
    while(pos < n) {
        t2[pos].erase(x);
        pos = pos | (pos + 1);
    }
}

int get_pref(int pos, int x) {
    int ans = 0;
    while(pos >= 0) {
        ans += sz(t1[pos]) - t1[pos].ook(x);
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int get_suff(int pos, int x) {
    int ans = 0;
    while(pos >= 0) {
        ans += t2[pos].ook(x + 1);
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;
    
    fr(i, 0, n - 1) cin >> a[i], a[i]--, pos[a[i]] = i;

    fr(i, 0, n - 1) {
        add_pref(i, a[i]);
    }
    rf(i, n - 1, 0) {
        add_suff(n - 1 - i, a[i]);
    }

    oset<int> st;
    fr(i, 0, n - 1) {
        ans += sz(st) - st.ook(a[i]);
        st.insert(a[i]);
    }

    cout << ans << " ";

    fr(i, 1, n - 2) {
        int x;
        cin >> x;
        x--;
        rem_pref(pos[x], x);
        rem_suff(n - 1 - pos[x], x);
        ans -= get_suff(n - 1 - (pos[x] + 1), x);
        ans -= get_pref(pos[x] - 1, x);
        cout << ans << " ";
    }
    cout << "\n";

    return 0;
}

/*
6
6 1 2 5 3 4
3 5 4 6
*/
