#include <bits/stdc++.h>
using namespace std;

int inversion_cnt(vector<int>& arr){
    if(arr.size() <= 1){
        return 0;
    }
    int m = arr.size() / 2;
    vector<int> left, right;
    for(int i = 0; i < m; i++){
        left.push_back(arr[i]);
    }
    for(int i = m; i < arr.size(); i++){
        right.push_back(arr[i]);
    }
    int ans = inversion_cnt(left) + inversion_cnt(right);
    int j = 0;
    for(int i = 0; i < left.size(); i++){
        while(j < right.size() && right[j] < left[i]){
            arr[i + j] = right[j];
            j++;
        }
        arr[i + j] = left[i];
        ans += j;
    }
    return ans;
}

signed main(){
    int n;
    cin >> n;
    vector<int> arr(n);
    for(auto& x : arr){
        cin >> x;
        x--;
    }
    vector<int> sorted_arr = arr;
    int ans = inversion_cnt(sorted_arr);
    cout << ans << ' ';
    vector<int> exist(n, true);
    vector<int> pos(n);
    for(int i = 0; i < n; i++){
        pos[arr[i]] = i;
    }
    for(int t = 0; t < n - 2; t++){
        int del;
        cin >> del;
        del--;
        int i = pos[del];
        exist[i] = false;
        for(int j = i - 1; j >= 0; j--){
            if(arr[i] < arr[j] && exist[j]){
                ans--;
            }
        }
        for(int j = i + 1; j < n; j++){
            if(arr[i] > arr[j] && exist[j]){
                ans--;
            }
        }
        cout << ans << ' ';
    }
}
