#include <bits/stdc++.h>
using namespace std;

int n, k;

void sort_by_T(vector<int>& T, vector<int>& L){
    vector<int> ans;
    for(int i = 0; i < n; i++){
        if(L[i] == 0){
            int j = T[i];
            while(j != i){
                ans.push_back(L[j]);
                j = T[j];
            }
            ans.push_back(0);
            reverse(ans.begin(), ans.end());
            L = ans;
            return;
        }
    }
}

signed main(){
    cin >> n >> k;
    vector<int> T(n), L(n);
    for(int i = 0; i < n; i++){
        cin >> T[i] >> L[i];
    }
    int ans = 0;
    sort_by_T(T, L);
    vector<vector<int>> dp(n, vector<int>(n + 1));
    for(int i = 0; i <= n; i++){
        dp[0][i] = 0;
    }
    for(int i = 1; i < n; i++){
        for(int j = 0; j <= n; j++){
            dp[i][j] = dp[i - 1][j];
            if(j){
                dp[i][j] = max(dp[i][j], dp[i][j - 1]);
            }
            if(i > 1 && j > 1){
                dp[i][j] = max(dp[i][j], dp[i - 2][j - 2] + L[i]);
            } else if(i == 1){
                dp[i][j] = max(dp[i][j], L[i]);
            }
            if(j >= k){
                dp[i][j] = max(dp[i][j], dp[i - 1][j - k] + L[i]);
            }
        }
    }
    cout << dp.back().back();
}
