#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100002;
const int MOD = 5000;

int n;

int a[N_MAX];

int posa[N_MAX];

short int BIT[N_MAX][MOD];

void update (int a, int b, int uval)
{
    for(int i = a; i <= n; i += i & -i)
        for(int j = b; j <= n; j += j & -j)
            BIT[i][j % MOD] += uval;
}

int query (int a, int b)
{
    int ans = 0;
    for(int i = a; i >= 1; i -= i & -i)
        for(int j = b; j >= 1; j -= j & -j)
            ans += BIT[i][j % MOD];
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    for(int i = 1; i <= n; i++)
        posa[a[i]] = i;
    for(int i = 1; i <= n; i++)
        update(i, a[i], +1);
    long long ans = 0;
    for(int i = 1; i <= n; i++)
        ans += query(i - 1, n) - query(i - 1, a[i]);
    cout << ans << " ";
    for(int q = 1; q <= n - 2; q++)
    {
        int val;
        cin >> val;
        int pos = posa[val];
        ans -= query(pos - 1, n) - query(pos - 1, a[pos]);
        ans -= query(n, a[pos] - 1) - query(pos, a[pos] - 1);
        update(pos, a[pos], -1);
        cout << ans << " ";
    }
    cout << "\n";
    return 0;
}
