#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100002;

const int BUFFER_SIZE = 10000;

char buffer[BUFFER_SIZE];
int bpos = BUFFER_SIZE - 1;

char read_char ()
{
    bpos++;
    if(bpos == BUFFER_SIZE)
    {
        fread(buffer, sizeof(char), BUFFER_SIZE, stdin);
        bpos = 0;
    }
    return buffer[bpos];
}

int read_int ()
{
    int ans = 0;
    char c;
    while(!isdigit(c = read_char()));
    while(isdigit(c))
    {
        ans = ans * 10 + c - '0';
        c = read_char();
    }
    return ans;
}

int n;

int a[N_MAX];

int posa[N_MAX];

unordered_map <int, int> BIT[N_MAX];

void update (int a, int b, int uval)
{
    for(int i = a; i <= n; i += i & -i)
        for(int j = b; j <= n; j += j & -j)
            BIT[i][j] += uval;
}

int query (int a, int b)
{
    int ans = 0;
    for(int i = a; i >= 1; i -= i & -i)
        for(int j = b; j >= 1; j -= j & -j)
            ans += BIT[i][j];
    return ans;
}

int BIT1A[N_MAX], BIT1B[N_MAX];

void update1 (int pos, int uval, int BIT1[])
{
    for(int i = pos; i <= n; i += i & -i)
        BIT1[i] += uval;
}

int query1 (int pos, int BIT1[])
{
    int ans = 0;
    for(int i = pos; i >= 1; i -= i & -i)
        ans += BIT1[i];
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    n = read_int();
    for(int i = 1; i <= n; i++)
        a[i] = read_int();
    for(int i = 1; i <= n; i++)
        posa[a[i]] = i;
    for(int i = 1; i <= n; i++)
    {
        update(i, a[i], +1);
        update1(i, +1, BIT1A);
        update1(a[i], +1, BIT1B);
    }
    int ans = 0;
    for(int i = 1; i <= n; i++)
        ans += query1(i - 1, BIT1A) - query(i - 1, a[i]);
    cout << ans << " ";
    for(int q = 1; q <= n - 2; q++)
    {
        int val;
        val = read_int();
        int pos = posa[val];
        ans -= query1(pos - 1, BIT1A) - query(pos - 1, a[pos]);
        ans -= query1(a[pos] - 1, BIT1B) - query(pos, a[pos] - 1);
        update(pos, a[pos], -1);
        update1(pos, -1, BIT1A);
        update1(a[pos], -1, BIT1B);
        cout << ans << " ";
    }
    cout << "\n";
    return 0;
}
