//
//  main.cpp
//  C
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
vector<int> t;
vector<int> vals;

void upd(int p, int l, int r, int ind) {
    if (r - l == 1) {
        t[p] = vals[l];
        return;
    }
    int m = (l + r) / 2;
    if (ind >= m) {
        upd(2 * p + 2, m, r, ind);
    }
    else {
        upd(2 * p + 1, l, m, ind);
    }
    t[p] = t[2 * p + 1] + t[2 * p + 2];
}

int get(int p, int l, int r, int ql, int qr) {
    if (r <= ql || l >= qr) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return t[p];
    }
    int m = (l + r) / 2;
    return get(2 * p + 1, l, m, ql, qr) + get(2 * p + 2, m, r, ql, qr);
}

int main() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        v[i]--;
    }
    int summ  = 0;
    t.resize(4 * n);
    vals.resize(n + 1);
    for (int i = 0; i < n; i++) {
        vals[v[i]]++;
        upd(0, 0, n, v[i]);
        summ += get(0, 0, n, v[i] + 1, n);
    }
    cout << summ << ' ';
    for (int i = 0; i < n - 2; i++) {
        int x;
        cin >> x;
        int pos = find(v.begin(), v.end(), x - 1) - v.begin();
        int cnt = 0;
        for (int j = 0; j < pos; j++) {
            if (v[j] != -1 && v[j] > x - 1) {
                cnt++;
            }
        }
        for (int j = pos + 1; j < n; j++) {
            if (v[j] != -1 && v[j] < x - 1) {
                cnt++;
            }
        }
        
        v[pos] = -1;
        summ -= cnt;
        cout << summ << ' ';
    }
}
