#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

long long ans = 0;

void rec(vector<vector<int>> a, int cnt, vector<int> good, vector<int> gr, int k) {
    if (cnt == gr.size()) {
        long long now_ans = 0;
        for (int i = 0; i < a.size(); ++i) {
            int count = 0;
            for (int j = 0; j < a[i].size(); ++j) {
                if (i == a[i][j] || a[i][j] == gr[i]) {
                    count += k;
                } else {
                    count += 1;
                }
            }
            if (count >= 2 * k) {
                now_ans += good[i];
            }
        }
        ans = max(ans, now_ans);
        return;
    }
    for (int i = 0; i < a.size(); ++i) {
        a[i].push_back(cnt);
        rec(a, cnt + 1, good, gr, k);
        a[i].pop_back();
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    vector<int> gr(n);
    vector<int> good(n);
    for (int i = 0; i < n; ++i) {
        cin >> gr[i] >> good[i];
    }
    rec(vector<vector<int>>(n), 0, good, gr, m);
    cout << ans;
}