//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <bits/extc++.h>
//OEQWWEXH
using namespace std;
//using namespace __gnu_pbds;
typedef int ll;
typedef vector<int> vll;

#define nd node*
#define pnd pair<nd, nd>

mt19937 rnd;

struct e {
    struct node {
        nd l = nullptr, *r = nullptr;
        ll x = 0;
        ll y = rnd();
        ll sz = 1;
        node() = default;
        explicit node(ll x) : x(x) {}
    };

    nd root = nullptr;

    static inline void resize(nd a) {
        a->sz = 1;
        if (a->l) {
            a->sz += a->l->sz;
        }
        if (a->r) {
            a->sz += a->r->sz;
        }
    }

    pnd split(nd rt, ll x) {
        if (!rt) {
            return {nullptr, nullptr};
        }
        if (rt->x < x) {
            rt->sz -= rt->r ? rt->r->sz : 0;
            pnd tmp = split(rt->r, x);
            rt->r = tmp.first;
            resize(rt);
            return {rt, tmp.second};
        } else {
            rt->sz -= rt->l ? rt->l->sz : 0;
            pnd tmp = split(rt->l, x);
            rt->l = tmp.second;
            resize(rt);
            return {tmp.first, rt};
        }
    }

    nd merge(nd l, nd r) {
        if (!r) {
            return l;
        }
        if (!l) {
            return r;
        }

        if (l->y < r->y) {
            r->sz -= r->l ? r->l->sz : 0;
            r->l = merge(l, r->l);
            if (r->l) {
                r->sz += r->l->sz;
            }
            return r;
        } else {
            l->sz -= l->r ? l->r->sz : 0;
            l->r = merge(l->r, r);
            if (l->r) {
                l->sz += l->r->sz;
            }
            return l;
        }
    }

    inline void erase(ll x) {
        pnd tmp = split(root, x);
        pnd tmp1 = split(tmp.second, x + 1);
        root = merge(tmp.first, tmp1.second);
    }

    nd insert(nd rt, nd x) {
        if (!rt || rt->y < x->y) {
            pnd tmp = split(rt, x->x);
            x->l = tmp.first;
            x->r = tmp.second;
            resize(x);
            return x;
        } else {
            if (rt->x < x->x) {
                rt->r = insert(rt->r, x);
                resize(rt);
                return rt;
            } else {
                rt->l = insert(rt->l, x);
                resize(rt);
                return rt;
            }
        }
    }

    inline void insert(ll x) {
        nd nw = new node(x);
        root = insert(root, nw);
    }

    inline ll order_of_key(ll x) const {
        nd nw = root;
        ll c = 0;
        while (nw) {
            if (nw->x < x) {
                c += (nw->l ? nw->l->sz : 0) + 1;
                nw = nw->r;
            } else {
                nw = nw->l;
            }
        }

        return c;
    }

    inline ll size() const {
        return root ? root->sz : 0;
    }
};

e t[400005];

ll n;

void build(ll l, ll r, ll v, vll &a) {
    for (ll i = l; i <= r; ++i) {
        t[v].insert(a[i]);
    }
    if (l != r) {
        ll mid = (l + r) >> 1;
        build(l, mid, v * 2, a);
        build(mid + 1, r, v * 2 + 1, a);
    }
}

inline void build(vll &a) {
    build(0, n - 1, 1, a);
}

void modify(ll l, ll r, ll v, ll x, ll i) {
    t[v].erase(x);
    if (l != r) {
        ll mid = (l + r) >> 1;
        if (i <= mid) {
            modify(l, mid, v * 2, x, i);
        } else {
            modify(mid + 1, r, v * 2 + 1, x, i);
        }
    }
}

inline void modify(ll x, ll i) {
    modify(0, n - 1, 1, x, i);
}

ll get(ll kl, ll kr, ll l, ll r, ll v, ll x) {
    if (kl <= l && r <= kr) {
        return t[v].order_of_key(x);
    }
    if (r < kl || kr < l) {
        return 0;
    }
    ll mid = (l + r) >> 1;
    return get(kl, kr, l, mid, v * 2, x) + get(kl, kr, mid + 1, r, v * 2 + 1, x);
}

inline ll get(ll l, ll r, ll x) {
    return get(l, r, 0, n - 1, 1, x);
}

ll get1(ll kl, ll kr, ll l, ll r, ll v, ll x) {
    if (kl <= l && r <= kr) {
        ll p = t[v].size() - t[v].order_of_key(x);
        return p;
    }
    if (r < kl || kr < l) {
        return 0;
    }
    ll mid = (l + r) >> 1;
    return get1(kl, kr, l, mid, v * 2, x) + get1(kl, kr, mid + 1, r, v * 2 + 1, x);
}

inline ll get1(ll l, ll r, ll x) {
    return get1(l, r, 0, n - 1, 1, x);
}


map<ll, ll> r;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
//    n = 100000;
    vll a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
//        a[i] = n - i;
        r[a[i]] = i;
    }

    ll m = n - 2;
    long long ans = 0;
    build(a);
    for (ll i = 0; i < n; ++i) {
        ans += get(i, n - 1, a[i]);
    }
    cout << ans << ' ';
    ll o = 1;
    while (m--) {
        ll x = o;
        cin >> x;
        ans -= get1(0, r[x], x) - 1;
        cout << (ans -= get(r[x], n - 1, x)) << ' ';
        modify(x, r[x]);
        ++o;
    }
    cout << endl;
    cout << (float) clock() / CLOCKS_PER_SEC << endl;
}


