#include <bits/stdc++.h>

using namespace std;

void SetIO() {
    #ifdef BLAT
        freopen("input.in", "r", stdin);
        freopen("output.out", "w", stdout);
    #endif // BLAT
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
}

const int N = 1e4;

struct ura {
    int i, t, l;

    bool operator < (const ura &aux) const {
        return l > aux.l;
    }
};
ura v[5 + N];
bool taken[5 + N];

int main() {
    SetIO();
    int n, k, ans(0);
    cin >> n >> k;

    for(int i = 1; i <= n; i++) {
        cin >> v[i].t >> v[i].l;
        v[i].i = i;
    }

    sort(v + 1, v + n + 1);

    int j(n);
    for(int i = 1; i <= n; i++) {
        int score = 0;
        if(!taken[v[i].i]) {
            taken[v[i].i] = true;
            score += k;
        }

        if(!taken[v[i].t]) {
            taken[v[i].t] = true;
            score += k;
        }

        if(score == 2 * k) {
            ans += v[i].l;
        } else {
            int cj = j;
            while(i < j && score < 2 * k) {
                taken[v[j].i] = true;
                score++;
                j--;
            }

            if(score == 2 * k)
                ans += v[i].l;
            else j = cj;
        }
    }

    cout << ans << '\n';
    return 0;
}
