//#pragma GCC optimization("Ofast,unroint-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int,int> pii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> OST;

const int NMAX = 100001;
const int MOD = 1000000007;
const int BLOCK = 320;

int n;

class AIB {
    int aib[NMAX];
    int sz = 0;
public:
    void update(int x, int val) {
        for(int i = x; i <= n; i += i&(-i))
            aib[i] += val;
        if(val == 1)
            sz++;
        else
            sz--;
    }
    int query(int x) {
        int sum = 0;
        for(int i = x; i > 0; i -= i&(-i))
            sum += aib[i];
        return sum;
    }
    int smainter(int x) {
        return query(x - 1);
    }
    int bigger(int x) {
        return sz - query(x);
    }
} aib[BLOCK + 10], mare;

int poz[NMAX];
int v[NMAX];

int main() {
    //ifstream cin(".in");
    //ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll inv = 0, i;
    cin >> n;
    for(i = 1; i <= n; i++) {
        int x;
        cin >> x;
        aib[i / BLOCK].update(x, 1);
        v[i] = x;
        inv += 1LL * mare.bigger(x);
        mare.update(x, 1);
        poz[x] = i;
    }
    ///sa nu uit sa fac v[i] si aib.update la stergere
    cout << inv << " ";
   for(i = 1; i <= n - 2; i++) {
        int a;
        cin >> a;
        int x = poz[a] - 1;
        while(x > 0 && x % BLOCK != 0) {
            if(a < v[x] && v[x] != -1)
                inv--;
            x--;
        }
        if(x != 0) {
            if(a < v[x] && v[x] != -1)
                inv--;
            x--;
        }
        while(x > 0) {
            inv -= 1LL * aib[x / BLOCK].bigger(a);
            x -= BLOCK;
        }
        int y = poz[a] + 1;
        while(y <= n && y % BLOCK != 0) {
            if(a > v[y] && v[y] != -1)
                inv--;
            y++;
        }
        if(y <= n) {
            if(a > v[y] && v[y] != -1)
                inv--;
            y++;
        }
        while(y <= n) {
            inv -= 1LL * aib[y / BLOCK].smainter(a);
            y += BLOCK;
        }
        aib[poz[a] / BLOCK].update(a, -1);
        v[poz[a]] = -1;
        cout << inv << " ";
    }
    return 0;
}
