//#pragma GCC optimization("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <ll,ll> pii;
typedef tree <ll, null_type, less <ll>, rb_tree_tag, tree_order_statistics_node_update> OST;

const ll NMAX = 100001;
const ll MOD = 1000000007;
const ll BLOCK = 220;

ll n;

class AIB {
    int aib[NMAX];
    ll sz = 0;
public:
    void update(ll x, ll val) {
        for(ll i = x; i <= n; i += i&(-i))
            aib[i] += val;
        if(val == 1)
            sz++;
        else
            sz--;
    }
    ll query(ll x) {
        ll sum = 0;
        for(ll i = x; i > 0; i -= i&(-i))
            sum += 1LL * aib[i];
        return sum;
    }
    ll smaller(ll x) {
        return query(x - 1);
    }
    ll bigger(ll x) {
        return sz - query(x);
    }
} aib[NMAX / BLOCK + 5], mare;

ll poz[NMAX];
ll v[NMAX];

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll inv = 0, i;
    cin >> n;
    for(i = 1; i <= n; i++) {
        ll x;
        cin >> x;
        aib[i / BLOCK].update(x, 1);
        v[i] = x;
        inv += mare.bigger(x);
        mare.update(x, 1);
        poz[x] = i;
    }
    ///sa nu uit sa fac v[i] si aib.update la stergere
    cout << inv << " ";
   for(i = 1; i <= n - 2; i++) {
        ll a;
        cin >> a;
        ll x = poz[a] - 1;
        while(x > 0 && x % BLOCK != 0) {
            if(a < v[x] && v[x] != -1)
                inv--;
            x--;
        }
        if(x != 0) {
            if(a < v[x] && v[x] != -1)
                inv--;
            x--;
        }
        while(x > 0) {
            inv -= aib[x / BLOCK].bigger(a);
            x -= BLOCK;
        }
        ll y = poz[a] + 1;
        while(y <= n && y % BLOCK != 0) {
            if(a > v[y] && v[y] != -1)
                inv--;
            y++;
        }
        while(y <= n) {
            inv -= aib[y / BLOCK].smaller(a);
            y += BLOCK;
        }
        aib[poz[a] / BLOCK].update(a, -1);
        v[poz[a]] = -1;
        cout << inv << " ";
    }
    return 0;
}