#pragma GCC optimization("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <ll,ll> pii;
typedef tree <pii, null_type, less <pii >, rb_tree_tag, tree_order_statistics_node_update> OST;

const ll NMAX = 100001;
const ll MOD = 1000000007;
const ll BLOCK = 400;

ll n;

class AIB {
    OST aib[NMAX];
    public:
    ll sz = 0;
    void update(pii x, ll val) {
        for(int i = x.first; i <= n; i += i&(-i))
        {
            if(val == 1){
                aib[i].insert({x.second, x.first});
            }else{
                aib[i].erase({x.second, x.first});
            }
        }
        if(val == 1)
            sz++;
        else
            sz--;
    }
    ll query(pii x) {
        ll sum = 0;
        for(int i = x.first; i > 0; i -= i&(-i))
        {
           sum += aib[i].order_of_key({x.second + 1, 0});
        }
        return sum;
    }
} mare;
///de testat aibul

ll inv;
ll poz[NMAX];
ll v[NMAX];
ll sol[NMAX];
ll pz[NMAX];
ll q[NMAX];
ll oke[NMAX];

void adauga(pii x){
    inv += mare.query(x);
    inv += (mare.query({n, n}) - mare.query({x.first, n}) - mare.query({n, x.second}) + mare.query({x.first, x.second}));
    mare.update(x, 1);
}

int main() {
    ifstream cin(".in");
    ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    int i;
    for(i = 1; i <= n; i++){
        cin >> v[i];
        poz[v[i]] = i;
    }
    for(i = 1; i <= n - 2; i++){
       cin >> q[i];
       oke[q[i]] = 1;
       pz[q[i]] = i;
    }
    for(i  =1 ; i<= n; i++){
        if(!oke[i])
        adauga({n - i + 1, poz[i]});
    }
    for(i = n - 2; i >= 1; i--){
        sol[i] = inv;
        adauga({n - q[i] + 1, poz[q[i]]});
    }
    sol[0] = inv;
    for( i= 0; i <= n - 2; i++){
        cout << sol[i] << " ";
    }
    return 0;
}
