#include <bits/stdc++.h>
using namespace std;

const int INF = 0x3f3f3f3f;

int n, k;

void subtask1() {
  vector<int> t(n), l(n);
  for (int i = 0; i < n; i++) {
    cin >> t[i] >> l[i];
  }
  vector< vector<int> > dp(n + 1, vector<int>(1 << n, -INF)), from = dp;
  dp[0][0] = 0;
  for (int i = 0; i < n; i++) {
    for (int mask = 0; mask < (1 << n); mask++) {
      if (dp[i][mask] == -INF) continue;
      vector<int> tmp;
      for (int j = 0; j < n; j++) if (!(mask & (1 << j))) tmp.push_back(j);
      int sz = (int) tmp.size();
      for (int mask2 = 0; mask2 < (1 << sz); mask2++) {
        int points = 0, mask3 = 0;
        for (int j = 0; j < sz; j++) {
          if (mask2 & (1 << j)) {
            mask3 |= (1 << tmp[j]);
            points += (tmp[j] == i || tmp[j] == t[i]) ? k : 1;
          }
        }
        if (dp[i + 1][mask3 | mask] < dp[i][mask] + (points >= 2 * k ? l[i] : 0)) {
          dp[i + 1][mask3 | mask] = dp[i][mask] + (points >= 2 * k ? l[i] : 0);
          from[i + 1][mask3 | mask] = mask3;
        }
      }
    }
  }
  /*for (int i = n, mask = (1 << n) - 1; i >= 1; i--) {
    cerr << dp[i][mask] << ", " << i << ": ";
    for (int j = 0; j < n; j++) {
      if (from[i][mask] & (1 << j)) {
        cerr << j << ' ';
      }
    }
    cerr << '\n';
    mask ^= from[i][mask];
  }*/
  cout << dp[n][(1 << n) - 1] << '\n';
}

void subtask23() {
  vector<int> t(n), l(n);
  for (int i = 0; i < n; i++) cin >> t[i] >> l[i];
  int cur = t[0];
  vector<int> a = {l[0]};
  while (cur != 0) {
    a.push_back(l[cur]);
    cur = t[cur];
  }
  vector<int> dp(n, 0);
  for (int i = 0; i < n; i++) {
    if (i > 0) dp[i] = dp[i - 1];
    if (i > 1) dp[i] = max(dp[i], dp[i - 2] + max(a[i], a[i - 1]));
  }
  int ans = dp[n - 1];
  dp.assign(n, 0);
  a.push_back(a[0]);
  a.erase(a.begin());
  for (int i = 0; i < n; i++) {
    if (i > 0) dp[i] = dp[i - 1];
    if (i > 1) dp[i] = max(dp[i], dp[i - 2] + max(a[i], a[i - 1]));
  }
  cout << max(ans, dp[n - 1]) << '\n';
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);  
  cin >> n >> k;
  if (n <= 10) {
    subtask1();
  } else {
    subtask23();
  }
  return 0;
}