#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

const int N = 1e5 + 10;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> top_set;

top_set t[4 * N];

void update(int v, int l, int r, int pos, int val){
    t[v].insert(val);
    if (l == r){
        return;
    }
    int m = (l + r) / 2;
    if (pos <= m){
        update(2 * v, l, m, pos, val);
    }
    else{
        update(2 * v + 1, m + 1, r, pos, val);
    }
}

int get(int v, int tl, int tr, int l, int r, int val, int need){
    if (l > r) return 0;
    if (tl == l && tr == r){
        if (need == 1){
            return t[v].size() - t[v].order_of_key(val);
        }
        else{
            return t[v].order_of_key(val);
        }
    }
    int tm = (tl + tr) / 2;
    return get(2 * v, tl, tm, l, min(r, tm), val, need) + get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val, need);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, ans = 0;
    cin >> n;
    vector<int> v(n);
    vector<int> ind(n + 1);
    vector<bool> used(n + 1);
    for (int i = 0; i < n; i++){
        cin >> v[i];
        ind[v[i]] = i;
    }
    vector<int> u, mem;
    for (int i = 0; i < n - 2; i++){
        int a;
        cin >> a;
        used[a] = 1;
        u.push_back(a);
    }
    reverse(u.begin(), u.end());
    int last = -1e9;
    for (int i = 0; i < n; i++){
        if (!used[v[i]]){
            ans += (last > v[i]);
            last = v[i];
            update(1, 0, n - 1, ind[v[i]], v[i]);
        }
    }
    mem.push_back(ans);
    for (auto to : u){
        ans += get(1, 0, n - 1, 0, ind[to] - 1, to, 1);
        ans += get(1, 0, n - 1, ind[to] + 1, n - 1, to, -1);
        update(1, 0, n - 1, ind[to], to);
        mem.push_back(ans);
    }
    reverse(mem.begin(), mem.end());
    for (auto to : mem){
        cout << to << " ";
    }
    return 0;
}
