#include <iostream>
#include <vector>
#include <stack>

using namespace std;

int answer = 0;
vector<int> a, dp;

void count() {
	stack<int> st;
	st.push(1e9);
	st.push(a.size() - 1);
	for (int i = a.size() - 2; i >= 0; i--)
	{
		int t = st.top(), cnt = 0;
		while (t != 1e9 && a[i] > a[t]) {
			cnt += dp[t] + 1;
			st.pop();
			t = st.top();
		}
		st.push(i);
		dp[i] = cnt;
		answer += cnt;
	}
}

int main() {
	int n;
	cin >> n;
	a.resize(n);
	dp.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}
	vector<int> ans;
	count();
	ans.push_back(answer);
	for (int i = 0; i < n - 2; i++)
	{
		int num;
		cin >> num;
		for (auto c = a.begin(), b = dp.begin(); c != a.end(); ++c, ++b) {
			if (*c > num) {
				(*b)--;
				answer--;
			}
			if (*c == num) {
				answer -= *b;
				a.erase(c);
				dp.erase(b);
				break;
			}
		}
		ans.push_back(answer);
	}
	for (auto an : ans) {
		cout << an << " ";
	}
	return 0;
}