#include <bits/stdc++.h>
#define F first
#define S second
using namespace std;
typedef vector<pair<int,int> > vii;
//ifstream fi("disorder.in");
//ofstream fo("disorder.out");

const int MAXN = 100000;
int n,X[MAXN+5],ORD[MAXN+5],XNOU[MAXN+5],R[MAXN+5],rad,ST[MAXN+5],DR[MAXN+5],numar_grupa,nn,inversiuni;
/// X - sirul de carti actual               | se poate modifica
/// ORD[i] - pozitia numarului i in sir
///XNOU - folosit pentru refacerea sirului fara rad elemente
/// R - ordinea scoateri cartilor           | nu se modifica
/// ST- inversiuni care se termina cu elementul curent
/// DR- inversiuni care incep cu elementul curent
vii ES[10005];/// elementele deja scoase

int BIT[MAXN+5];

int valoare(int poz)
{
    ///will return value in BIT from 0 to poz-1
    int rez = 0;
    while(poz){
        rez+=BIT[poz];
        poz -= (poz&(-poz));
    }
    return rez;
}

void update(int poz,int ad)
{
    ///will update poz-1 by adding ad in log(n) time
    while(poz <= nn){
        BIT[poz]+=ad;
        poz += (poz&(-poz));
    }
}

void setup()
{
    ///will set up ST and DR using BIT in nn*log(nn) time
    int n_nou = 0;
    for(int i=1;i<=nn;i++){
        if(X[i] != -1)
            XNOU[++n_nou]=X[i];
        X[i]=0;
    }
    for(int i=1;i<=n;i++)
        ORD[i]=ST[i]=DR[i]=0;/// n^3/2 inca intra in timp cu chiu cu val
    nn = n_nou;
    for(int i=1;i<=nn;i++){
        X[i]=XNOU[i];
        ORD[X[i]]=i;
    }
    int o  = 0;
    for(int i=1;i<=n;i++)
        BIT[i]=0;
    for(int i = 1; i <= n; i++)///dr
        if(ORD[i]){
            o = ORD[i];
            DR[o] = valoare(n) - valoare(o);
            update(o,1);
        }
    for(int i=1;i<=n;i++)
        BIT[i]=0;
    inversiuni=0;
    for(int i = n; i >= 1; i--)///st
        if(ORD[i]){
            o = ORD[i];
            ST[o] = valoare(o);
            inversiuni+=ST[o];
            update(o,1);
        }
    return;
}

void afis()
{
    cout << "ST - ";
    for(int i = 1; i <= nn; i++)
        cout << ST[i] << " ";
    cout << "\nDR - ";
    for(int i = 1; i <= nn; i++)
        cout << DR[i] << " ";
}

int main()
{
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> X[i];
    for(int i = 1; i <= n-2; i++)
        cin >> R[i];
    nn=n;
    rad = (int)(sqrt((double)(n))+.00001d);
    setup();
    cout << inversiuni << " ";
    for(int i = 1; i <= rad+1; i++){
        ///procesam grupa i
        numar_grupa = i;
        for(int j = 1+(i-1)*rad; j <= min(n-2,i*rad); j++){
            int el = R[j];
            int o = ORD[el];
            ///il scoatem pe j si scadem ST+DR
            inversiuni -= ST[o] + DR [o];
            /// adaugam cele deja scoase din lista
            for(auto it : ES[numar_grupa])
                if( (it.F > el && it.S < o) || (it.F < el && it.S > o) )
                    inversiuni++;
            cout << inversiuni << " ";
            ///il adaugam si pe el
            ES[numar_grupa].push_back(make_pair(el,o));
            ///punem valoarea -1 in locul lui
            X[o]=-1;
        }
        setup();
    }
    return 0;
}
