#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void upd(int*& f, int x, int d, int n) {
    while (x <= n) {
        f[x] += d;
        x = x | (x + 1);
    }
}

int psum(int*& f, int x) {
    int sum = 0;
    while (x > 0) {
        sum += f[x];
        x = (x & (x + 1)) - 1;
    }
    return sum;
}

int req(int*& f, int L, int R) {
    return psum(f, R) - psum(f, L - 1);
}

const int maxn = 100'031;

int n;
int p [maxn];
int del [maxn];

void input() {
    cin.tie(0)->sync_with_stdio(0);
    cout.tie(0)->sync_with_stdio(0);
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> p[i];
    for (int i = 0; i < n - 2; ++i) cin >> del[i];
}

const int k = 3162;
int where [maxn];
int add [maxn];
int ans [maxn];
int curr [maxn];
int* b [(maxn + k - 1) / k];

void solve() {
    int bc = (n + k - 1) / k;
    
    set<int> all; for (int i = 1; i <= n; ++i) all.insert(i);
    for (int i = 0; i < n; ++i) where[p[i]] = i;
    for (int i = 0; i < n - 2; ++i) all.erase(del[i]);
    int l1 = *(all.begin()), l2 = *(all.rbegin());
    add[0] = l1; add[1] = l2;
    for (int i = 2; i < n; ++i) {
        add[i] = del[n - 1 - i];
    }
    
    fill(ans, ans + n + 1, 0); int sum = 0;
    fill(curr, curr + n, 0);
    for (int i = 0; i < bc; ++i) {
        b[i] = new int [n + 1];
        fill(b[i], b[i] + n + 1, 0);
    }
    for (int j = 0; j < n; ++j) {
        int x = add[j];
        if (x == 4) {
            // flex
        }
        int bi = where[x] / k;
        for (int i = 0; i < bi; ++i) {
            sum += req(b[i], x + 1, n + 1);
        }
        for (int i = bi * k; i < where[x]; ++i) {
            sum += (curr[i] != 0 && curr[i] > x);
        }
        for (int i = where[x] + 1; i < (bi + 1) * k && i < n; ++i) {
            sum += (curr[i] != 0 && x > curr[i]);
        }
        for (int i = bi + 1; i < bc; ++i) {
            sum += req(b[i], 1, x - 1);
        }
        curr[where[x]] = x;
        upd(b[bi], x, 1, n + 1);
        ans[j + 1] = sum;
    }
    for (int i = 0; i < n - 1; ++i) {
        cout << ans[n - i] << ' ';
    }
    cout << '\n';
}

signed main() {
    input();
    solve();
}
