#include <bits/stdc++.h>
#define F first
#define S second
#define ull size_t
#define inf INT_MAX
#define ll long long
#define pb push_back
#define elif else if
#define iofast ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

/*
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
*/

using namespace std;

ll power(ll a, ll b);
ll get_up_sum(ll curr, vector < vector < ll > > &tree);
void back_add(ll pos, ll num, vector < vector < ll > > &tree);
void back_umin(ll pos, ll num, vector < vector < ll > > &tree);
void back_umax(ll pos, ll num, vector < vector < ll > > &tree);
void add(ll pos, ll num, vector < vector < ll > > &tree, ll n);
void update_max(ll pos, ll num, vector < vector < ll > > &tree, ll n);
void update_min(ll pos, ll num, vector < vector < ll > > &tree, ll n);
ll get_sum(ll range_begin, ll range_end, vector < vector < ll > > &tree, ll curr);
void down_add(ll mod, ll range_begin, ll range_end, vector < vector < ll > > &tree, ll curr);
void modify(ll value, ll range_begin, ll range_end, ll max_value, vector < vector < ll > > &tree,
    vector < vector < ll > > &min_tree, vector < vector < ll > > &max_tree, vector < vector < ll > > &sum_tree, ll curr, ll &s);


//===============================================================================
int main(){
    iofast;
    ll n, buf, a, b, real_n, s = 0, id = 0;
    cin >> n;
    vector < ll > arr(n);
    vector < ll > times_used(n);
    vector < ll > pos(n + 1);
    real_n = power(2, ceil(log2(n)));
    vector < vector < ll > > mod_tree(real_n * 2, vector < ll > (5, 0));

    for(ll i = real_n; i < real_n * 2; i++){
        mod_tree[i] = {0, i - real_n, i - real_n, -1, -1}; // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(ll i = real_n * 2 - 1; i > 1; i -= 2){
        mod_tree[i / 2] = {0,
                                mod_tree[i - 1][1], mod_tree[i][2], i - 1, i};
    }

    for(auto &i: arr){
        cin >> i;
    }
    reverse(arr.begin(), arr.end());

    for(auto &i: arr){
        pos[i] = id;
        id++;
        down_add(1, 0, i - 1, mod_tree, 1);
        times_used[i - 1] -= get_up_sum(real_n + i - 1, mod_tree);
    }

    for(ll i = 0; i < n; i++){
        times_used[i] += get_up_sum(real_n + i, mod_tree);
        s += times_used[i];
    }

    for(ll i = real_n; i < real_n * 2; i++){
        mod_tree[i] = {0, i - real_n, i - real_n, -1, -1}; // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(ll i = real_n * 2 - 1; i > 1; i -= 2){
        mod_tree[i / 2] = {mod_tree[i][0] + mod_tree[i - 1][0],
                                mod_tree[i - 1][1], mod_tree[i][2], i - 1, i};
    }
    vector < vector < ll > > min_tree(real_n * 2, vector < ll > (5, 0));
    for(ll i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = arr[i - real_n];
        }else{
            buf = 0;
        }
        min_tree[i] = {buf, i - real_n, i - real_n, -1, -1}; // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(ll i = real_n * 2 - 1; i > 1; i -= 2){
        min_tree[i / 2] = {min(min_tree[i - 1][0], min_tree[i][0]),
                                min_tree[i - 1][1], min_tree[i][2], i - 1, i};
    }
    vector < vector < ll > > max_tree(real_n * 2, vector < ll > (5, 0));
    for(ll i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = arr[i - real_n];
        }else{
            buf = 0;
        }
        max_tree[i] = {buf, i - real_n, i - real_n, -1, -1}; // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(ll i = real_n * 2 - 1; i > 1; i -= 2){
        max_tree[i / 2] = {max(max_tree[i - 1][0], max_tree[i][0]),
                                max_tree[i - 1][1], max_tree[i][2], i - 1, i};
    }
    vector < vector < ll > > sum_tree(real_n * 2, vector < ll > (5, 0));
    for(ll i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = 1;
        }else{
            buf = 0;
        }
        sum_tree[i] = {buf, i - real_n, i - real_n, -1, -1}; // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(ll i = real_n * 2 - 1; i > 1; i -= 2){
        sum_tree[i / 2] = {sum_tree[i - 1][0] + sum_tree[i][0],
                                sum_tree[i - 1][1], sum_tree[i][2], i - 1, i};
    }

//===============================================================================
//                             end of initialization
//===============================================================================

    cout << s << ' ';
    for(ll t = 0; t < n - 2; t++){
        cin >> buf;
        add(pos[buf], -1, sum_tree, real_n);
        s -= times_used[buf - 1] - get_up_sum(pos[buf] + real_n, mod_tree);
        modify(1, 0, pos[buf], buf, mod_tree, min_tree, max_tree, sum_tree, 1, s);
        update_max(pos[buf], 0, max_tree, real_n);
        update_min(pos[buf], 0, max_tree, real_n);
        if (t != n - 1){
            cout << s << ' ';
        }else{
            cout << s << endl;
        }
    }


    return 0;
}
//===============================================================================


void modify(ll value, ll range_begin, ll range_end, ll max_value, vector < vector < ll > > &tree,
    vector < vector < ll > > &min_tree, vector < vector < ll > > &max_tree, vector < vector < ll > > &sum_tree, ll curr, ll &s){
    if (range_begin == tree[curr][1] and range_end == tree[curr][2] and max_tree[curr][0] <= max_value){
        tree[curr][0] += value;
        s -= sum_tree[curr][0] * value;
        return;
    }
    if (range_begin <= tree[tree[curr][3]][2] and min_tree[tree[curr][3]][0] <= max_value){
        modify(value, range_begin, min(tree[tree[curr][3]][2], range_end), max_value, tree, min_tree, max_tree, sum_tree, tree[curr][3], s);
    }
    if (range_end >= tree[tree[curr][4]][1] and min_tree[tree[curr][4]][0] <= max_value){
        modify(value, max(tree[tree[curr][4]][1], range_begin), range_end, max_value, tree, min_tree, max_tree, sum_tree, tree[curr][4], s);
    }
}


ll power(ll a, ll b){
    ll ans = 1;
    for(ll i = 0; i < b; i++){
        ans *= a;
    }
    return ans;
}


ll get_sum(ll range_begin, ll range_end, vector < vector < ll > > &tree, ll curr){
    ll ans = 0;
    if (range_begin == tree[curr][1] and range_end == tree[curr][2]){
        return tree[curr][0];
    }
    if (range_begin <= tree[tree[curr][3]][2]){
        ans += get_sum(range_begin, min(tree[tree[curr][3]][2], range_end), tree, tree[curr][3]);
    }
    if (range_end >= tree[tree[curr][4]][1]){
        ans += get_sum(max(tree[tree[curr][4]][1], range_begin), range_end, tree, tree[curr][4]);
    }
    return ans;
}


ll get_up_sum(ll curr, vector < vector < ll > > &tree){
    ll ans = tree[curr][0];
    if (curr > 1){
        ans += get_up_sum(curr / 2, tree);
    }
    return ans;
}


void update_min(ll pos, ll num, vector < vector < ll > > &tree, ll n){
    pos += n;
    tree[pos][0] = num;
    if (pos != 1){
        back_umin(pos / 2, num, tree);
    }
}

void back_umin(ll pos, ll num, vector < vector < ll > > &tree){
    tree[pos][0] = min(tree[tree[pos][3]][0], tree[tree[pos][4]][0]);
    if (pos != 1){
        back_umin(pos / 2, num, tree);
    }
}


void update_max(ll pos, ll num, vector < vector < ll > > &tree, ll n){
    pos += n;
    tree[pos][0] += num;
    if (pos != 1){
        back_umax(pos / 2, num, tree);
    }
}


void back_umax(ll pos, ll num, vector < vector < ll > > &tree){
    tree[pos][0] = max(tree[tree[pos][3]][0], tree[tree[pos][4]][0]);
    if (pos != 1 and num == tree[pos][0]){
        back_umax(pos / 2, num, tree);
    }
}


void down_add(ll mod, ll range_begin, ll range_end, vector < vector < ll > > &tree, ll curr){

    if (range_begin == tree[curr][1] and range_end == tree[curr][2]){
        tree[curr][0] += mod;
        return;
    }
    if (range_begin <= tree[tree[curr][3]][2]){
        down_add(mod, range_begin, min(tree[tree[curr][3]][2], range_end), tree, tree[curr][3]);
    }
    if (range_end >= tree[tree[curr][4]][1]){
        down_add(mod, max(tree[tree[curr][4]][1], range_begin), range_end, tree, tree[curr][4]);
    }
}


void add(ll pos, ll num, vector < vector < ll > > &tree, ll n){
    pos += n;
    tree[pos][0] += num;
    if (pos != 1){
        back_add(pos / 2, num, tree);
    }
}


void back_add(ll pos, ll num, vector < vector < ll > > &tree){
    tree[pos][0] += num;
    if (pos != 1){
        back_add(pos / 2, num, tree);
    }
}
