#include <bits/stdc++.h>
#define F first
#define S second
#define ull size_t
#define inf INT_MAX
#define ll long long
#define pb push_back
#define elif else if
#define iofast ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#define MAXN 15000


#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")


using namespace std;

int mod_tree[MAXN][5];
int min_tree[MAXN][5];
int max_tree[MAXN][5];
int sum_tree[MAXN][5];

int power(int a, int b);
int get_up_sum(int curr);
void back_add(int pos, int num);
void back_umin(int pos, int num);
void back_umax(int pos, int num);
void add(int pos, int num, int n);
void update_max(int pos, int num, int n);
void update_min(int pos, int num, int n);
int get_sum(int range_begin, int range_end, int curr);
void down_add(int mod, int range_begin, int range_end, int curr);
void modify(int value, int range_begin, int range_end, int max_value, int curr, int &s);


//===============================================================================
int main(){
    iofast;
    int n, buf, a, b, real_n, s = 0, id = 0;
    cin >> n;
    vector < int > arr(n);
    vector < int > times_used(n);
    vector < int > pos(n + 1);
    real_n = power(2, ceil(log2(n)));


    for(int i = real_n; i < real_n * 2; i++){
        mod_tree[i][0] = 0;
        mod_tree[i][1] = i - real_n;
        mod_tree[i][2] = i - real_n;
        mod_tree[i][3] = -1;
        mod_tree[i][4] = -1;
         // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        mod_tree[i / 2][0] = 0;
        mod_tree[i / 2][1] = mod_tree[i - 1][1];
        mod_tree[i / 2][2] = mod_tree[i][2];
        mod_tree[i / 2][3] = i - 1;
        mod_tree[i / 2][4] = i;
    }

    for(auto &i: arr){
        cin >> i;
    }
    reverse(arr.begin(), arr.end());

    for(auto &i: arr){
        pos[i] = id;
        id++;
        down_add(1, 0, i - 1, 1);
        times_used[i - 1] -= get_up_sum(real_n + i - 1);
    }

    for(int i = 0; i < n; i++){
        times_used[i] += get_up_sum(real_n + i);
        s += times_used[i];
    }

    for(int i = real_n; i < real_n * 2; i++){
        mod_tree[i][0] = 0;
        mod_tree[i][1] = i - real_n;
        mod_tree[i][2] = i - real_n;
        mod_tree[i][3] = -1;
        mod_tree[i][4] = -1;
         // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        mod_tree[i / 2][0] = 0;
        mod_tree[i / 2][1] = mod_tree[i - 1][1];
        mod_tree[i / 2][2] = mod_tree[i][2];
        mod_tree[i / 2][3] = i - 1;
        mod_tree[i / 2][4] = i;
    }

    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = arr[i - real_n];
        }else{
            buf = 0;
        }
        min_tree[i][0] = buf;
        min_tree[i][1] = i - real_n;
        min_tree[i][2] = i - real_n;
        min_tree[i][3] = -1;
        min_tree[i][4] = -1;
         // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        min_tree[i / 2][0] = min(min_tree[i - 1][0], min_tree[i][0]);
        min_tree[i / 2][1] = min_tree[i - 1][1];
        min_tree[i / 2][2] = min_tree[i][2];
        min_tree[i / 2][3] = i - 1;
        min_tree[i / 2][4] = i;
    }

    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = arr[i - real_n];
        }else{
            buf = 0;
        }
        max_tree[i][0] = buf;
        max_tree[i][1] = i - real_n;
        max_tree[i][2] = i - real_n;
        max_tree[i][3] = -1;
        max_tree[i][4] = -1; // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        max_tree[i / 2][0] = max(max_tree[i - 1][0], max_tree[i][0]);
        max_tree[i / 2][1] = max_tree[i - 1][1];
        max_tree[i / 2][2] = max_tree[i][2];
        max_tree[i / 2][3] = i - 1;
        max_tree[i / 2][4] = i;
    }

    for(int i = real_n; i < real_n * 2; i++){
        if(i - real_n < n){
            buf = 1;
        }else{
            buf = 0;
        }
        sum_tree[i][0] = buf;
        sum_tree[i][1] = i - real_n;
        sum_tree[i][2] = i - real_n;
        sum_tree[i][3] = -1;
        sum_tree[i][4] = -1;
 // {0:value, 1:range_begin, 2:range_end, 3:child_1, 4:child_2}
    }
    for(int i = real_n * 2 - 1; i > 1; i -= 2){
        sum_tree[i / 2][0] = sum_tree[i - 1][0] + sum_tree[i][0];
        sum_tree[i / 2][1] = sum_tree[i - 1][1];
        sum_tree[i / 2][2] = sum_tree[i][2];
        sum_tree[i / 2][3] = i - 1;
        sum_tree[i / 2][4] = i;

    }

//===============================================================================
//                             end of initialization
//===============================================================================

    cout << s << ' ';
    for(int t = 0; t < n - 2; t++){
        cin >> buf;
        add(pos[buf], -1, real_n);
        s -= times_used[buf - 1] - get_up_sum(pos[buf] + real_n);
        update_max(pos[buf], 0, real_n);
        update_min(pos[buf], inf, real_n);
        modify(1, 0, pos[buf], buf, 1, s);
        if (t != n - 1){
            cout << s << ' ';
        }else{
            cout << s;
        }
    }


    return 0;
}
//===============================================================================


void modify(int value, int range_begin, int range_end, int max_value, int curr, int &s){
    if (range_begin == mod_tree[curr][1] and range_end == mod_tree[curr][2] and max_tree[curr][0] <= max_value){
        mod_tree[curr][0] += value;
        s -= sum_tree[curr][0] * value;
        return;
    }
    if (range_begin <= mod_tree[mod_tree[curr][3]][2] and min_tree[mod_tree[curr][3]][0] <= max_value){
        modify(value, range_begin, min(mod_tree[mod_tree[curr][3]][2], range_end), max_value, mod_tree[curr][3], s);
    }
    if (range_end >= mod_tree[mod_tree[curr][4]][1] and min_tree[mod_tree[curr][4]][0] <= max_value){
        modify(value, max(mod_tree[mod_tree[curr][4]][1], range_begin), range_end, max_value, mod_tree[curr][4], s);
    }
}


int power(int a, int b){
    int ans = 1;
    for(int i = 0; i < b; i++){
        ans *= a;
    }
    return ans;
}


int get_up_sum(int curr){
    int ans = mod_tree[curr][0];
    if (curr > 1){
        ans += get_up_sum(curr / 2);
    }
    return ans;
}


void update_min(int pos, int num, int n){
    pos += n;
    min_tree[pos][0] = num;
    if (pos != 1){
        back_umin(pos / 2, num);
    }
}

void back_umin(int pos, int num){
    min_tree[pos][0] = min(min_tree[min_tree[pos][3]][0], min_tree[min_tree[pos][4]][0]);
    if (pos != 1){
        back_umin(pos / 2, num);
    }
}


void update_max(int pos, int num, int n){
    pos += n;
    max_tree[pos][0] = num;
    if (pos != 1){
        back_umax(pos / 2, num);
    }
}


void back_umax(int pos, int num){
    max_tree[pos][0] = max(max_tree[max_tree[pos][3]][0], max_tree[max_tree[pos][4]][0]);
    if (pos != 1){
        back_umax(pos / 2, num);
    }
}


void down_add(int mod, int range_begin, int range_end, int curr){

    if (range_begin == mod_tree[curr][1] and range_end == mod_tree[curr][2]){
        mod_tree[curr][0] += mod;
        return;
    }
    if (range_begin <= mod_tree[mod_tree[curr][3]][2]){
        down_add(mod, range_begin, min(mod_tree[mod_tree[curr][3]][2], range_end), mod_tree[curr][3]);
    }
    if (range_end >= mod_tree[mod_tree[curr][4]][1]){
        down_add(mod, max(mod_tree[mod_tree[curr][4]][1], range_begin), range_end, mod_tree[curr][4]);
    }
}


void add(int pos, int num, int n){
    pos += n;
    sum_tree[pos][0] += num;
    if (pos != 1){
        back_add(pos / 2, num);
    }
}


void back_add(int pos, int num){
    sum_tree[pos][0] += num;
    if (pos != 1){
        back_add(pos / 2, num);
    }
}
