#include <iostream>
#include <set>
using namespace std;
struct dta {
  int val, ind;
  bool operator <(const dta& x) const {
    return ind>x.ind && val<x.val;
  }
  bool operator <=(const dta& x) const {
    return ind>=x.ind && val<=x.val;
  }
  bool operator ==(const dta& x) const {
    return ind==x.ind && val==x.val;
  }
};
static inline dta makedata(int val, int ind) {
  dta rez;
  rez.val=val;
  rez.ind=ind;
  return rez;
}
struct altdata {
  int val, ind;
  bool operator <(const altdata& x) const {
    return ind<x.ind && val>x.val;
  }
  bool operator <=(const altdata& x) const {
    return ind<=x.ind && val>=x.val;
  }
};
static inline altdata makealtdata(int val, int ind) {
  altdata rez;
  rez.val=val;
  rez.ind=ind;
  return rez;
}
int order[100000],inverse[100000];
int invgrade[100000],alt[100000];
int main() {
  int n,totalinv,x;
  cin >> n;
  for(int i=0; i<n; i++) {
    cin >> order[i];
    inverse[order[i]]=i;
  }
  multiset<int> :: iterator it;
  multiset<int> freq;
  totalinv=0;
  for(int i=n-1; i>=0; i--) {
    if(i<n-1)
      totalinv+=(invgrade[order[i]]=distance(freq.begin(),freq.lower_bound(order[i])));
    freq.insert(order[i]);
  }
  multiset<int> alte;
  for(int i=0; i<n; i++) {
    if(i>0) 
      alt[order[i]]=distance(alte.lower_bound(order[i]),alte.end());
    alte.insert(order[i]);
  }
  cout << totalinv << ' ';
  multiset<dta> out;
  multiset<altdata> altout;
  for(int i=0; i<n-2;  i++) {
    cin >> x;
    totalinv-=invgrade[x]+alt[x];
    if(i>0) {
      totalinv+=(distance(out.begin(),out.lower_bound(makedata(x,inverse[x]))));
      totalinv+=(distance(altout.begin(),altout.lower_bound(makealtdata(x,inverse[x]))));
    }
    cout << totalinv << ' ';
    altout.insert(makealtdata(x,inverse[x]));
    out.insert(makedata(x,inverse[x]));
  }
  cout << '\n';
}
/*
  6
  6 1 2 5 3 4
  3 5 4 6
 * 
 * 
 * class aint {
private:
  int tree[131073], treesize;
public:
  aint(int v[], int size) {
    int leafpointer=(1<<((int)log2(size)));
    treesize=leafpointer<<1;
    for(int i=0; i<size; i++) {
      tree[i+leafpointer]=v[i];
    }
    construct(1,leafpointer);
  }
  int construct(int node, int leafpointer) {
    if(node>=leafpointer)
      return tree[node];
    tree[node]=construct(2*node,leafpointer)+construct(2*node+1,leafpointer);
  }
  int query(int node, int
};
 */
