#include <bits/stdc++.h>

#include <ext/pb_ds/detail/standard_policies.hpp>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define whole(Pudge) (Pudge).begin (), (Pudge).end ()

#define sqr(Pudge) (Pudge) * (Pudge)
#define pw(Pudge) (1LL << (Pudge))

using namespace std;

using namespace __gnu_pbds;

const int MaXn = 1 * 1e5 + 15;

template <typename key> using Ordered_Set = tree <key, null_type, less <key>, rb_tree_tag, tree_order_statistics_node_update>;


Ordered_Set <int> haveL, haveR;

set <int> tLS[MaXn];

int d[MaXn], L[MaXn], r[MaXn], g[MaXn];

int tL[10 * MaXn];

void buildL (int Vertex, int tLeft, int tRight) {

    if (!(tLeft - tRight))
        tL[Vertex] = L[d[tLeft]] + 0;

    else {

        int tC = (tLeft + tRight) / 2;

        buildL (Vertex * 2, tLeft, tC);
        buildL (Vertex * 2 + 1, tC + 1, tRight);
    }
}

void pushL (int Vertex, int tLeft, int tRight) {

    if ((int)tLS[Vertex].size ()) {

        if (!(tRight - tLeft)) {

            for (auto h : tLS[Vertex])
                if (d[tLeft] < h)
                    tL[Vertex]--;

            tLS[Vertex].clear ();
        }

        for (auto h : tLS[Vertex]) {

             tLS[Vertex * 2].insert (h);
             tLS[Vertex * 2 + 1].insert (h);
        }

        tLS[Vertex].clear ();
    }
}

void group_ModL (int Vertex, int tLeft, int tRight, int Left, int right, int x) {

    if (Left > right)
        return;

    if (!(tLeft - Left) && !(tRight - right)) {

        tLS[Vertex].insert (x);
        pushL (Vertex, tLeft, tRight);
    }

    else {

        int tC = (tLeft + tRight) / 2;

        pushL (Vertex, tLeft, tRight);
        pushL (Vertex * 2, tLeft, tC);
        pushL (Vertex * 2 + 1, tC + 1, tRight);

        group_ModL (Vertex * 2, tLeft, tC, Left, min (tC, right), x);
        group_ModL (Vertex * 2 + 1, tC + 1, tRight, max (Left, tC + 1), right, x);
    }
}

int getL (int Vertex, int tLeft, int tRight, int p) {

    pushL (Vertex, tLeft, tRight);

    if (!(tLeft - p) && !(tRight - p))
        return tL[Vertex];

    int tC = (tLeft + tRight) / 2;

    if (p > tC)
        return getL (Vertex * 2 + 1, tC + 1, tRight, p);

    else
        return getL (Vertex * 2, tLeft, tC, p);
}

int main () {

    ios_base :: sync_with_stdio (0);
    cin.tie (0); cout.tie (0);

#ifdef Local

    freopen ("Pudge.in", "r", stdin);
    freopen ("Pudge.out", "w", stdout);

#endif // Local

    int n;
    cin >> n;

    for (int now = 0; now < n; now++) {

        cin >> d[now];
        g[d[now]] = now + 0;
    }

    for (int now = 0; now < n; now++) {

        L[d[now]] = (int)haveL.size () - haveL.order_of_key (d[now]);
        haveL.insert (d[now]);
    }

    int answer = 0;
    for (int now = n - 1; now > -1; now--) {

        haveR.insert (d[now]);

        int delta = haveR.order_of_key (d[now]);

        r[d[now]] = r[d[now]] + delta;
        answer = answer + delta;
    }

    cout << answer << " ";

    buildL (1, 0, n - 1);

    int Q = n - 2;
    while (Q--) {

        int x;
        cin >> x;

        answer = answer - getL (1, 0, n - 1, g[x]) - r[x];

        if (g[x] < n - 1)
            group_ModL (1, 0, n - 1, g[x] + 1, n - 1, x);

        for (int w = x + 1; w < n + 1; w++)
            if (g[w] < g[x])
                r[w]--;

//        for (int w = 1; w < x; w++)
//            if (g[w] > g[x])
//                L[w]--;

        cout << answer << " ";
    }

    cout << "\n";
    return 0;
}
