#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=1e5+6;
ll pos[MAXN],a[MAXN];
struct block
{
	vector<ll>v;
	vector<ll>sorted;
};
const ll sz=800;
vector<block>buckets;
vector<ll>xd;
ll ans=0;
ll BIT[MAXN];
void update(ll idx,ll val)
{
	for(;idx<MAXN;idx+=idx&(-idx))
	{
		BIT[idx]+=val;
	}
}
ll query(ll idx)
{
	ll ret=0;
	for(;idx>0;idx-=idx&(-idx))
	{
		ret+=BIT[idx];
	}
	return ret;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	ll n;
	cin>>n;
	for(ll i=0;i<n;++i)
	{
		cin>>a[i];
		ans+=i-query(a[i]);
		update(a[i],1);
		pos[a[i]]=i;
		if(i%sz==0)
		{
			buckets.push_back({xd,xd});
		}
		buckets.back().v.push_back(a[i]);
		buckets.back().sorted.push_back(a[i]);
	}
	for(ll i=0;i<buckets.size();++i)
	{
		sort(buckets[i].sorted.begin(),buckets[i].sorted.end());
	}
	vector<ll>output;
	output.push_back(ans);
	for(ll i=1;i<n-1;++i)
	{
		ll p;
		cin>>p;
		ll f=pos[p];
		ll numb=f/sz;
		for(ll j=0;j<numb;++j)
		{
			ll low=0,high=buckets[j].sorted.size()-1,mid,ans1=high+1;
			while(low<=high)
			{
				mid=(low+high)/2;
				if(buckets[j].sorted[mid]<p)
				{
					low=mid+1;
				}
				else 
				{
					ans1=mid;
					high=mid-1;
				}
			}
			ans-=buckets[j].sorted.size()-ans1;
		}
		for(ll j=numb+1;j<buckets.size();++j)
		{
			ll low=0,high=buckets[j].sorted.size()-1,mid,ans1=low-1;
			while(low<=high)
			{
				mid=(low+high)/2;
				if(buckets[j].sorted[mid]>p)
				{
					high=mid-1;
				}
				else 
				{
					ans1=mid;
					low=mid+1;
				}
			}
			ans-=ans1+1;
		}
		bool found=0;
		for(ll j=0;j<buckets[numb].v.size();++j)
		{
			if(found==0&&buckets[numb].v[j]>p)
			{
				//cout<<"* "<<buckets[numb].v[j]<<" "<<p<<endl;
				ans--;
			}
			if(found==1&&buckets[numb].v[j]<p)
			{
				//cout<<"* "<<buckets[numb].v[j]<<" "<<p<<endl;
				ans--;
			}
			if(buckets[numb].v[j]==p)found=1;
		}
		vector<ll>newv,newsorted;
		for(auto j:buckets[numb].v)
		{
			if(j==p)continue;
			newv.push_back(j);
		}
		buckets[numb].v=newv;
		for(auto j:buckets[numb].sorted)
		{
			if(j==p)continue;
			newsorted.push_back(j);
		}
		buckets[numb].sorted=newsorted;
		output.push_back(ans);
		/*for(int j=0;j<buckets.size();j++)
		{
			cout<<j<<":";
			for(auto l:buckets[j].v)cout<<l<<" ";
			cout<<endl;
			for(auto l:buckets[j].sorted)cout<<l<<" ";
			cout<<endl;
		}
		cout<<"dx\n";*/
	}
	cout<<output[0];
	for(ll i=1;i<output.size();++i)cout<<" "<<output[i];
	cout<<endl;
return 0;
}
