#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=1e5+6;
int pos[MAXN],a[MAXN];
struct block
{
	vector<int>v;
	vector<int>sorted;
};
const int sz=1000;
vector<block>buckets;
vector<int>xd;
ll ans=0;
int BIT[MAXN];
void update(int idx,int val)
{
	for(;idx<MAXN;idx+=idx&(-idx))
	{
		BIT[idx]+=val;
	}
}
int query(int idx)
{
	int ret=0;
	for(;idx>0;idx-=idx&(-idx))
	{
		ret+=BIT[idx];
	}
	return ret;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin>>n;
	for(int i=0;i<n;++i)
	{
		cin>>a[i];
		ans+=(ll)i-query(a[i]);
		update(a[i],1);
		pos[a[i]]=i;
		if(i%sz==0)
		{
			buckets.push_back({xd,xd});
		}
		buckets.back().v.push_back(a[i]);
		buckets.back().sorted.push_back(a[i]);
	}
	for(int i=0;i<buckets.size();++i)
	{
		sort(buckets[i].sorted.begin(),buckets[i].sorted.end());
	}
	vector<int>output;
	output.push_back(ans);
	for(int i=1;i<n-1;++i)
	{
		int p;
		cin>>p;
		int f=pos[p];
		int numb=f/sz;
		for(int j=0;j<numb;++j)
		{
			int low=0,high=buckets[j].sorted.size()-1,mid,ans1=high+1;
			while(low<=high)
			{
				mid=(low+high)/2;
				if(buckets[j].sorted[mid]<p)
				{
					low=mid+1;
				}
				else 
				{
					ans1=mid;
					high=mid-1;
				}
			}
			ans-=(ll)buckets[j].sorted.size()-ans1;
		}
		for(int j=numb+1;j<buckets.size();++j)
		{
			int low=0,high=buckets[j].sorted.size()-1,mid,ans1=low-1;
			while(low<=high)
			{
				mid=(low+high)/2;
				if(buckets[j].sorted[mid]>p)
				{
					high=mid-1;
				}
				else 
				{
					ans1=mid;
					low=mid+1;
				}
			}
			ans-=(ll)ans1+1;
		}
		bool found=0;
		for(int j=0;j<buckets[numb].v.size();++j)
		{
			if(found==0&&buckets[numb].v[j]>p)
			{
				//cout<<"* "<<buckets[numb].v[j]<<" "<<p<<endl;
				--ans;
			}
			if(found==1&&buckets[numb].v[j]<p)
			{
				//cout<<"* "<<buckets[numb].v[j]<<" "<<p<<endl;
				--ans;
			}
			if(buckets[numb].v[j]==p)found=1;
		}
		vector<int>newv,newsorted;
		for(int j=0;j<buckets[numb].v.size();++j)
		{
			if(buckets[numb].v[j]!=p)newv.push_back(buckets[numb].v[j]);
			if(buckets[numb].sorted[j]!=p)newsorted.push_back(buckets[numb].sorted[j]);
		}
		buckets[numb].v=newv;
		buckets[numb].sorted=newsorted;
		output.push_back(ans);
	}
	cout<<output[0];
	for(int i=1;i<output.size();++i)cout<<" "<<output[i];
	cout<<endl;
return 0;
}
