#include<iostream>
#include<stack>
#include<utility>

#define endl '\n'

using namespace std;

const int MAXN=1e5+3;
int nums[MAXN],ind[MAXN];

int disorder_score(int n){
    stack<pair<int, int>> prev;

    int score=0;
    for(int i=n-1;i>=0;--i){
        if(nums[i]==-1){
            continue;
        }

        pair<int, int> curr(nums[i], 1);
        while(!prev.empty() and nums[i]>prev.top().first){
            curr.second+=prev.top().second;
            prev.pop();
        }

        score+=curr.second-1;
        prev.push(curr);
    }

    return score;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin>>n;

    for(int i=0;i<n;++i){
        cin>>nums[i];
        ind[nums[i]-1]=i;
    }

    cout<<disorder_score(n)<<" ";
    for(int i=2;i<n;++i){
        int removed;
        cin>>removed;

        nums[ind[removed-1]]=-1;
        cout<<disorder_score(n)<<" ";
    }
    cout<<endl;
return 0;
}
