#include <iostream>
using namespace std;
const int maxn = 1e4+10;
int t[maxn], l[maxn], n, k;
int sum[maxn];
int bruteforce(int x) {
    if (x == n) {
        int ans = 0;
        for (int i = 0 ; i < n ; ++i) {
            ans += (sum[i] >= 2*k)*l[i];
        }
        return ans;
    }
    int ans = 0;
    for (int i = 0 ; i < n ; ++i) {
        sum[i] += (x == i || x == t[i] ? k : 1);
        ans = max(ans, bruteforce(x+1));
        sum[i] -= (x == i || x == t[i] ? k : 1);
    }
    return ans;
}
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> k;
    for (int i = 0 ; i < n ; ++i)
        cin >> t[i] >> l[i];
    cout << bruteforce(0) << '\n';
    return 0;
}
