#include <iostream>
#include <stack>
#include <algorithm>
using namespace std;
const int MAXN=1e5+10;
struct Zaqwka{
    int x, ind;
};
Zaqwka b[MAXN], b1[MAXN], b2[MAXN];
stack <long long> st;
long long ans[MAXN];
int a[MAXN], pos[MAXN], c[MAXN], a1[MAXN], a2[MAXN], b3[MAXN], b4[MAXN];
long long tree[4*MAXN];
bool used[MAXN];
bool cmp(Zaqwka a, Zaqwka b) {
    return pos[a.x]<pos[b.x];
}
void build_tree(int node, int l, int r) {
    if (l==r) {
        tree[node]=1;
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    tree[node]=tree[node*2]+tree[node*2+1];
}
void update(int node, int l, int r, int qind) {
    if (qind>r || qind<l) return;
    if (l==r) {
        tree[node]--;
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,qind);
    update(node*2+1,mid+1,r,qind);
    tree[node]=tree[node*2]+tree[node*2+1];
}
int query(int node, int l, int r, int ql, int qr) {
    if (ql>r || qr<l) return 0;
    if (l>=ql && r<=qr) return tree[node];
    int mid=(l+r)/2;
    return query(node*2,l,mid,ql,qr)+query(node*2+1,mid+1,r,ql,qr);
}
void count_inv(int l, int mid, int r) {
    for (int i=l;i<=mid;i++) a1[i]=a[i];
    for (int i=mid+1;i<=r;i++) a2[i]=a[i];
    a2[r+1]=MAXN;
    int br1, br2;
    br1=l; br2=mid+1;
    while (br1<=mid) {
        ans[a1[br1]]+=br2-(mid+1);
        if (a1[br1]<a2[br2]) br1++;
        else {
            while (a1[br1]>a2[br2]) {
                ans[a[br1]]++;
                br2++;
            }
            br1++;
        }
    }
    for (int i=mid+1;i<=r;i++) a1[i]=-a[i];
    for (int i=l;i<=mid;i++) a2[i]=-a[i];
    a2[mid+1]=MAXN;
    br1=mid+1; br2=l;
    while (br1<=r) {
        ans[a1[br1]]+=br2-l;
        if (a1[br1]<a2[br2]) br1++;
        else {
            while (a1[br1]>a2[br2]) {
                ans[-a[br1]]++;
                br2++;
            }
            br1++;
        }
    }
}
void merg(int l, int mid, int r) {
    for (int i=l;i<=mid;i++) a1[i]=a[i];
    for (int i=mid+1;i<=r;i++) a2[i]=a[i];
    a2[r+1]=MAXN;
    a1[mid+1]=MAXN;
    int br1, br2, br3;
    br1=br3=l; br2=mid+1;
    while (br1<=mid || br2<=r) {
        if (a1[br1]<a2[br2]) {
            a[br3]=a1[br1];
            br3++;
            br1++;
        } else {
            while (a1[br1]>a2[br2]) {
                a[br3]=a2[br2];
                br3++;
                br2++;
            }
            a[br3]=a1[br1];
            br3++;
            br1++;
        }
    }
}
void invert_cnt(int l, int r) {
    if (l==r) return;
    int mid=(l+r)/2;
    invert_cnt(l,mid);
    invert_cnt(mid+1,r);
    count_inv(l,mid,r);
    merg(l,mid,r);
}
void count_b(int l, int mid, int r) {
    for (int i=l;i<=mid;i++) {
        b1[i]=b[i];
        b3[i]=b[i].ind;
    }
    for (int i=mid+1;i<=r;i++) {
        b2[i]=b[i];
        b3[i]=b[i].ind;
    }
    b2[r+1].x=MAXN;
    sort(b3+l,b3+r+1);
    for (int i=l;i<=r;i++) b4[b3[i]]=i-l;
    build_tree(1,0,r-l+1);
    int br1, br2;
    br1=l; br2=mid+1;
    build_tree(1,0,r-l+1);
    while (br1<=mid) {
        if (b1[br1].x>b2[br2].x) {
            while (b1[br1].x>b2[br2].x) {
                update(1,0,r-l+1,b4[b2[br2].x]);
                br2++;
            }
        }
        ans[b1[br1].x]-=query(1,0,r-l+1,b4[b1[br1].x],r-l+1);
        br1++;
    }
    for (int i=mid+1;i<=r;i++) {
        b1[i]=b[i];
        b1[i].x=-b1[i].x;
    }
    for (int i=l;i<=mid;i++) {
        b2[i]=b[i];
        b2[i].x=-b2[i].x;
    }
    b2[mid+1].x=MAXN;
    br1=mid+1; br2=l;
    build_tree(1,0,r-l+1);
    while (br1<=mid) {
        if (b1[br1].x>b2[br2].x) {
            while (b1[br1].x>b2[br2].x) {
                update(1,0,r-l+1,b4[-b2[br2].x]);
                br2++;
            }
        }
        ans[-b1[br1].x]-=query(1,0,r-l+1,b4[-b1[br1].x],r-l+1);
        br1++;
    }
}
void merg_b(int l, int mid, int r) {
    for (int i=l;i<=mid;i++) b1[i]=b[i];
    for (int i=mid+1;i<=r;i++) b2[i]=b[i];
    b2[r+1].x=MAXN;
    int br1, br2, br3;
    br1=br3=l; br2=mid+1;
    while (br1<=mid || br2<=r) {
        ans[b1[br1].x]+=br2-(mid+1);
        if (b1[br1].x<b2[br2].x) {
            b[br3]=b1[br1];
            br3++;
            br1++;
        }
        else {
            while (b1[br1].x>b2[br2].x) {
                b[br3]=b2[br2];
                br3++;
                br2++;
            }
            b[br3]=b1[br1];
            br3++;
            br1++;
        }
    }
}
void invert_b(int l, int r) {
    if (l==r) return;
    int mid=(l+r)/2;
    invert_b(l,mid);
    invert_b(mid+1,r);
    count_b(l,mid,r);
    merg_b(l,mid,r);
}
int cnt_first(int n) {
    for (int i=0;i<n-2;i++) used[c[i]]=true;
    int a, b, posa, posb;
    a=-1;
    for (int i=1;i<=n;i++) {
        if (!used[i]) {
            if (a==-1) {
                a=i;
                posa=pos[a];
            } else {
                b=i;
                posb=pos[b];
            }
        }
    }
    if (posa>posb) swap(a,b);
    return a>b;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> a[i];
        pos[a[i]]=i;
    }
    invert_cnt(0,n-1);
    /**
    for (int i=0;i<n;i++) cout << a[i] << ' ';
    cout << endl;
    for (int i=1;i<=n;i++) cout << ans[i] << ' ';
    cout << endl;
    **/
    for (int i=0;i<n-2;i++) {
        cin >> b[i].x;
        b[i].ind=i;
        c[i]=b[i].x;
    }
    sort(b,b+n-2,cmp);
    invert_b(0,n-2);
    long long s=cnt_first(n);
    st.push(s);
    for (int i=0;i<n-2;i++) {
        s+=ans[c[i]];
        st.push(s);
    }
    while (!st.empty()) {
        cout << st.top() << ' ';
        st.pop();
    }
    cout << endl;
    return 0;
}
