#include<bits/stdc++.h>
using namespace std;

const int MAXN = 100000;

vector<pair<int, int> > ribs;
int n;
int m[MAXN+1], br = 0;
int v[MAXN];
int w[MAXN+1];

void SS(int b, int e)
{
    if(b == e) return;
    int mid = (b+e)/2;
    int s[MAXN], h1 = b, h2 = mid+1;
    SS(b, mid);
    SS(mid + 1, e);
    for(int i = b; i <= e; i++) s[i] = m[i];
    int id = b;
    while(h1 <= mid && h2 <= e)
    {
        if(s[h1] < s[h2]) m[id++] = s[h1++];
        else
        {
            ribs.push_back({s[h2], s[h1]});
            m[id++] = s[h2++];
            br++;
        }
    }
    while(h1<=mid) m[id++] = s[h1++];
    while(h2<=e) m[id++] = s[h2++];
}

int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    for(int i = 0; i < n; i++) cin >> m[i];
    SS(0, n-1);
    memset(w, 0, sizeof(w));
    for(int i = 0; i < n-2; i++)
    {
        cin >> v[i];
        m[v[i]] = n-i;
    }
    for(pair<int, int> l:ribs)
    {
        if(m[l.first] > m[l.second]) w[l.first]++;
        else w[l.second]++;
    }
    cout << br << " ";
    for(int i = 0; i < n-2; i++)
    {
        br -= w[v[i]];
        cout << br << " ";
    }
    cout << "\n";
    return 0;
}
