#include <algorithm>
#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int a[MAXN + 5];
int pos[MAXN + 5];
bool used[MAXN + 5];
int p[MAXN + 5], s[MAXN + 5];
int fw1[MAXN + 5], fw2[MAXN + 5];

void update(int idx, int delta, int fw[])
{
    while (idx <= MAXN)
    {
        fw[idx] += delta;
        idx += (idx & (-idx));
    }
}

int query(int idx, int fw[])
{
    int ret = 0;
    while (idx)
    {
        ret += fw[idx];
        idx -= (idx & (-idx));
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
    }

    reverse(a + 1, a + n + 1);

    for (int i = 1; i <= n; ++ i)
    {
        pos[a[i]] = i;
        p[i] = query(a[i] - 1, fw1);
        update(a[i], 1, fw1);
    }

    for (int i = n; i >= 1; -- i)
    {
        s[i] = query(n - a[i], fw2);
        update(n - a[i] + 1, 1, fw2);
    }

    long long ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        ans += p[i];
    }

    cout << ans << " ";

    for (int i = 1; i <= n - 2; ++ i)
    {
        int num;
        cin >> num;
        ans = ans - (p[pos[num]] + s[pos[num]]);
        used[num] = true;
        for (int j = 1; j < pos[num]; ++ j)
        {
            if (!used[a[j]] and a[j] < num) s[j]--;
        }
        for (int j = pos[num] + 1; j <= n; ++ j)
        {
            if (!used[a[j]] and num < a[j]) p[j]--;
        }
        cout << ans << " ";
    }
    cout << endl;

    return 0;
}
