#include <bits/stdc++.h>
using namespace std;

const int INF = (int)1e9 + 239;

inline void upd(int &x, int y) {
    if (y > x)
        x = y;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> t(n), l(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i] >> l[i];
    vector<bool> used(n, false);
    vector<int> glob_dp(n + 1, -INF);
    glob_dp[0] = 0;
    for (int start = 0; start < n; ++start) {
        if (used[start])
            continue;
        vector<int> p;
        int cur = start;
        while (!used[cur]) {
            used[cur] = true;
            p.push_back(cur);
            cur = t[cur];
        }
        int len = p.size();
        vector<int> mx(n + 1, -INF);
        for (int take_last = 0; take_last < 2; ++take_last) {
            vector<vector<int>> dp(n + 1, vector<int>(2, -INF));
            for (int i = 0; i <= n; ++i) {
                if (glob_dp[i] == -INF)
                    continue;
                upd(dp[i][0], glob_dp[i]);
                if (i + 2 * k <= n)
                    upd(dp[i + 2 * k][0], glob_dp[i] + l[p[0]]);
                if (i + k + 1 <= n)
                    upd(dp[i + k + 1][1], glob_dp[i] + l[p[0]]);
                if (!take_last) {
                    if (i + k + 1 <= n)
                        upd(dp[i + k + 1][0], glob_dp[i] + l[p[0]]);
                    if (i + 2 <= n)
                        upd(dp[i + 2][1], glob_dp[i] + l[p[0]]);
                }
            }
            for (int i = 1; i < len; ++i) {
                vector<vector<int>> new_dp(n + 1, vector<int>(2, -INF));
                for (int cnt = 0; cnt <= n; ++cnt) {
                    for (int take = 0; take < 2; ++take) {
                        if (dp[cnt][take] == -INF)
                            continue;
                        int cur = dp[cnt][take] + l[p[i]];
                        upd(new_dp[cnt][0], dp[cnt][take]);
                        if (cnt + 2 * k <= n)
                            upd(new_dp[cnt + 2 * k][0], cur);
                        if(cnt + k + 1 <= n) {
                            upd(new_dp[cnt + k + 1][1], cur);
                            if (!take)
                                upd(new_dp[cnt + k + 1][0], cur);
                        }
                        if (cnt + 2 <= n && !take)
                            upd(new_dp[cnt + 2][1], cur);
                    }
                }
                dp = new_dp;
            }
            for (int i = 0; i <= n; ++i)
                mx[i] = max(mx[i], dp[i][take_last]);
        }
        glob_dp = mx;
    }
    int ans = -INF;
    for (int i = 0; i <= n; ++i)
        upd(ans, glob_dp[i]);
    cout << ans;
    return 0;
}
