#include <algorithm>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <vector>

using namespace std;
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define INF 0x3f3f3f3f
#define INFLL (int64_t)(1e18)
#define EPS 1e-9

template <class T> istream &operator>>(istream &is, vector<T> &a) {
    for (size_t i = 0; i < a.size(); ++i)
        is >> a[i];
    return is;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<unordered_set<int>> v(n);
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            if (a[i] > a[j])
                v[a[i] - 1].insert(a[j] - 1);
    int ans = 0;
    for (int i = 0; i < n; ++i)
        ans += v[i].size();
    cout << ans << " ";
    for (int _ = 0; _ < n - 2; ++_) {
        int cur;
        cin >> cur;
        --cur;
        for (int i = 0; i < n; ++i)
            v[a[i] - 1].erase(cur);
        v[cur].clear();
        ans = 0;
        for (int i = 0; i < n; ++i)
            ans += v[a[i] - 1].size();
        cout << ans << " ";
    }
}
