#include <bits/stdc++.h>
#pragma GCC optimization("Ofast")
#pragma GCC optimization("unroll-loops")

using namespace std;

typedef long long ll;

const int maxkoren=320;
const int maxn=100001;

int decomp[maxkoren][maxn];
int niz[maxn];
int gde[maxn];
int bitt[maxn];
int n;

void dodajdole(int x,int *bit){
    for(;x<=n;x+=x&-x) bit[x]++;
}

void sklonidole(int x,int *bit){
    for(;x<=n;x+=x&-x) bit[x]--;
}

int upitdole(int x,int *bit){
    int ret=0;
    for(;x>0;x-=x&-x) ret+=bit[x];
    return ret;
}

int upitgore(int x,int *bit){
    int ret=upitdole(n,bit)-upitdole(x,bit);
    return ret;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>niz[i];
        gde[niz[i]]=i;
    }
    int koren=sqrt(n)+0.0001;
    ///uradi pocetni
    ll res=0;
    for(int i=n-1;i>=0;i--){
        res+=upitdole(niz[i],bitt);
        dodajdole(niz[i],bitt);
    }
    for(int i=0;i<n;i++){
        dodajdole(niz[i],decomp[i/koren]);
    }
    cout<<res<<" ";
    //cout<<"koren: "<<koren<<"\n";
    ///
    for(int i=0;i<n-2;i++){
        int a;
        cin>>a;
        //cout<<"ovde je: "<<gde[a]<<"\n";
        niz[gde[a]]=-1;
        sklonidole(a,decomp[gde[a]/koren]);
        for(int j=0;j<n;j+=koren){
            //cout<<j<<" "<<j+koren<<" ";
            if(j+koren>gde[a] && j<=gde[a]){
                for(int p=j;p<gde[a];p++){
                    if(niz[p]!=-1 && niz[p]>a) res--;
                }
                for(int p=gde[a]+1;p<j+koren && p<n;p++){
                    if(niz[p]!=-1 && niz[p]<a) res--;
                }
                continue;
            }
            if(j+koren>=n){
                for(int p=j;p<n;p++){
                    if(niz[p]!=-1 && niz[p]<a) res--;
                }
                break;
            }
            if(j+koren<=gde[a]){
                res-=upitgore(a,decomp[j/koren]);
                //cout<<"ispredlepo\n";
            }else if(j>=gde[a]){
                //cout<<"poslelepo\n";
                res-=upitdole(a,decomp[j/koren]);
            }
        }
        cout<<res<<" ";
    }
    return 0;
}
