#include <iostream>
#include <cmath>
#include <algorithm>


using namespace std;

int buck[200][200], sz[200], n, a[100002], poz[100002], aib[100002];

void updateAIB (int x) {
  for (int i = x; i <= n; i += (i & -i))
    aib[i]++;
}
int queryAIB (int x) {
  int s = 0;
  for (int i = x; i; i -= (i & -i))
    s += aib[i];
  return s;
}

int main()
{
  ios_base::sync_with_stdio(false);
  cin.tie(0); cout.tie(0);
  cin >> n;
  long long total = 0;
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    total += queryAIB(n - a[i] + 1);
    updateAIB(n - a[i] + 1);
    poz[a[i]] = i;
  }
  int B = sqrt(n);
  if (B == 1)
    B = 2;
  for (int i = 0; i < n; i += B) {
    for (int j = 0; j < B; j++)
      buck[i / B][j] = a[i + j];
    sort(buck[i / B], buck[i / B] + B);
    sz[i / B] = B;
  }
  cout << total << " ";
  for (int i = 1; i <= n - 2; i++) {
    int x;
    cin >> x;
    int ans = 0;
    int p = poz[x];
    int last = 0;
    for (int j = 0; j < n; j += B) {
      if (j + B - 1 < p) {
        last = j + B;
        ans += sz[j / B] - (lower_bound(buck[j / B], buck[j / B] + sz[j / B], x) - buck[j / B]);
      }
    }
    for (int j = last; j < p; j++)
      if (a[j] > x)
        ans++;
    int start = p + 1, End = p;
    bool ok = 0;
    for (int j = 0; j < n; j += B) {
      if (p + 1 <= j) {
        if (!ok)
          start = j, ok = 1;
        End = j + B - 1;
        ans += lower_bound(buck[j / B], buck[j / B] + sz[j / B], x) - buck[j / B];
      }
    }
    for (int j = n - 1; j > End; j--)
      if (a[j] < x)
        ans++;
    for (int j = p + 1; j < start; j++)
      if (a[j] < x)
        ans++;
    a[p] = 0;
    for (int j = 0; j < n; j += B)
      if (j <= p && p < j + B) {
        sz[j / B]--;
        int meh;
        for (int k = 0; k < sz[j / B]; k++)
          if (x == buck[j / B][k]) {
            meh = k;
            break;
          }
        for (int k = meh; k + 1 < sz[j / B]; k++)
          buck[j / B][k] = buck[j / B][k + 1];
        break;
      }
    total -= ans;
    cout << total << " ";
  }
  return 0;
}
