#include <bits/stdc++.h>
#define ub(x) (x&(-x))

using namespace std;

constexpr int NMAX = 1e5 + 5;

int aib[NMAX];
int N;

int val[NMAX];

long long ans = 0;

void Update (int poz, int val) {
    for (int i = poz; i <= N; i += ub(i))
        aib[i] += val;
}

int Query (int poz) {
    int S = 0;

    for (int i = poz; i > 0; i -= ub(i))
        S += aib[i];

    return S;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i <= N; ++ i )
        cin >> val[i];

    for (int i = N; i >= 1; -- i ) {
        ans = ans + 1LL * Query(val[i]);
        Update(val[i], 1);
    }

    cout << ans << " ";

    for (int i = 1; i <= N - 2; ++ i ) {
        int x;
        cin >> x;
        ans = 0;
        for (int j = 1; j <= N; ++ j )
            aib[j] = 0;

        for (int j = N; j >= 1; -- j ) {
            if (val[j] == x)
                val[j] = 0;
            if (val[j] == 0) continue;

            ans = ans + 1LL * Query(val[j]);
            Update(val[j], 1);
        }

        cout << ans << " ";
    }

    return 0;
}
