#include <bits/stdc++.h>
#define INF 0x3f3f3f3f

using namespace std;

constexpr int NMAX = 1e4 + 5;

int N, K;

int T[NMAX], L[NMAX];
bool apartsol[NMAX];
bool elim[NMAX];

int val[NMAX];

int ans = 0;

int vf;
vector <int> G[NMAX];
int dp[3][705][705];

void Back (int k) {
    if (k == N) {
        for (int i = 0; i < N; ++ i ) {
            elim[i] = apartsol[i];
            val[i] = 0;
            if (apartsol[i]) val[i] = K;
        }
        for (int i = 0; i < N; ++ i ) {
            if (apartsol[i]) {
                for (int j = 0; j < N; ++ j ) {
                    if (elim[j]) continue;

                    if (T[j] == i) {
                        val[i] = 2 * K;
                        elim[j] = 1;
                        break;
                    }
                }
            }
        }

        for (int i = 0; i < N; ++ i ) {
            if (apartsol[i] && val[i] < 2 * K) {
                for (int j = 0; j < N; ++ j ) {
                    if (!elim[j]) {
                        elim[j] = 1;
                        val[i]++;
                        if (val[i] == 2*K) break;
                    }
                }
                if (val[i] < 2*K) return;
            }
        }

        int sol = 0;
        for (int i = 0; i < N; ++ i ) {
            if (!apartsol[i]) continue;

            sol = sol + L[i];
        }

        ans = max(ans, sol);

        return;
    }

    apartsol[k] = 1;
    Back(k+1);
    apartsol[k] = 0;
    Back(k+1);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> K;

    for (int i = 0; i < N; ++ i )
        cin >> T[i] >> L[i];

    if (N <= 10) {
        Back(0);

        cout << ans << '\n';
    }
    else {
        for (int i = 0; i < N; ++ i ) {
            if (!elim[i]) {
                ++ vf;
                G[vf].push_back(i);
                int node = T[i];
                elim[node] = 1;
                while (node != i) {
                    elim[node] = 1;
                    G[vf].push_back(node);
                    node = T[node];
                }
            }
        }

        int sol = 0;
        dp[0][1][1] = L[0];
        for (int i = 1; i < N; ++ i ) {
            int now = i % 3;
            int old = (i-1) % 3;
            int oldold = (i-2) % 3;

            for (int Nrs = 1; Nrs <= (N+1)/2 && Nrs <= i; ++ Nrs) {
                for (int Nrn = 1; Nrn <= (N + (K-1) * Nrs) / (K+1) && Nrn <= i; ++ Nrn) {
                    dp[now][Nrs][Nrn] = dp[old][Nrs][Nrn-1] + L[i];
                    if (i > 1) dp[now][Nrs][Nrn] = max(dp[now][Nrs][Nrn], dp[oldold][Nrs-1][Nrn-1] + L[i]);

                    sol = max(sol, dp[now][Nrs][Nrn]);
                }
            }

            if (i > 1) {
                for (int Nrs = 1; Nrs <= (N+1)/2 && Nrs <= i; ++ Nrs) {
                    for (int Nrn = 1; Nrn <= (N + (K-1) * Nrs) / (K+1) && Nrn <= i; ++ Nrn) {
                        dp[old][Nrs][Nrn] = max(dp[old][Nrs][Nrn], dp[oldold][Nrs][Nrn]);
                    }
                }
            }
        }

        cout << sol << '\n';
    }
    return 0;
}
