#include <bits/stdc++.h>

using namespace std;

vector<vector<int> > tree, num;
int n;
vector<int> a;

int get(int x, vector<int> &fen) {
    int ans = 0;
    for (; x > 0; x = (x & (x - 1)))
        ans += fen[x];
    return ans;
}

void add(int x, int cnt, vector<int> &fen) {
    for (; x <= (int) fen.size(); x = (x | (x - 1)) + 1)
        fen[x] += cnt;
}


void built(int v = 0, int l = 0, int r = n) {
    if (l + 1 == r) {
        tree[v] = {0, 1};
        num[v] = {a[l]};
        return;
    }
    int m = (l + r) / 2;
    built(v + v + 1, l, m);
    built(v + v + 2, m, r);
    for(int i = l;i<r;++i){
        num[v].push_back(a[i]);
    }
    sort(num[v].begin(), num[v].end());
    tree[v].resize(r - l + 1);
    for(int i = 0;i<(int)num[v].size();++i)
        add(i + 1, 1, tree[v]);
}

int finddpos(int x, int v) {
    int ll = -1, rr = (int) num[v].size();
    while (ll + 1 < rr) {
        int mid = (ll + rr) / 2;
        if (num[v][mid] <= x)
            ll = mid;
        else
            rr = mid;
    }
    return rr;
}

void del(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (pos < l || r <= pos)
        return;
    if (l + 1 == r) {
        tree[v][1] = 0;
        return;
    }
    int m = (l + r) / 2;
    del(x, pos, v + v + 1, l, m);
    del(x, pos, v + v + 2, m, r);
    add(finddpos(x, v), -1, tree[v]);
}


int findans(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (l > pos)
        return 0;
    if (r <= pos + 1) {
        int t = get(r - l, tree[v]);
        int tt = get(finddpos(x, v), tree[v]);
        return get(r - l, tree[v]) - get(finddpos(x, v), tree[v]);
    }
    int m = (l + r) / 2;
    return findans(x, pos, v + v + 1, l, m) + findans(x, pos, v + v + 2, m, r);
}


int findansback(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (r <= pos)
        return 0;
    if (l >= pos) {
        int tt = get(finddpos(x, v), tree[v]);
        return get(finddpos(x, v), tree[v]);
    }
    int m = (l + r) / 2;
    return findansback(x, pos, v + v + 1, l, m) + findansback(x, pos, v + v + 2, m, r);
}

signed main() {
    cin >> n;
    a.resize(n);
    tree.resize(4 * n);
    num.resize(4 * n);
    vector<int> b(n + 1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[a[i]] = i;
    }
    built();
    int ans = 0;
    for (int i = 0; i < n; ++i)
        ans += findans(a[i], i);
    cout << ans << " ";
    for (int i = 0; i < n - 2; ++i) {
        int x;
        cin >> x;
        del(x, b[x]);
        int k = findans(x, b[x]) + findansback(x, b[x]);
        cout << ans - k << " ";
        ans -= k;
    }
}