#include <bits/stdc++.h>

using namespace std;
#define int long long
const int MXN = 2e5;
vector<int> tree[MXN + 3], num[MXN + 3];
int n;
int a[MXN + 3], b[MXN + 3];

int get(int x, int v) {
    int ans = 0;
    int pr = -1;
    for (; x > 0; x = (x & (x - 1))) {
        ans += tree[v][x];
        if(pr == x)
            exit(0);
        pr = x;
    }
    return ans;
}

void add(int x, int cnt, int v) {
    int pr = -1;
    for (; x <= (int) tree[v].size(); x = (x | (x - 1)) + 1) {
        tree[v][x] += cnt;
        if(pr == x)
            exit(0);
        pr = x;
    }
}


void built(int v = 0, int l = 0, int r = n) {
    if (l + 1 == r) {
        tree[v] = {0, 1};
        num[v] = {a[l]};
        return;
    }
    int m = (l + r) / 2;
    built(v + v + 1, l, m);
    built(v + v + 2, m, r);
    num[v].resize(r - l);
    merge(num[v + v + 1].begin(), num[v + v + 1].end(), num[v + v + 2].begin(), num[v + v + 2].end(), num[v].begin());
    tree[v].resize(r - l + 1);
    for (int i = 0; i < (int) num[v].size(); ++i)
        add(i + 1, 1, v);
}

int finddpos(int x, int v) {
    int ll = -1, rr = (int) num[v].size();
    while (ll + 1 < rr) {
        int mid = (ll + rr) / 2;
        if (num[v][mid] <= x)
            ll = mid;
        else
            rr = mid;
    }
    return rr;
}

void del(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (pos < l || r <= pos)
        return;
    if (l + 1 == r) {
        tree[v][1] = 0;
        return;
    }
    int m = (l + r) / 2;
    del(x, pos, v + v + 1, l, m);
    del(x, pos, v + v + 2, m, r);
    add(finddpos(x, v), -1, v);
}


int findans(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (l > pos)
        return 0;
    if (r <= pos + 1) {
        return get(r - l, v) - get(finddpos(x, v), v);
    }
    int m = (l + r) / 2;
    return findans(x, pos, v + v + 1, l, m) + findans(x, pos, v + v + 2, m, r);
}


int findansback(int x, int pos, int v = 0, int l = 0, int r = n) {
    if (r <= pos)
        return 0;
    if (l >= pos) {
        return get(finddpos(x, v), v);
    }
    int m = (l + r) / 2;
    return findansback(x, pos, v + v + 1, l, m) + findansback(x, pos, v + v + 2, m, r);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        b[a[i]] = i;
    }
    built();
    int ans = 0;
    for (int i = 0; i < n; ++i)
        ans += findans(a[i], i);
    cout << ans << " ";
    for (int i = 0; i < n - 2; ++i) {
        int x;
        cin >> x;
        del(x, b[x]);
        int k = findans(x, b[x]) + findansback(x, b[x]);
        cout << ans - k << " ";
        ans -= k;
    }
}