#include <bits/stdc++.h>

#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")

//#define int long long
#define ff first
#define ss second
#define pb push_back

using namespace std;

const int N = 1e5 + 5, inf = 1e5 + 100;

struct tree
{
    int sum, max, min;
}t[4 * N];

int a[N], pos[N];

inline void upd(int v, int l, int r, int i)
{
    if (l == r)
    {
        t[v].sum = 1;
        return;
    }

    int mid = (l + r) / 2;
    if (i <= mid) upd(v * 2, l, mid, i);
    else upd(v * 2 + 1, mid + 1, r, i);

    t[v].sum = t[v * 2].sum + t[v * 2 + 1].sum;
}

inline int sum(int v, int l, int r, int lq, int rq)
{
    if (l > r || lq > rq || l > rq || r < lq) return 0;
    if (lq <= l && r <= rq) return t[v].sum;

    int mid = (l + r) / 2;
    int s1 = sum(v * 2, l, mid, lq, rq);
    int s2 = sum(v * 2 + 1, mid + 1, r, lq, rq);

    return s1 + s2;
}

inline void upd1(int v, int l, int r, int i)
{
    if (l == r)
    {
        t[v].max = 0;
        t[v].min = inf;
        return;
    }

    int mid = (l + r) / 2;;
    if (i <= mid) upd1(v * 2, l, mid, i);
    else upd1(v * 2 + 1, mid + 1, r, i);

    t[v].min = min(t[v * 2].min, t[v * 2 + 1].min);
    t[v].max = max(t[v * 2].max, t[v * 2 + 1].max);
}

inline int mx(int v, int l, int r, int lq, int rq)
{
    if (l > r || lq > rq || l > rq || r < lq) return 0;
    if (lq <= l && r <= rq) return t[v].max;

    int mid = (l + r) / 2;
    int s1 = mx(v * 2, l, mid, lq, rq);
    int s2 = mx(v * 2 + 1, mid + 1, r, lq, rq);

    return max(s1, s2);
}

inline int mn(int v, int l, int r, int lq, int rq)
{
    if (l > r || lq > rq || l > rq || r < lq) return inf;
    if (lq <= l && r <= rq) return t[v].min;

    int mid = (l + r) / 2;
    int s1 = mn(v * 2, l, mid, lq, rq);
    int s2 = mn(v * 2 + 1, mid + 1, r, lq, rq);

    return min(s1, s2);
}

inline void build(int v, int l, int r)
{
    if (l == r)
    {
        t[v].max = a[l];
        t[v].min = a[l];
        return;
    }

    int mid = (l + r) / 2;
    build(v * 2, l, mid);
    build(v * 2 + 1, mid + 1, r);

    t[v].min = min(t[v * 2].min, t[v * 2 + 1].min);
    t[v].max = max(t[v * 2].max, t[v * 2 + 1].max);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
        pos[a[i]] = n - i + 1;
    }

    reverse(a + 1, a + n + 1);

    build(1, 1, n);

    int cnt = 0;
    for (int i = 1; i <= n; ++i)
    {
        cnt += sum(1, 1, n, 1, a[i]);
        upd(1, 1, n, a[i]);
    }

    cout << cnt << ' ';

    for (int j = 1; j <= n - 2; ++j)
    {
        int x;
        cin >> x;

        int c = 0, c1 = 0, k = pos[x];

        int prefmn = mn(1, 1, n, 1, k - 1);
        int suffmx = mx(1, 1, n, k + 1, n);

        if (prefmn < x)
        {
            if (k - 1 < x - prefmn)
            {
                for (int i = 1; i < k; ++i)
                    c += (a[i] < x && a[i] > 0);
            }
            else
            {
                for (int i = prefmn; i < x; ++i)
                    c += (pos[i] > 0 && pos[i] < k);
            }
        }

        if (suffmx > x)
        {
            int suffmn = mn(1, 1, n, k + 1, n);

            if (n - k < n - max(x + 1, suffmn) + 1)
            {
                for (int i = k + 1; i <= n; ++i)
                    c1 += (a[i] > x);
            }
            else
            {
                for (int i = max(x + 1, suffmn); i <= suffmx; ++i)
                    c1 += (pos[i] > 0 && pos[i] > k);
            }
        }

        cnt -= (c + c1);
        cout << cnt << ' ';

        a[k] = 0;
        pos[x] = 0;
        upd1(1, 1, n, k);
    }
    return 0;
}
/*
6
6 1 2 5 3 4
3 5 4 6
*/
