#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;

const int N = 1e4 + 7, INF = 2e9 + 7;

int t[N], l[N];

vector < int > comp[N];///vom avea o permutare si ciclii ei vor fi componente conexe
bitset < N > viz;
int dp[N][2];
int ncomp;

void dfs(int nod) {
    if (!viz[t[nod]]) {
        viz[t[nod]] = 1;
        comp[ncomp].push_back(t[nod]);
        dfs(t[nod]);
    }
}

int main()
{
    int n, k;
    cin >> n >> k;
    for (int i = 1; i <= n; ++i) {
        cin >> t[i] >> l[i];
        t[i]++;///indexam de la 1
    }
    for (int i = 1; i <= n; ++i) {
        if (!viz[i]) {
            viz[i] = 1;
            comp[++ncomp].push_back(i);
            dfs(i);
        }
    }
    int total(0);
    vector < int > omis;
    for (int p = 1; p <= ncomp; ++p) {
        vector < int > c;
        c.push_back(comp[p].back());
        for (int i : comp[p])
            c.push_back(i);
        ///3 cazuri: 1 omis, 1 mort, 1 viu
        int ans(0), caz(-1);
        auto dubiduba = [&]() {
                for (int i = c.size() - 2; i >= 1; --i) {
                    dp[i][0] = max(dp[i + 1][0], dp[i + 1][1]);
                    dp[i][1] = dp[i + 1][0] + l[c[i]];
                }
            };
        dp[c.size() - 1][0] = -INF;
        dp[c.size() - 1][1] = l[c.back()];
        dubiduba();
        if (ans < dp[1][0])
            ans = dp[1][0], caz = 1;
        dp[c.size() - 1][0] = 0;
        dp[c.size() - 1][1] = -INF;
        dubiduba();
        if (ans < dp[1][0])
            ans = dp[1][0], caz = 0;
        if (ans < dp[1][1])
            ans = dp[1][1], caz = 2;
        if (caz == 1) {
            dp[c.size() - 1][0] = -INF;
            dp[c.size() - 1][1] = l[c.back()];
            dubiduba();
        }
        for (int i = 1; i < c.size(); ++i) {
            if (caz == 0)
                omis.push_back(i);
            if (caz == 2)
                caz = 1;
            else if (dp[i][(caz == 0 ? caz : caz - 1)] == dp[i + 1][0])
                caz = 0;
            else/// if (dp[i][(caz == 0 ? caz : caz - 1)] == dp[i + 1][1])
                caz = 2;
        }
        total += ans;
    }
    sort(omis.begin(), omis.end(), [](int a, int b) -> bool {
            return (l[a] > l[b]);
         });
    for (int i = 0; i < omis.size() / k; ++i)
        total += l[i];
    cout << total;
    return 0;
}
