#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5;

int n;
int a[N];
oset<int> t[4 * N];
int pos[N];
ll ans = 0;

void build(int v = 1, int tl = 0, int tr = n - 1) {
    if(tl == tr) {
        t[v].insert(a[tl]);
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    fe(x, t[v << 1]) t[v].insert(x);
    fe(x, t[v << 1 | 1]) t[v].insert(x);
}

void ers(int v, int tl, int tr, int pos, int x) {
    t[v].erase(x);
    if(tl == tr) {
        return;
    }
    int tm = (tl + tr) >> 1;
    if(pos <= tm) ers(v << 1, tl, tm, pos, x);
    else ers(v << 1 | 1, tm + 1, tr, pos, x);
}

void ers(int pos, int x) {
    ers(1, 0, n - 1, pos, x);
}

int query(int v, int tl, int tr, int l, int r, int mn, int mx) {
    if(l > r) {
        return 0;
    }
    if(tl == l && tr == r) {
        return t[v].ook(mx + 1) - t[v].ook(mn);
    }
    int tm = (tl + tr) >> 1;
    return query(v << 1, tl, tm, l, min(r, tm), mn, mx) + query(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r, mn, mx);
}

int query(int l, int r, int mn, int mx) {
    return query(1, 0, n - 1, l, r, mn, mx);
}

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 0, n - 1) cin >> a[i], a[i]--, pos[a[i]] = i;

    build();

    fr(i, 0, n - 1) {
        ans += query(i + 1, n - 1, 0, a[i] - 1);
    }
    cout << ans << " ";

    fr(i, 1, n - 2) {
        int x;
        cin >> x;
        x--;
        ers(pos[x], x);
        ans -= query(pos[x] + 1, n - 1, 0, x - 1);
        ans -= query(0, pos[x] - 1, x + 1, n - 1);
        cout << ans << " ";
    }
    cout << "\n";

    return 0;
}

/*
6
6 1 2 5 3 4
3 5 4 6
*/
