#include <bits/stdc++.h>

#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e5;

int n;
int a[N];
oset<int> t[N];
int pos[N];
ll ans = 0;

void add(int pos, int x) {
    while(pos < n) {
        t[pos].insert(x);
        pos = pos | (pos + 1);
    }
}

void rem(int pos, int x) {
    while(pos < n) {
        t[pos].erase(x);
        pos = pos | (pos + 1);
    }
}

int get1(int pos, int x) {
    int ans = 0;
    while(pos >= 0) {
        ans += sz(t[pos]) - t[pos].ook(x);
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int get1(int l, int r, int x) {
    return get1(r, x) - get1(l - 1, x);
}

int get2(int pos, int x) {
    int ans = 0;
    while(pos >= 0) {
        ans += t[pos].ook(x + 1);
        pos = (pos & (pos + 1)) - 1;
    }
    return ans;
}

int get2(int l, int r, int x) {
    return get2(r, x) - get2(l - 1, x);
}

int main() {
#ifndef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 0, n - 1) cin >> a[i], a[i]--, pos[a[i]] = i;

    fr(i, 0, n - 1) {
        add(i, a[i]);
    }

    fr(i, 0, n - 1) {
        ans += get2(i + 1, n - 1, a[i]);
    }
    cout << ans << " ";

    fr(i, 1, n - 2) {
        int x;
        cin >> x;
        x--;
        rem(pos[x], x);
        ans -= get2(pos[x] + 1, n - 1, x);
        ans -= get1(0, pos[x] - 1, x);
        cout << ans << " ";
    }
    cout << "\n";

    return 0;
}

/*
6
6 1 2 5 3 4
3 5 4 6
*/
