#include <iostream>
#include <vector>
#include <algorithm>
#include <random>

using namespace std;

vector<vector<int>> all;

void gen(int n, vector<int> &x) {
    if(n == 0) {
        all.push_back(x);
        return;
    }
    for(int i = 0; i < 4; ++i) {
        x.push_back(i);
        gen(n - 1, x);
        x.pop_back();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> t(n);
    vector<int> l(n);
    for(int i = 0; i < n; ++i) {
        cin >> t[i] >> l[i];
    }
    vector<int> x;
    gen(n, x);
    int ans = 0;
    for(vector<int> &y : all) {
        vector<bool> used(n, false);
        int curr = 0;
        for(int i = 0; i < n; ++i) {
            if (y[i] == 0) {
                continue;
            }
            if (y[i] == 1) {
                if (used[i]) {
                    curr = -1e9;
                }
                else {
                    used[i] = true;
                }
            }
            if (y[i] == 2) {
                if (used[t[i]]) {
                    curr = -1e9;
                }
                else {
                    used[t[i]] = true;
                }
            }
            if (y[i] == 3) {
                if (used[i] || used[t[i]]) {
                    curr = -1e9;
                }
                else {
                    used[i] = used[t[i]] = true;
                    curr += l[i];
                }
            }
        }
        int left = 0;
        for(int i : used) {
            left += (!i);
        }
        int cnt_half = 0;
        for(int i = 0; i < n; ++i) {
            if (y[i] == 1 || y[i] == 2) {
                ++cnt_half;
            }
        }
        if(cnt_half * k > left) {
            curr = -1e9;
        }
        else {
            left -= cnt_half * k;
            for(int i = 0; i < n; ++i) {
                if (y[i] == 1 || y[i] == 2) {
                    curr += l[i];
                }
            }
        }
        vector<int> can;
        for(int i = 0; i < n; ++i) {
            if (y[i] == 0) {
                can.push_back(l[i]);
            }
        }
        sort(can.rbegin(), can.rend());
        int kek = left / (k * 2);
        for(int i = 0; i < min(kek, (int)can.size()); ++i) {
            curr += can[i];
        }
        ans = max(ans, curr);
    }
    cout << ans;
    return 0;
}