#include <bits/stdc++.h>
#define F first
#define S second
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define in(x) freopen(x, "r", stdin)
#define out(x) freopen(x, "w", stdout)
#define el "\n"
#define pb push_back
using namespace std;
typedef long long ll;

const int N = 1e5 + 500;

int ps[N], a[N], x[N], val;
int le[20 * N], ri[20 * N];
int b[N];
bool mk[N];
int i, n, j;
ll ans;
ll t[2 * N];
vector <ll> pst;
int root[N];
ll aa[N];

void upd(int v) {for (; v < N; v = (v | (v + 1))) t[v]++;}
ll f(int v) {ll res = 0; for (; v >= 0; v = (v & (v + 1)) - 1) res += t[v]; return res;}

int calc(int l, int r)
{
    return f(r) - f(l - 1);
}

int clone(int v)
{
    int newv = sz(pst);
    pst.pb(pst[v]);

    le[newv] = le[v];
    ri[newv] = ri[v];

    return newv;
}

void build(int v, int l, int r, int ps, int val)
{
    if (l == r)
        t[v] = val;
    else
    {
        int md = (l + r) >> 1;

        if (ps <= md)
        {
            le[v] = clone(le[v]);

            build(le[v], l, md, ps, val);
        }
        else
        {
            ri[v] = clone(ri[v]);

            build(ri[v], md + 1, r, ps, val);
        }

        pst[v] = pst[le[v]] + pst[ri[v]];
    }
}

void upd(int v, int l, int r, int ps)
{
    if (l == r)
        pst[v]++;
    else
    {
        int md = (l + r) >> 1;

        if (ps <= md)
            upd(le[v], l, md, ps);
        else
            upd(ri[v], md + 1, r, ps);

        pst[v] = pst[le[v]] + pst[ri[v]];
    }
}

ll get(int v, int l, int r, int tl, int tr)
{
    if (l == tl && r == tr)
        return pst[v];

    if (l > r || tl > tr || tl > r || l > tr)
        return 0;

    int md = (l + r) >> 1;

    return get(le[v], l, md, tl, min(md, tr)) + get(ri[v], md + 1, r, max(tl, md + 1), tr);
}

int main()
{
    ios_base::sync_with_stdio(0);
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (i = 0; i < n; i++)
        cin >> a[i], b[i] = a[i];

    for (i = 0; i < n; i++)
    {
        ans += calc(a[i], n);
        upd(a[i]);
        ps[a[i]] = i;

//        cout << a[i] - i + n << " ";
    }
//    cout << el;

    cout << ans;

    for (i = 0; i < n - 2; i++)
    {
        cin >> x[i];
        b[ps[x[i]]] = 0;
    }

    pst.pb(0);

    for (i = 0; i < n; i++)
    {
        le[i] = 2 * i + 1;
        ri[i] = 2 * i + 2;

        pst.pb(0);
        pst.pb(0);
    }

    int root_now = 0;

    for (i = 1; i < n; i++)
    {
        if (b[i] == 0)
            val = 0;
        else
            val = 1;

        root[i] = clone(root_now);

        root_now = root[i];

        build(root[i], 1, n, a[i], val);
    }

    int last = 0;
    ans = 0;
    for (i = 0; i < n; i++)
    {
        if (last && b[i])
            ans = (b[i] < last);
        else
            if (b[i])
            last = b[i];
    }

    for (i = n - 2; i >= 0; i--)
    {
//        cout << get(root[ps[x[i]] - 1], 1, n, x[i] + 1, n) << " " << get(root[ps[x[i]] + 1], 1, n, 1, x[i] - 1) << el;

        ans += get(root[ps[x[i]] - 1], 1, n, x[i] + 1, n);
        ans += get(root[ps[x[i]] + 1], 1, n, 1, x[i] - 1);

        upd(root[ps[x[i]]], 1, n, x[i]);

        aa[i] = ans;
    }

    for (i = 0; i < n - 2; i++)
        cout << " " << aa[i];
}
