#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll get_disorder(vector<int>& arr){
    if(arr.size() <= 1){
        return 0;
    }
    size_t m = arr.size() / 2;
    vector<int> lef, rig;
    for(size_t i = 0; i < m; i++){
        lef.push_back(arr[i]);
    }
    for(size_t i = m; i < arr.size(); i++){
        rig.push_back(arr[i]);
    }
    ll ans = get_disorder(lef) + get_disorder(rig);
    size_t j = 0;
    for(size_t i = 0; i < m; i++){
        while(j < rig.size() && rig[j] < lef[i]){
            arr[i + j] = rig[j];
            j++;
        }
        ans += j;
        arr[i + j] = lef[i];
    }
    return ans;
}

signed main(){
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<int> qst(n - 2);
    for(int i = 0; i < n - 2; i++){
        cin >> qst[i];
    }
    vector<int> exist(n, 1);
    ll ans = 0;
    for(int i = 0; i < n; i++){
        for(int j = i + 1; j < n; j++){
            if(a[i] > a[j]){
                ans += exist[j] * exist[i];
            }
        }
    }
    cout << ans << ' ';
    for(int t = 0; t < n - 2; t++){
        int i = 0;
        for(int j = 0; j < n; j++){
            if(a[j] == qst[t]){
                i = j;
                exist[j] = 0;
            }
        }
        for(int j = i - 1; j >= 0; j--){
            if(a[j] > a[i]){
                ans -= exist[j];
            }
        }
        for(int j = i + 1; j < n; j++){
            if(a[j] < a[i]){
                ans -= exist[j];
            }
        }
        cout << ans << ' ';
    }
}
