#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

ll get_disorder(vector<int>& arr){
    if(arr.size() <= 1){
        return 0;
    }
    size_t m = arr.size() / 2;
    vector<int> lef, rig;
    for(size_t i = 0; i < m; i++){
        lef.push_back(arr[i]);
    }
    for(size_t i = m; i < arr.size(); i++){
        rig.push_back(arr[i]);
    }
    ll ans = get_disorder(lef) + get_disorder(rig);
    size_t j = 0;
    for(size_t i = 0; i < m; i++){
        while(j < rig.size() && rig[j] < lef[i]){
            arr[i + j] = rig[j];
            j++;
        }
        ans += j;
        arr[i + j] = lef[i];
    }
    return ans;
}

signed main(){
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
    }
    vector<int> exist(n, 1);
    vector<int> copy_a = a;
    ll ans = get_disorder(copy_a);
    cout << ans << '\n';
    for(int t = n - 2; t--;){
        int eras;
        cin >> eras;
        int i;
        for(int j = 0; j < n; j++){
            if(a[j] == eras){
                i = j;
            }
        }
        exist[i] = 0;
        for(int j = i - 1; j >= 0; j--){
            if(exist[j] && a[j] > a[i]){
                ans--;
            }
        }
        for(int j = i + 1; j < n; j++){
            if(exist[j] && a[j] < a[i]){
                ans--;
            }
        }
        cout << ans << '\n';
    }
}
