#include <bits/stdc++.h>

using namespace std;

const int N_MAX = 100002;

int n;

int a[N_MAX];

int posa[N_MAX];

vector <int> opt[N_MAX];

void updateSim (int a, int b)
{
    for(int i = a; i <= n; i += i & -i)
        for(int j = b; j <= n; j += j & -j)
            opt[i].push_back(j);
}

void querySim (int a, int b)
{
    for(int i = a; i >= 1; i -= i & -i)
        for(int j = b; j >= 1; j -= j & -j)
            opt[i].push_back(j);
}

int queries[N_MAX];

map <int, int> codif[N_MAX], L[N_MAX], R[N_MAX];

vector <int> BIT[N_MAX];

void sim ()
{
    for(int i = 1; i <= n; i++)
        updateSim(i, a[i]);
    for(int i = 1; i <= n; i++)
    {
        querySim(i - 1, n);
        querySim(i - 1, a[i]);
    }
    for(int q = 1; q <= n - 2; q++)
    {
        int val;
        cin >> val;
        int pos = posa[val];
        queries[q] = pos;
        querySim(pos - 1, n);
        querySim(pos - 1, a[pos]);
        querySim(n, a[pos] - 1);
        querySim(pos, a[pos] - 1);
        updateSim(pos, a[pos]);
    }
    for(int i = 1; i <= n; i++)
    {
        sort(opt[i].begin(), opt[i].end());
        vector <int> aux;
        for(int j = 0; j < (int)opt[i].size(); j++)
            if(j == 0 || opt[i][j] > opt[i][j - 1])
            {
                int x = opt[i][j];
                codif[i][x] = aux.size();
                aux.push_back(j);
            }
        BIT[i].resize(aux.size());
        for(int j = 0; j < (int)aux.size(); j++)
        {
            int x = opt[i][aux[j]];
            if(1 <= x - (x & -x) && x - (x & -x) <= n)
                L[i][j] = codif[i][x - (x & -x)];
            else
                L[i][j] = -1;
            if(1 <= x + (x & -x) && x + (x & -x) <= n)
                R[i][j] = codif[i][x + (x & -x)];
            else
                R[i][j] = -1;
        }
    }
}

void update (int a, int b, int uval)
{
    for(int i = a; i <= n; i += i & -i)
        for(int j = codif[i][b]; j != -1; j = R[i][j])
            BIT[i][j] += uval;
}

int query (int a, int b)
{
    if(b == 0 || a == 0)
        return 0;
    int ans = 0;
    for(int i = a; i >= 1; i -= i & -i)
        for(int j = codif[i][b]; j != -1; j = L[i][j])
            ans += BIT[i][j];
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 1; i <= n; i++)
        cin >> a[i];
    for(int i = 1; i <= n; i++)
        posa[a[i]] = i;
    sim();
    for(int i = 1; i <= n; i++)
        update(i, a[i], +1);
    int ans = 0;
    for(int i = 1; i <= n; i++)
        ans += query(i - 1, n) - query(i - 1, a[i]);
    cout << ans << " ";
    for(int q = 1; q <= n - 2; q++)
    {
        int pos = queries[q];
        ans -= query(pos - 1, n) - query(pos - 1, a[pos]);
        ans -= query(n, a[pos] - 1) - query(pos, a[pos] - 1);
        update(pos, a[pos], -1);
        cout << ans << " ";
    }
    cout << "\n";
    return 0;
}
