#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <assert.h>
#include <unordered_map>
#include <unordered_set>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 100010;
int n;
int a[N];
int b[N];
int c[N];
int qu[N];
ll sum;

struct t
{
	int v;

	t* le;
	t* ri;


	t()
	{
		v = 0;
		le = nullptr;
		ri = nullptr;
	}

	void rec()
	{
		v = 0;
		if (le) v += le->v;
		if (ri) v += ri->v;
	}

	void add(int q, int qv, int l, int r)
	{
		if (l + 1 == r)
		{
			assert(l == q);
			v += qv;
			return;
		}

		int m = (l + r) >> 1;
		if (q < m)
		{
			if (le == 0)
			{
				le = new t();
			}
			le->add(q, qv, l, m);
		}
		else
		{
			if (ri == 0)
			{
				ri = new t();
			}
			ri->add(q, qv, m, r);
		}
		rec();
	}

	int sum(int ql, int qr, int l, int r)
	{
		if (ql <= l && r <= qr) return v;
		if (qr <= l || r <= ql) return 0;

		int m = (l + r) >> 1;
		int ans = 0;
		if (le)
		{
			ans += le->sum(ql, qr, l, m);
		}
		if (ri)
		{
			ans += ri->sum(ql, qr, m, r);
		}
		return ans;
	}
};

struct t2
{
	t *v;

	t2* le;
	t2* ri;

	t2()
	{
		v = new t();
		le = nullptr;
		ri = nullptr;
	}

	void add(int q1, int q2, int qv, int l1, int r1, int l2, int r2)
	{
		if (l1 + 1 == r1)
		{
			assert(l1 == q1);
			v->add(q2, qv, l2, r2);
			return;
		}

		int m1 = (l1 + r1) >> 1;
		if (q1 < m1)
		{
			if (le == 0)
			{
				le = new t2();
			}
			le->add(q1, q2, qv, l1, m1, l2, r2);
		}
		else
		{
			if (ri == 0)
			{
				ri = new t2();
			}
			ri->add(q1, q2, qv, m1, r1, l2, r2);
		}
		v->add(q2, qv, l2, r2);
	}

	int sum(int ql1, int qr1, int ql2, int qr2, int l1, int r1, int l2, int r2)
	{
		if (ql1 <= l1 && r1 <= qr1) return v->sum(ql2, qr2, l2, r2);
		if (qr1 <= l1 || r1 <= ql1) return 0;

		int m1 = (l1 + r1) >> 1;
		int ans = 0;
		if (le)
		{
			ans += le->sum(ql1, qr1, ql2, qr2, l1, m1, l2, r2);
		}
		if (ri)
		{
			ans += ri->sum(ql1, qr1, ql2, qr2, m1, r1, l2, r2);
		}
		return ans;
	}
};

t2 f1, f2;
t h1, h2;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		b[i] = n;
	}
	f1 = t2();
	f2 = t2();
	h1 = t();
	h2 = t();

	for (int i = 1; i <= n - 2; ++i)
	{
		cin >> qu[i];
		b[qu[i]] = i;
	}

	for (int i = 1; i <= n; ++i)
	{
		sum += h1.sum(a[i] + 1, n + 1, 1, n + 1);
		c[a[i]] += f1.sum(a[i] + 1, n + 1, b[a[i]] + 1, n + 1, 1, n + 1, 1, n + 1);
		h1.add(a[i], 1, 1, n + 1);
		f1.add(a[i], b[a[i]], 1, 1, n + 1, 1, n + 1);
	}

	for (int i = n; i >= 1; --i)
	{
		sum += h2.sum(1, a[i], 1, n + 1);
		c[a[i]] += f2.sum(1, a[i], b[a[i]] + 1, n + 1, 1, n + 1, 1, n + 1);
		h2.add(a[i], 1, 1, n + 1);
		f2.add(a[i], b[a[i]], 1, 1, n + 1, 1, n + 1);
	}

	sum /= 2;

	cout << sum << ' ';

	for (int i = 1; i <= n - 2; ++i)
	{
		sum -= c[qu[i]];
		cout << sum << ' ';
	}
	return 0;
}