#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <assert.h>
#include <unordered_map>
#include <unordered_set>
#include <deque>

using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 100010;
int n;
int a[N];
int b[N];
int c[N];
int qu[N];
ll sum;

struct t
{
	int v;
	int le;
	int ri;

	t();
	void rec();
	void add(int q, int qv, int l, int r);
	int sum(int ql, int qr, int l, int r);
};

struct t2
{
	int v;

	int le;
	int ri;

	t2();
	void add(int q1, int q2, int qv, int l1, int r1, int l2, int r2);
	int sum(int ql1, int qr1, int ql2, int qr2, int l1, int r1, int l2, int r2);
};

t x[10000010];
t2 y[10000010];
int e1 = 1, e2 = 1;

int mkx()
{
	x[e1] = t();
	return e1++;
}

int mky()
{
	y[e2] = t2();
	return e2++;
}

t::t()
{
	v = 0;
	le = 0;
	ri = 0;
}

void t::rec()
{
	v = 0;
	if (le) v += x[le].v;
	if (ri) v += x[ri].v;
}

void t::add(int q, int qv, int l, int r)
{
	if (l + 1 == r)
	{
		assert(l == q);
		v += qv;
		return;
	}

	int m = (l + r) >> 1;
	if (q < m)
	{
		if (le == 0)
		{
			le = mkx();
		}
		x[le].add(q, qv, l, m);
	}
	else
	{
		if (ri == 0)
		{
			ri = mkx();
		}
		x[ri].add(q, qv, m, r);
	}
	rec();
}

int t::sum(int ql, int qr, int l, int r)
{
	if (ql <= l && r <= qr) return v;
	if (qr <= l || r <= ql) return 0;

	int m = (l + r) >> 1;
	int ans = 0;
	if (le)
	{
		ans += x[le].sum(ql, qr, l, m);
	}
	if (ri)
	{
		ans += x[ri].sum(ql, qr, m, r);
	}
	return ans;
}

t2::t2()
{
	v = mkx();
	le = 0;
	ri = 0;
}

void t2::add(int q1, int q2, int qv, int l1, int r1, int l2, int r2)
{
	if (l1 + 1 == r1)
	{
		assert(l1 == q1);
		x[v].add(q2, qv, l2, r2);
		return;
	}

	int m1 = (l1 + r1) >> 1;
	if (q1 < m1)
	{
		if (le == 0)
		{
			le = mky();
			y[le] = t2();
		}
		y[le].add(q1, q2, qv, l1, m1, l2, r2);
	}
	else
	{
		if (ri == 0)
		{
			ri = mky();
			y[ri] = t2();
		}
		y[ri].add(q1, q2, qv, m1, r1, l2, r2);
	}
	x[v].add(q2, qv, l2, r2);
}

int t2::sum(int ql1, int qr1, int ql2, int qr2, int l1, int r1, int l2, int r2)
{
	if (ql1 <= l1 && r1 <= qr1) return x[v].sum(ql2, qr2, l2, r2);
	if (qr1 <= l1 || r1 <= ql1) return 0;

	int m1 = (l1 + r1) >> 1;
	int ans = 0;
	if (le)
	{
		ans += y[le].sum(ql1, qr1, ql2, qr2, l1, m1, l2, r2);
	}
	if (ri)
	{
		ans += y[ri].sum(ql1, qr1, ql2, qr2, m1, r1, l2, r2);
	}
	return ans;
}

int f1, f2;
int h1, h2;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		b[i] = n;
	}
	f1 = mky();
	f2 = mky();
	h1 = mkx();
	h2 = mkx();

	for (int i = 1; i <= n - 2; ++i)
	{
		cin >> qu[i];
		b[qu[i]] = i;
	}

	for (int i = 1; i <= n; ++i)
	{
		//if (n > 15000) assert(i < 60000);
		sum += x[h1].sum(a[i] + 1, n + 1, 1, n + 1);
		c[a[i]] += y[f1].sum(a[i] + 1, n + 1, b[a[i]] + 1, n + 1, 1, n + 1, 1, n + 1);
		x[h1].add(a[i], 1, 1, n + 1);
		y[f1].add(a[i], b[a[i]], 1, 1, n + 1, 1, n + 1);
	}

	for (int i = n; i >= 1; --i)
	{
		sum += x[h2].sum(1, a[i], 1, n + 1);
		c[a[i]] += y[f2].sum(1, a[i], b[a[i]] + 1, n + 1, 1, n + 1, 1, n + 1);
		x[h2].add(a[i], 1, 1, n + 1);
		y[f2].add(a[i], b[a[i]], 1, 1, n + 1, 1, n + 1);
	}

	sum /= 2;

	cout << sum << ' ';

	for (int i = 1; i <= n - 2; ++i)
	{
		sum -= c[qu[i]];
		cout << sum << ' ';
	}
	return 0;
}