#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <assert.h>
#include <unordered_map>
#include <unordered_set>
#include <deque>

#define GLIB_GCC_DEBUG

using namespace std;
typedef long long ll;
typedef long double ld;
const int N = 100010;
int n;
int a[N];
int b[N];
int c[N];
int qu[N];
ll s;

struct t
{
	int v;
	int le;
	int ri;

	t();
};

struct t2
{
	int v;

	int le;
	int ri;

	t2();
};

t x[10000010];
t2 y[10000010];
int e1 = 1, e2 = 1;

int mkx()
{
	x[e1] = t();
	return e1++;
}

int mky()
{
	y[e2] = t2();
	return e2++;
}

t::t()
{
	v = 0;
	le = 0;
	ri = 0;
}

void rec(int i)
{
	x[i].v = 0;
	if (x[i].le) x[i].v += x[x[i].le].v;
	if (x[i].ri) x[i].v += x[x[i].ri].v;
}

void add(int i, int q, int qv, int l, int r)
{
	if (l + 1 == r)
	{
		//assert(l == q);
		x[i].v += qv;
		return;
	}

	int m = (l + r) >> 1;
	if (q < m)
	{
		if (x[i].le == 0)
		{
			x[i].le = mkx();
		}
		add(x[i].le, q, qv, l, m);
	}
	else
	{
		if (x[i].ri == 0)
		{
			x[i].ri = mkx();
		}
		add(x[i].ri, q, qv, m, r);
	}
	rec(i);
}

int sum(int i, int ql, int qr, int l, int r)
{
	if (ql <= l && r <= qr) return x[i].v;
	if (qr <= l || r <= ql) return 0;

	int m = (l + r) >> 1;
	int ans = 0;
	if (x[i].le)
	{
		ans += sum(x[i].le, ql, qr, l, m);
	}
	if (x[i].ri)
	{
		ans += sum(x[i].ri, ql, qr, m, r);
	}
	return ans;
}

t2::t2()
{
	v = mkx();
	le = 0;
	ri = 0;
}

void add(int i, int q1, int q2, int qv, int l1, int r1, int l2, int r2)
{
	if (l1 + 1 == r1)
	{
		//assert(l1 == q1);
		add(y[i].v, q2, qv, l2, r2);
		return;
	}

	int m1 = (l1 + r1) >> 1;
	if (q1 < m1)
	{
		if (y[i].le == 0)
		{
			y[i].le = mky();
		}
		add(y[i].le, q1, q2, qv, l1, m1, l2, r2);
	}
	else
	{
		if (y[i].ri == 0)
		{
			y[i].ri = mky();
		}
		add(y[i].ri, q1, q2, qv, m1, r1, l2, r2);
	}
	add(y[i].v, q2, qv, l2, r2);
}

int sum(int i, int ql1, int qr1, int ql2, int qr2, int l1, int r1, int l2, int r2)
{
	if (ql1 <= l1 && r1 <= qr1) return sum(y[i].v, ql2, qr2, l2, r2);
	if (qr1 <= l1 || r1 <= ql1) return 0;

	int m1 = (l1 + r1) >> 1;
	int ans = 0;
	if (y[i].le)
	{
		ans += sum(y[i].le, ql1, qr1, ql2, qr2, l1, m1, l2, r2);
	}
	if (y[i].ri)
	{
		ans += sum(y[i].ri, ql1, qr1, ql2, qr2, m1, r1, l2, r2);
	}
	return ans;
}

int f1, f2;
int h1, h2;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
		b[i] = n;
	}
	f1 = mky();
	f2 = mky();
	h1 = mkx();
	h2 = mkx();

	for (int i = 1; i <= n - 2; ++i)
	{
		cin >> qu[i];
		b[qu[i]] = i;
	}

	for (int i = 1; i <= n; ++i)
	{
		//if (n > 15000) assert(i < 60000);
		s += sum(h1, a[i] + 1, n + 1, 1, n + 1);
		c[a[i]] += sum(f1, a[i] + 1, n + 1, b[a[i]] + 1, n + 1, 1, n + 1, 1, n + 1);
		add(h1, a[i], 1, 1, n + 1);
		add(f1, a[i], b[a[i]], 1, 1, n + 1, 1, n + 1);
	}

	for (int i = n; i >= 1; --i)
	{
		s += sum(h2, 1, a[i], 1, n + 1);
		c[a[i]] += sum(f2, 1, a[i], b[a[i]] + 1, n + 1, 1, n + 1, 1, n + 1);
		add(h2, a[i], 1, 1, n + 1);
		add(f2, a[i], b[a[i]], 1, 1, n + 1, 1, n + 1);
	}

	s /= 2;

	cout << s << ' ';

	for (int i = 1; i <= n - 2; ++i)
	{
		s -= c[qu[i]];
		cout << s << ' ';
	}
	return 0;
}