//
//  main.cpp
//  D
//
//  Created by Ivan Podvorniy on 20.11.2020.
//  Copyright © 2020 Ivan Podvorniy. All rights reserved.
//

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;
void sol1(int n, int k) {
    vector<int> t(n);
    vector<int> l(n);
    for (int i = 0; i < n; i++) {
        cin >> t[i] >> l[i];
    }
    // vector<int> sol = {1, 4, 6};
    int maxx = 0;
    for (int i = 0; i < (2<<n); i++) {
        vector<int> took;
        for (int j = 0; j < n; j++) {
            if (i>>j&1) {
                took.push_back(j);
            }
        }
        int rest = n - took.size();
        int summ = 0;
        for (auto j : took) {
            if (i>>t[j]&1) {
                rest -= k;
            }
            else {
                rest -= 1;
            }
            summ += l[j];
        }
        
        if (rest >= 0) {
            maxx = max(maxx, summ);
        }
    }
    cout << maxx;
    return;
}
int main() {
    int n, k;
    cin >> n >> k;
    if (n <= 10) {
        sol1(n, k);
        return 0;
    }
    else {
        vector<int> fakel(n);
        vector<int> t(n);
        for (int i = 0; i < n; i++) {
            cin >> t[i] >> fakel[i];
        }
        int pos = t[0];
        vector<int> l(n);
        l[0] = fakel[0];
        int i = 1;
        while (pos != 0) {
            l[i] = fakel[pos];
            pos = t[pos];
            i++;
        }
        
        vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>> (n + 1, {-1e9, -1e9}));
        dp[1][1].first = l[0];
        for (int i = 2; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                if (j >= k) {
                    if (j < n) {
                        dp[i][j + 1].first = max(dp[i - 1][j - 1].second, dp[i - 1][j - k].first) + l[i - 1];
                    }
                    dp[i][j].second = max(dp[i - 1][j].second, dp[i - 1][j].first);
                }
                else {
                    if (j < n) {
                        dp[i][j + 1].first = dp[i - 1][j - 1].second + l[i - 1];
                        
                    }
                    dp[i][j].second = max(dp[i - 1][j].second, dp[i - 1][j].first);
                }
            }
        }
        
        int maxx = 0;
        for (int i = 0; i <= n; i++) {
            maxx = max(maxx, dp.back()[i].second);
        }
        
        for (int i = 0; i <= n - k + 1; i++) {
            maxx = max(maxx, dp.back()[i].first);
        }
        dp = vector<vector<pair<int, int>>> (n + 1, vector<pair<int, int>> (n + 1, {-1e9, -1e9}));
        dp[1][0].second = 0;
        for (int i = 2; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                if (j >= k) {
                    if (j < n) {
                        dp[i][j + 1].first = max(dp[i - 1][j - 1].second, dp[i - 1][j - k].first) + l[i - 1];
                    }
                    dp[i][j].second = max(dp[i - 1][j].second, dp[i - 1][j].first);
                }
                else {
                    if (j < n) {
                        dp[i][j + 1].first = dp[i - 1][j - 1].second + l[i - 1];
                        
                    }
                    dp[i][j].second = max(dp[i - 1][j].second, dp[i - 1][j].first);
                }
            }
        }
        
        for (int i = 0; i <= n; i++) {
            maxx = max(maxx, max(dp.back()[i].second, dp.back()[i].first));
        }
        cout << maxx << endl;
    }
}


/*
 8 2
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
 */

/* {
 8 3
 5 12
 6 111
 4 101
 0 13
 1 105
 7 14
 2 108
 3 9
 */
