#include <bits/stdc++.h>

using namespace std;
int n,v[100005],l[100005],r[100005],aib[100005],poz[100005];
int ai1[100005],ai2[100005],lazy1[100005],lazy2[100005];
int ub(int x)
{
    return (x&(-x));
}
void update(int poz, int val)
{
    for(int i=poz;i<=n;i+=ub(i))
    {
        aib[i]+=val;
    }
}
int query(int poz)
{
    int rez=0;
    for(int i=poz;i>=1;i-=ub(i))
    {
        rez+=aib[i];
    }
    return rez;
}
void propag(int nod, int a, int b)
{
    if(a==b)
    {
        return;
    }
    if(lazy1[nod]==0 || lazy1[nod]==0)
    {
        return;
    }
    ai1[nod*2]-=lazy1[nod];
    ai2[nod*2]-=lazy2[nod];
    ai1[nod*2+1]-=lazy1[nod];
    ai2[nod*2+1]-=lazy2[nod];
    lazy1[nod*2]+=lazy1[nod];
    lazy1[nod*2+1]+=lazy1[nod];
    lazy2[nod*2]+=lazy2[nod];
    lazy2[nod*2+1]+=lazy2[nod];
    lazy1[nod]=lazy2[nod]=0;
}
int query1(int poz, int nod, int a, int b)
{
    if(a==b)
    {
        return ai1[nod];
    }
    propag(nod,a,b);
    int mij = (a+b)/2;
    if(poz<=mij)
    {
        return query1(poz,nod*2,a,mij);
    }
    return query1(poz,nod*2+1,mij+1,b);
}
int query2(int poz, int nod, int a, int b)
{
    if(a==b)
    {
        return ai2[nod];
    }
    propag(nod,a,b);
    int mij = (a+b)/2;
    if(poz<=mij)
    {
        return query2(poz,nod*2,a,mij);
    }
    return query2(poz,nod*2+1,mij+1,b);
}
void update1(int ua, int ub, int val, int nod, int a, int b)
{
    if(ua<=a && ub>=b && ai1[nod]>=val)
    {
        ai1[nod]--;
        lazy1[nod]++;
        return;
    }
    if(a==b)
    {
        return;
    }
    int mij = (a+b)/2;
    propag(nod,a,b);
    if(ua<=mij)
    {
        update1(ua,ub,val,nod*2,a,mij);
    }
    if(ub>mij)
    {
        update1(ua,ub,val,nod*2+1,mij+1,b);
    }
    ai1[nod]=min(ai1[nod*2],ai1[nod*2+1]);
}
void update2(int ua, int ub, int val, int nod, int a, int b)
{
    if(ua<=a && ub>=b && ai1[nod]<=val)
    {
        ai2[nod]--;
        lazy2[nod]++;
        return;
    }
    if(a==b)
    {
        return;
    }
    propag(nod,a,b);
    int mij = (a+b)/2;
    if(ua<=mij)
    {
        update2(ua,ub,val,nod*2,a,mij);
    }
    if(ub>mij)
    {
        update2(ua,ub,val,nod*2+1,mij+1,b);
    }
    ai2[nod]=max(ai2[nod*2],ai2[nod*2+1]);
}
void const_trees(int a, int b, int nod)
{
    if(a==b)
    {
        ai1[nod]=l[a];
        ai2[nod]=r[a];
        return;
    }
    int mij=(a+b)/2;
    const_trees(a,mij,nod*2);
    const_trees(mij+1,b,nod*2+1);
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>v[i];
        poz[v[i]]=i;
    }
    long long rez=0;
    for(int i=1;i<=n;i++)
    {
        l[i]=query(n)-query(v[i]);
        update(v[i],+1);
        rez+=l[i];
    }
    cout<<rez<<' ';
    memset(aib,0,sizeof(aib));
    for(int i=n;i>=1;i--)
    {
        r[i]=query(v[i]);
        update(v[i],+1);
    }
    const_trees(1,n,1);
    for(int i=1;i<=n-2;i++)
    {
        int x;
        cin>>x;
        rez-=query1(poz[x],1,1,n)+query2(poz[x],1,1,n);
        update1(1,poz[x]-1,x,1,1,n);
        update2(poz[x]+1,n,x,1,1,n);
        cout<<rez<<' ';
    }
    return 0;
}
