#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#include <bits/extc++.h>
//OEQWWEXH
using namespace std;
using namespace __gnu_pbds;
typedef int ll;
typedef vector<int> vll;

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> e;


e t[400005];

ll n;

void build(ll l, ll r, ll v, vll &a) {
    for (ll i = l; i <= r; ++i) {
        t[v].insert(a[i]);
    }
    if (l != r) {
        ll mid = (l + r) >> 1;
        build(l, mid, v * 2, a);
        build(mid + 1, r, v * 2 + 1, a);
    }
}

inline void build(vll &a) {
    build(0, n - 1, 1, a);
}

void modify(ll l, ll r, ll v, ll x, ll i) {
    t[v].erase(x);
    if (l != r) {
        ll mid = (l + r) >> 1;
        if (i <= mid) {
            modify(l, mid, v * 2, x, i);
        } else {
            modify(mid + 1, r, v * 2 + 1, x, i);
        }
    }
}

inline void modify(ll x, ll i) {
    modify(0, n - 1, 1, x, i);
}

ll get(ll kl, ll kr, ll l, ll r, ll v, ll x) {
    if (kl <= l && r <= kr) {
        return t[v].order_of_key(x);
    }
    if (r < kl || kr < l) {
        return 0;
    }
    ll mid = (l + r) >> 1;
    return get(kl, kr, l, mid, v * 2, x) + get(kl, kr, mid + 1, r, v * 2 + 1, x);
}

inline ll get(ll l, ll r, ll x) {
    return get(l, r, 0, n - 1, 1, x);
}

ll get1(ll kl, ll kr, ll l, ll r, ll v, ll x) {
    if (kl <= l && r <= kr) {
        ll p = t[v].size() - t[v].order_of_key(x);
        return p;
    }
    if (r < kl || kr < l) {
        return 0;
    }
    ll mid = (l + r) >> 1;
    return get1(kl, kr, l, mid, v * 2, x) + get1(kl, kr, mid + 1, r, v * 2 + 1, x);
}

inline ll get1(ll l, ll r, ll x) {
    return get1(l, r, 0, n - 1, 1, x);
}


gp_hash_table<ll, ll> r;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    vll a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        r[a[i]] = i;
    }

    ll m = n - 2;
    ll ans = 0;
    build(a);
    for (ll i = 0; i < n; ++i) {
        ans += get(i, n - 1, a[i]);
    }
    cout << ans << ' ';
    while (m--) {
        ll x;
        cin >> x;
        ans -= get1(0, r[x], x) - 1;
        cout << (ans -= get(r[x], n - 1, x)) << ' ';
        modify(x, r[x]);
    }
    cout << endl;
}


