#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << '\n'

using namespace std;

const int N = 1e5;
const int INF = 1e9;

int v[5 + N], cv[5 + N];
int aux[5 + N];
int x[5 + N];
int y[5 + N];
int pos[5 + N];
int sol[5 + N];

int ans;

void CountInversions(int l, int r) {
    //debug(l); debug(r);
    if(l >= r)
        return;

    int mid = (l + r) / 2;

    CountInversions(l, mid);
    CountInversions(mid + 1, r);

    for(int i = l; i <= r; i++) aux[i] = v[i];

    x[0] = y[0] = 0;
    for(int i = l; i <= mid; i++) x[++x[0]] = aux[i];
    for(int i = mid + 1; i <= r; i++) y[++y[0]] = aux[i];

    int i, j;
    for(i = 1, j = 1; i <= x[0] && j <= y[0];) {
        if(x[i] <= y[j]) {
            aux[i + j - 1] = x[i];
            ++i;
        } else {
            ans += x[0] - i + 1;
            aux[i + j - 1] = y[j];
            ++j;
        }
    }

    while(i <= x[0]) aux[i + j - 1] = x[i], i++;
    while(j <= y[0]) aux[i + j - 1] = y[j], j++;

    for(i = l; i <= r; i++)
        v[i] = aux[i - l + 1];
}

void SetIO() {
#ifdef EVAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif // EVAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int main() {
    SetIO();
    int countinv(0);

    int n;
    cin >> n;
    for(int i = 1; i <= n; i++) {
        cin >> v[i]; cv[i] = v[i];
        pos[v[i]] = i;
    }

    CountInversions(1, n);

    for(int i = 1; i <= n; i++) v[i] = cv[i];
    cout << ans << " ";

    int prev = ans;

    int cn(n);
    for(int i = 1; i <= cn - 2; i++) {
        int x, posx;
        cin >> x;

        posx = pos[x];

        for(int j = posx; j < n; j++) {
            v[j] = cv[j] = v[j + 1];
        }
        --n;
        ans = 0;
        CountInversions(1, n);

        for(int i = 1; i <= n; i++) v[i] = cv[i];

        /*int cnt(0);
        for(int j = 1; j < posx; j++)
            if(v[j] != -INF && v[j] > x) cnt++;*/
        cout << ans << " ";
    }
    return 0;
}
