#include <bits/stdc++.h>

using namespace std;

const int N = 1e5;

int n;
class AIB {
public:
    int a[5 + N];

    int lsb(int x) {
        return (x & (-x));
    }

    void Update(int pos, int value, int sz) {
        for(int i = pos; i <= sz; i += lsb(i))
            a[i] += value;
    }

    int Query(int pos) {
        int s(0);
        for(int i = pos - 1; i >= 1; i -= lsb(i))
            s += a[i];

        return s;
    }
};
AIB aib;

int v[5 + N], cv[5 + N];
int pos[5 + N];

void SetIO() {
#ifdef BLAT
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif // EVAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int main() {
    SetIO();
    int countinv(0);
    cin >> n;

    for(int i = 1; i <= n; i++) {
        cin >> v[i];
    }

    reverse(v + 1, v + n + 1);
    for(int i = 1; i <= n; i++)
        pos[v[i]] = i;

    for(int i = 1; i <= n; i++) {
        countinv += aib.Query(v[i]);
        aib.Update(v[i], 1, n);
    }

    for(int j = 1; j <= n; j++) aib.a[j] = 0;
    cout << countinv << " ";

    int cn(n);
    for(int i = 1; i <= cn - 2; i++) {
        int x, posx;
        cin >> x;

        posx = pos[x];
        for(int j = posx; j <= n; j++) {
            v[j] = v[j + 1];
            pos[j]--;
        }
        --n;

        countinv = 0;
        for(int j = 1; j <= n; j++) {
            countinv += aib.Query(v[j]);
            aib.Update(v[j], 1, cn);
        }

        for(int j = 1; j <= cn; j++)
            aib.a[j] = 0;
        cout << countinv << " ";
    }
    return 0;
}
