#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define endl "\n"
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> orset;
//mt19937 rng(chorno::steady_clock::now().time_since_epoch.count());

const int N = 1e5 + 200;
int a[N], p[N], n, cur;
bool rem[N];

struct Mtree{
  vector<orset> t;
  void init(){
    t.resize(4*N);
  }
  void build(int v, int tl, int tr){
    for(int i = tl; i <= tr; i ++)
      if(i < n)t[v].insert(a[i]);
    if(tl == tr)
      return;
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
  }
  int bigger(int v, int tl, int tr, int l, int r, int x){
    if(l > r)
      return 0;
    if(tl == l && tr == r)
      return (int)t[v].size() - (int)(t[v].order_of_key(x));
    int tm = (tl + tr) / 2;
    return bigger(v * 2, tl, tm, l, min(r, tm), x) +
           bigger(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, x);
  }
  int smaller(int v, int tl, int tr, int l, int r, int x){
    if(l > r)
      return 0;
    if(tl == l && tr == r)
      return (int)(t[v].order_of_key(x));
    int tm = (tl + tr) / 2;
    return smaller(v * 2, tl, tm, l, min(r, tm), x) +
           smaller(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, x);
  }
  void rem(int v, int tl, int tr, int pos, int val){
    t[v].erase(val);
    if(tl == tr)
      return;
    int tm = (tl + tr) / 2;
    if(pos <= tm)
      rem(v * 2, tl, tm, pos, val);
    else
      rem(v * 2 + 1, tm + 1, tr, pos, val);
  }
};

//struct Stree{
//  vector<int> t;
//  void init(){
//    t.resize(4*N);
//  }
//  void add(int v, int tl, int tr, int pos){
//    if(tl == tr){
//      t[v] ++;
//      return;
//    }
//    int tm = (tl + tr) / 2;
//    if(pos <= tm)
//      add(v * 2, tl, tm, pos);
//    else
//      add(v * 2 + 1, tm + 1, tr, pos);
//    t[v] = t[v * 2] + t[v * 2 + 1];
//  }
//  int sum(int v, int tl, int tr, int l, int r){
//    if(l > r)
//      return 0;
//    if(tl == l && tr == r)
//      return t[v];
//    int tm = (tl + tr) / 2;
//    return sum(v * 2, tl, tm, l, min(r, tm)) + sum(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
//  }
//};

int main(){
  ios_base::sync_with_stdio(0);
  cin.tie(0); cout.tie(0);
  cin >> n;
  for(int i = 0; i < n; i ++)
    cin >> a[i],
    p[a[i]] = i;
  Mtree mt;
  mt.init();
  mt.build(1, 0, N - 1);
  for(int i = 0; i < n; i ++)
    cur += mt.smaller(1, 0, N - 1, i + 1, N - 1, a[i]);
  cout << cur << " ";
  for(int i = 0; i < n - 2; i ++){
    int x; cin >> x;
    cur -= mt.bigger(1, 0, N - 1, 0, p[x] - 1, x);
    cur -= mt.smaller(1, 0, N - 1, p[x] + 1, N - 1, x);
    mt.rem(1, 0, N - 1, p[x], x);
    cout << cur << " ";
  }
}
