#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debug_s(x) cerr << #x << " " << x << " "

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int,int> pii;
typedef tree <pii, null_type, less <pii >, rb_tree_tag, tree_order_statistics_node_update> OST;

const int NMAX = 100001;
const int MOD = 1000000007;
const int BLOCK = 400;

int n;

OST aib[NMAX];
int sz = 0;
void update(pii x, int val) {
    for(int i = x.first; i <= n; i += i&(-i)) {
        if(val == 1) {
            aib[i].insert({x.second, x.first});
        } else {
            aib[i].erase({x.second, x.first});
        }
    }
    if(val == 1)
        sz++;
    else
        sz--;
}
int query(pii x) {
    int sum = 0;
    for(int i = x.first; i > 0; i -= i&(-i)) {
        sum += aib[i].order_of_key({x.second + 1, 0});
    }
    return sum;
}
///de testat aibul

int inv;
int poz[NMAX];
int v[NMAX];
int sol[NMAX];
int pz[NMAX];
int q[NMAX];
int oke[NMAX];

void adauga(pii x) {
    inv += query(x);
    inv += (query({n, n}) - query({x.first, n}) - query({n, x.second}) + query({x.first, x.second}));
    update(x, 1);
}

int main() {

 
    cin >> n;
    int i;
    for(i = 1; i <= n; i++) {
        cin >> v[i];
        poz[v[i]] = i;
    }
    for(i = 1; i <= n - 2; i++) {
        cin >> q[i];
        oke[q[i]] = 1;
        pz[q[i]] = i;
    }
    for(i  =1 ; i<= n; i++) {
        if(!oke[i])
            adauga({n - i + 1, poz[i]});
    }
    for(i = n - 2; i >= 1; i--) {
        sol[i] = inv;
        adauga({n - q[i] + 1, poz[q[i]]});
    }
    sol[0] = inv;
    for( i= 0; i <= n - 2; i++) {
        cout << sol[i] << " ";
    }
    return 0;
}
