#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const int INF = 1e9;

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, k;
	cin >> n >> k;
	vector<int> t(n);
	vector<int> l(n);
	for (int i = 0; i < n; ++i) {
		cin >> t[i] >> l[i];
	}

	vector<vector<int>> dp(n + 1, vector<int> (n + 1, -INF));

	dp[0][n] = 0;

	vector<int> used(n);
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			int first = i;
			for (int j = t[i]; j != i; j = t[j])
				if (l[first] > l[j])
					first = j;
			++cnt;
			int base = cnt;
			for (int m = 0; m < n + 1; ++m) {
					dp[cnt][m] = dp[cnt - 1][m];
			}
			used[first] = cnt;
			for (int j = t[first]; j != first; j = t[j]) {
				used[j] = cnt++;
				for (int m = 0; m < n + 1; ++m) {
					dp[cnt][m] = dp[cnt - 1][m];
					if (m < n - k)
						dp[cnt][m] = std::max(dp[cnt][m], dp[cnt - 1][m + k + 1] + l[j]);
					if (m < n - 1)
						dp[cnt][m] = std::max(dp[cnt][m], dp[cnt - 2][m + 2] + l[j]);
				}
			}
			cnt = base;
			for (int m = 0; m < n + 1; ++m) {
				dp[cnt][m] = dp[cnt - 1][m];
				if (m < n - 1)
					dp[base][m] = std::max(dp[cnt][m], dp[cnt - 1][m + 2] + l[first]);
			}

			for (int j = t[first]; t[j] != first; j = t[j]) {
				used[j] = cnt++;
				for (int m = 0; m < n + 1; ++m) {
					dp[cnt][m] = dp[cnt - 1][m];
					if (m < n - k)
						dp[cnt][m] = std::max(dp[cnt][m], dp[cnt - 1][m + k + 1] + l[j]);
					if (m < n - 1)
						if (j != t[first])
							dp[cnt][m] = std::max(dp[cnt][m], dp[cnt - 2][m + 2] + l[j]);
				}
			}
			for (int m = 0; m < n + 1; ++m)
				dp[cnt][m] = std::max(dp[cnt][m], dp[cnt][m - 1]);

		}
	}

	int ans = -INF;
	for (int i = 0; i < n; ++i)
		ans = std::max(ans, dp[cnt][i]);

	std::cout << ans;


	return 0;
}