#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>


using namespace std;
using namespace __gnu_pbds;

const int N = 1e5 + 10;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> top_set;

top_set t[4 * N];

void update(int v, int l, int r, int pos, int val, int need){
    if (need == 1) t[v].insert(val);
    else t[v].erase(val);
    if (l == r){
        return;
    }
    int m = (l + r) / 2;
    if (pos <= m){
        update(2 * v, l, m, pos, val, need);
    }
    else{
        update(2 * v + 1, m + 1, r, pos, val, need);
    }
}

int get(int v, int tl, int tr, int l, int r, int val, int need){
    if (l > r) return 0;
    if (tl == l && tr == r){
        if (need == 1){
            return t[v].size() - t[v].order_of_key(val);
        }
        else{
            return t[v].order_of_key(val);
        }
    }
    int tm = (tl + tr) / 2;
    return get(2 * v, tl, tm, l, min(r, tm), val, need) + get(2 * v + 1, tm + 1, tr, max(l, tm + 1), r, val, need);
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, ans = 0;
    cin >> n;
    vector<int> v(n);
    vector<int> ind(n + 1);
    for (int i = 0; i < n; i++){
        cin >> v[i];
        ind[v[i]] = i;
        ans += get(1, 0, n - 1, 0, i - 1, v[i], 1);
        update(1, 0, n - 1, i, v[i], 1);
    }
    cout << ans << " ";
    for (int i = 0; i < n - 2; i++){
        int a;
        cin >> a;
        int pos = ind[a];
        update(1, 0, n - 1, pos, a, -1);
        ans -= get(1, 0, n - 1, 0, pos - 1, a, 1);
        ans -= get(1, 0, n - 1, pos + 1, n - 1, a, -1);
        cout << ans << " ";
    }
    return 0;
}
