//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

#pragma GCC target("avx,avx2,sse3,ssse3,sse4.1,sse4.2,tune=native")
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")


using namespace std;

//#define int long long
#define f first
#define s second

int n;
vector <pair <int,int> > t;
vector <int> b;

void build(int v, int l, int r)
{
    if (l==r){
        if (b[l]==1){
            t[v]={0,1};
            return;
        }
        if (b[l]==0) {
            t[v]={1,0};
            return;
        }
        t[v]={0,0};
        return;
    }
    int m=(l+r)>>1;
    build(v*2,l,m);
    build(v*2+1,m+1,r);
    t[v].f=t[v*2+1].f+t[v*2].f;
    t[v].s=t[v*2+1].s+t[v*2].s;
}

void update(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        b[l]=x;
        if (b[l]==1){
            t[v]={0,1};
            return;
        }
        if (b[l]==0) {
            t[v]={1,0};
            return;
        }
        t[v]={0,0};
        return;
    }
    int m=(l+r)>>1;
    update(v*2,l,m,pos,x);
    update(v*2+1,m+1,r,pos,x);
    t[v].f=t[v*2].f+t[v*2+1].f;
    t[v].s=t[v*2].s+t[v*2+1].s;
}

pair <int,int> get(int v, int l, int r, int A, int B)
{
    if (A>B)return {0,0};
    if (B<l || r<A)return {0,0};
    if (A<=l && r<=B)return t[v];
    int m=(l+r)>>1;
    auto q1=get(v*2,l,m,A,B);
    auto q2=get(v*2+1,m+1,r,A,B);
    return {q1.f+q2.f,q1.s+q2.s};
}

vector <int> a;
vector <int> pos;

vector <int> tree()
{
    b.assign(n,0);
    build(1,0,n-1);
    vector <pair <int,int> > p;
    for (int i=0; i<n; i++){
        if (a[i]!=-1)p.push_back({a[i],i});
        else {
            update(1,0,n-1,i,-1);
        }
    }
    sort(p.begin(),p.end());
    vector <int> cnt(n,0);

    for (int i=0; i<p.size(); i++){
        update(1,0,n-1,p[i].s,1);
        auto x=get(1,0,n-1,0,p[i].s-1);
        cnt[p[i].f]+=x.f;
        x=get(1,0,n-1,p[i].s+1,n-1);
        cnt[p[i].f]+=x.s;
    }
    return cnt;
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    pos.resize(n);
    a.resize(n);
    t.resize(4*n+5,{0,0});
    b.resize(n,0);
    build(1,0,n-1);

    for (int i=0; i<n; i++){
        cin >> a[i];
        a[i]--;
    }
    for (int i=0; i<n; i++){
        pos[a[i]]=i;
    }

    vector <int> q(n-2);
    for (int i=0; i<n-2; i++){
        cin >> q[i];
        q[i]--;
    }

    vector <int> cnt=tree();

    int ans=0;
    for (int i=0; i<n; i++){
        ans+=cnt[i];
    }
    cout << ans/2 << " ";
    int poss=0;
    int k=1000;
    while (poss<n-2){
        int oldpos=poss;
        for (int i=0; i<k; i++){
            if (poss>=n-2)return 0;
            int v=q[poss];
            a[pos[v]]=-1;
            ans-=2*cnt[v];
            for (int j=oldpos; j<poss; j++){
                int u=q[j];
                if (pos[v]>pos[u] && u>v)ans+=2;
                if (pos[v]<pos[u] && v>u)ans+=2;
            }
            cnt[v]=0;

            cout << ans/2 << " ";
            poss++;
        }
        cnt=tree();
        /*cout << endl << endl;
        for (int i:a)cout << i+1 << " ";
        cout << endl;
        for (int i:cnt)cout << i << " ";
        cout << endl;
        cout << endl;*/
    }
}
/**
6
6 1 2 5 3 4
3 5 4 6
*/


