﻿#pragma GCC optimize("O2")
#pragma unroll_loops

#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

template<class T>
void print(const vector<T> v) {
	for (auto val : v) {
		cout << val << ' ';
	}
	cout << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	VI va(n);
	VI valpos(n);
	for (int i = 0; i < n; ++i) {
		cin >> va[i];
		--va[i];
		valpos[va[i]] = i;
	}

	VI vout(n - 2);
	set<int> out;
	for (int i = 0; i < n - 2; ++i) {
		int a;
		cin >> a;
		--a;
		vout[i] = valpos[a];
		out.insert(vout[i]);
	}

	VI res(n - 1);
	map<int, int> curr;
	for (int i = 0; i < n; ++i) {
		if (out.find(i) == out.end()) {
			curr[va[i]] = i;
		}
	}

	//cout << curr.begin()->first << ' ' << curr.rbegin()->first << endl;
	//cout << curr.begin()->second << ' ' << curr.rbegin()->second << endl;

	if (curr.begin()->first > curr.rbegin()->first) {
		res[0] = 1;
	}
	else {
		res[0] = 0;
	}

	reverse(vout.begin(), vout.end());

	for (int i = 0; i < n - 2; ++i) {
		res[i + 1] = res[i];
		int val = va[vout[i]];
		for (auto p : curr) {
			if ((val - p.first) * (vout[i] - p.second) < 0) {
				++res[i + 1];
			}
		}
		curr[val] = vout[i];
	}

	for (int i = n - 2; i >= 0; --i) {
		cout << res[i] << ' ';
	}
	cout << endl;

	return 0;
}
