﻿#pragma unroll_loops

#include <iostream>
#include <vector>
#include <set>
#include <list>
#include <algorithm>
#include <cmath>
#include <map>
#include <iomanip>
#include <string>

using namespace std;

#define ll long long

#define VI vector<int>
#define VB vector<bool>
#define VS vector<string>
#define VC vector<char>
#define PAR pair<int, int>
#define VP vector<PAR>
#define VVI vector<VI>
#define VVC vector<VC>
#define VVB vector<VB>
#define VVP vector<VP>
#define endl '\n'

template<class T>
void print(const vector<T> v) {
	for (auto val : v) {
		cout << val << ' ';
	}
	cout << endl;
}

bool rmax(int& a, int b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

bool rmin(int& a, int b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

int n, k;
VI vt, vl;
//set<PAR> vals;

/*int solve(int spare, int arrownum, const set<PAR>& vals) {
	if (spare <= 1) {
		return 0;
	}
	int result = 0;
	auto it = vals.rbegin();
	set<PAR> nvals = vals;
	while (it != vals.rend()) {
		nvals.erase(*it);
		int nexti = vt[it -> second];
		
	}
	return result;
}*/

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	
	cin >> n >> k;
	vt.resize(n);
	vl.resize(n);
	
	for (int i = 0; i < n; ++i) {
		cin >> vt[i] >> vl[i];
		//vals.insert({ vl[i], i });
	}

	if (k == 1) {
		sort(vl.begin(), vl.end());
		int res = 0;
		for (int i = 1; 2 * i <= n; ++i) {
			res += vl[n - i];
		}
		cout << res << endl;
		return 0;
	}
	/*
	for (int arrownum = 0; arrownum < n / 2; ++arrownum) {
		cout << solve(n, arrownum) << endl;
	}*/
	vector<map<int, int>> dp1(n + 1), dp2(n + 1);
	int currpos = 0;
	dp1[0][n] = 0;
	for (int i = 0; i < n; ++i) {
		for (auto p : dp1[i]) {
			if (p.first > 1) {
				rmax(dp2[i + 1][p.first - 2], p.second + vl[currpos]);
			}
			if (p.first > k) {
				rmax(dp1[i + 1][p.first - 1 - k], p.second + vl[currpos]);
			}
			rmax(dp1[i + 1][p.first], p.second);
		}
		for (auto p : dp2[i]) {
			rmax(dp1[i + 1][p.first], p.second);
		}
		currpos = vt[currpos];
	}

	int res = 0;
	for (auto p : dp1[n]) {
		rmax(res, p.second);
	}
	for (auto p : dp2[n]) {
		rmax(res, p.second);
	}

	cout << res << endl;
	
	return 0;
}
