﻿#include <iostream>
#include <vector>
#include <numeric>
#include <algorithm>


int n;
std::vector<int> vec;


int get(const std::vector<int> &vec) {
	int res = 0;
	for (int i = 0; i < vec.size(); i++) {
		res += std::count_if(vec.begin() + i, vec.end(), [&](const auto &val) {return val < vec[i];  });
	}
	return res;
}


int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(0);
	std::cout.tie(0);

	std::cin >> n;
	vec.resize(n);
	std::for_each(vec.begin(), vec.end(), [](auto &val) {std::cin >> val; });


	std::cout << get(vec);
	for (int i = 0; i < (n - 2); i++) {
		int v;
		std::cin >> v;
		vec.erase(std::find(vec.begin(), vec.end(), v));
		//std::cerr << "res: ";
		std::cout << ' ' << get(vec);
		//std::cerr << '\n';
	}
	std::cout << "\n";

	std::cout.flush();
	return 0;
}

/*
6
6 1 2 5 3 4
3 5 4 6

*/