#include <iostream>
#include <deque>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
using namespace std;
vector <int> tree1;
vector <int> a;
vector <int> ans;
vector <vector <int> > tree2;
vector <vector <int> > tree3;
vector <int> sl;
int res(int v,int l,int r,int lx,int rx){
    if (l >= lx && r<= rx) {
        return tree1[v];
    }
    else{
        if (l >= rx || lx >= r) {
            return 0;
        }
        else {
            int mid = (r + l) / 2;
            return res(v * 2 + 1, l, mid, lx, rx) + res(v * 2 + 2, mid, r, lx, rx);
        }
    }
}
void push2(int v) {

    while (tree3[v].size()) {
        tree3[v * 2 + 1].push_back(tree3[v].back());
        tree3[v * 2 + 2].push_back(tree3[v].back());
        tree3[v].pop_back();
    }
}
void push(int v) {
    while ( tree2[v].size()) {
        tree2[v * 2 + 1].push_back(tree2[v].back());
        tree2[v * 2 + 2].push_back(tree2[v].back());
        tree2[v].pop_back();
    }
}
void update(int v, int l,int r,int lx,int rx) {
    if (l == lx && r- l == 1) {
        tree1[v] = 1;
    }
    else {
        if (l >= rx || lx >= r) {
            int no;
        }
        else {
            int mid = (r + l) / 2;
            update(v * 2 + 1, l, mid, lx, rx);
            update(v * 2 + 2, mid, r, lx, rx);
            tree1[v] = tree1[v * 2 + 1] + tree1[v * 2 + 2];
        }
    }
}
void res2(int v, int l, int r, int lx, int rx,int c) {
    if (r - l > 1) {
        push(v);
    }
    if (l == lx && r - l == 1) {
        while (tree2[v].size()) {
            if (tree2[v].back() <c) {
                ans[lx]--;
            }
            tree2[v].pop_back();
        }
    }
    else {
        if (l >= rx || lx >= r) {
            int no;
        }
        else {
            int mid = (r + l) / 2;
            res2(v * 2 + 1, l, mid, lx, rx,c);
            res2(v * 2 + 2, mid, r, lx, rx,c);
            
        }
    }
}
void update2(int v, int l, int r, int lx, int rx,int d) {
    if (l >= lx && r <= rx) {
        tree2[v].push_back(d);
    }
    else {
        if (l >= rx || lx >= r) {
            int no;
        }
        else {
            int mid = (r + l) / 2;
            update2(v * 2 + 1, l, mid, lx, rx,d);
            update2(v * 2 + 2, mid, r, lx, rx,d);
        }
    }
}
void res3(int v, int l, int r, int lx, int rx,int c) {
    if (r - l > 1) {
        push2(v);
    }
    if (l == lx && r - l == 1) {

        while (tree3[v].size()) {
            if (tree3[v].back() > c) {
                sl[lx]--;
            }
            tree3[v].pop_back();
        }
    }
    else {
        if (l >= rx || lx >= r) {
            int no;
        }
        else {
            int mid = (r + l) / 2;
            res3(v * 2 + 1, l, mid, lx, rx,c);
            res3(v * 2 + 2, mid, r, lx, rx,c);

        }
    }
}
void update3(int v, int l, int r, int lx, int rx, int d) {
    if (l >= lx && r <= rx) {
        tree3[v].push_back(d);
    }
    else {
        if (l >= rx || lx >= r) {
            int no;
        }
        else {
            int mid = (r + l) / 2;
            update3(v * 2 + 1, l, mid, lx, rx, d);
            update3(v * 2 + 2, mid, r, lx, rx, d);
        }
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector <int> pos(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a.push_back(x);
        pos[x - 1] = i;
    }
    set <int> e;
    tree1.resize(4 * n);
    ans.resize(n);
    tree2.resize(4 * n);
    tree3.resize(4 * n);
    int su=0;
    sl.resize(n);
    for (int i = n - 1; i >= 0; --i) {
        ans[i] = res(0, 0, n, 0, a[i]-1);
        sl[i] =n-a[i] - (n-i-ans[i]-1);
        su += ans[i];
        update(0, 0, n, a[i] - 1, a[i]);
    }
    cout << su<<" ";
    for (int i = 0; i < n - 2; ++i) {
        int x;
        cin >> x;
        x--;
        res2(0, 0, n, pos[x], pos[x] + 1,x);
        res3(0, 0, n, pos[x], pos[x] + 1, x);
        su -= ans[pos[x]];
        su -= sl[pos[x]];
        update2(0, 0, n, 0, pos[x], x);
        update3(0, 0, n, pos[x], n, x);
        cout << su << " ";
    }
   
}   