#include <iostream>
#include <deque>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
using namespace std;
vector <int> tree1;
vector <int> a;
vector <int> ans;
vector <int> sl;
int res(int v,int l,int r,int lx,int rx){
    if (l >= lx && r<= rx) {
        return tree1[v];
    }
    else{
        if (l >= rx || lx >= r) {
            return 0;
        }
        else {
            int mid = (r + l) / 2;
            return res(v * 2 + 1, l, mid, lx, rx) + res(v * 2 + 2, mid, r, lx, rx);
        }
    }
}
void update(int v, int l,int r,int lx,int rx) {
    if (l == lx && r- l == 1) {
        tree1[v] = 1;
    }
    else {
        if (l >= rx || lx >= r) {
            int no;
        }
        else {
            int mid = (r + l) / 2;
            update(v * 2 + 1, l, mid, lx, rx);
            update(v * 2 + 2, mid, r, lx, rx);
            tree1[v] = tree1[v * 2 + 1] + tree1[v * 2 + 2];
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector <int> pos(n);
    tree1.resize(4 * n);
    int bl = sqrt(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a.push_back(x);
        pos[x - 1] = i;
    }
    set <int> e;
    ans.resize(n);
    int su=0;
    sl.resize(n);
    for (int i = n - 1; i >= 0; --i) {
        ans[i] = res(0, 0, n, 0, a[i]-1);
        sl[i] =n-a[i] - (n-i-ans[i]-1);
        su += ans[i];
        update(0, 0, n, a[i] - 1, a[i]);
    }
    cout << su << " ";
    int j = 0;

    vector <int> used(n, 0);
    while (j < n - 2) {
        int z = j;
        vector <int> d;
        while (j < n - 2 && j - z < bl) {
            int x;
            cin >> x;
            x--;
            int e = su - ans[pos[x]] - sl[pos[x]];
            for (int z = 0; z < d.size(); ++z) {
                if (pos[d[z]]>pos[x] && d[z]<x){
                    e++;
                }
                if (pos[d[z]] < pos[x] && d[z]> x) {
                    e++;
                }
            }
            d.push_back(x);
            used[x] = 1;
            su = e;
            cout << e << " ";
            j++;
        }
        su = 0;
        if (d.size()) {
            for (int i = 0; i < n; ++i) {
                if (used[a[i] - 1] == 0) {
                    for (int j = 0; j < d.size(); ++j) {
                        if (pos[d[j]] > i && d[j] < a[i] - 1) {
                            ans[i]--;
                        }
                        if (pos[d[j]]<i && d[j]>a[i] - 1) {
                            sl[i]--;
                        }
                    }
                }
                else {
                    ans[i] = 0;
                    sl[i] = 0;
                }
                su += ans[i];
            }
        }
    }
   
}   