#include <iostream>
#include <set>
using namespace std;
struct dta {
  int val, ind;
  bool operator <(const dta& x) const {
    return ind>x.ind && val<x.val;
  }
};
struct oppdata {
  int val, ind;
  bool operator <(const oppdata& x) const {
    return ind<x.ind && val>x.val;
  }
};
int inverse[100000],order[100000];
int wval[100000],wind[100000];
int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n,totalinv,x;
  cin >> n;
  for(int i=0; i<n; i++) {
    cin >> order[i];
    inverse[order[i]]=i;
  }
  set<int> freq;
  totalinv=0;
  for(int i=n-1; i>=0; i--) {
    totalinv+=(wval[order[i]]=distance(freq.begin(),freq.lower_bound(order[i])));
    freq.insert(order[i]);
  }
  freq.erase(freq.begin(),freq.end());
  for(int i=0; i<n; i++) {
    wval[order[i]]+=distance(freq.lower_bound(order[i]),freq.end());
    freq.insert(order[i]);
  }
  cout << totalinv << ' ';
  for(int i=0; i<n-2; i++) {
    cin >> x;
    for(int j=0; j<inverse[x]; j++) {
      if(order[j]>x)
        wval[order[j]]--;
    }
    for(int j=inverse[x]+1; j<n; j++) {
      if(order[j]<x)
        wval[order[j]]--;
    }
    totalinv-=wval[x];
    cout << totalinv << ' '; 
  }
}
