#include <iostream>
#include <set>
using namespace std;
struct dta {
  int val, ind,key;
  bool operator <(const dta& x) const {
    return ind>x.ind && val<x.val && key!=x.key;
  }
};
struct oppdata {
  int val, ind,key;
  bool operator <(const oppdata& x) const {
    return ind<x.ind && val>x.val && key!=x.key;
  }
};
int inverse[100000],order[100000];
int wval[100000],wind[100000];
int main() {
  int n,totalinv,x;
  cin >> n;
  for(int i=0; i<n; i++) {
    cin >> order[i];
    inverse[order[i]]=i+1;
  }
  set<int> freq;
  totalinv=0;
  for(int i=n-1; i>=0; i--) {
    totalinv+=(wval[order[i]]=distance(freq.begin(),freq.lower_bound(order[i])));
    freq.insert(order[i]);
  }
  freq.erase(freq.begin(),freq.end());
  for(int i=0; i<n; i++) {
    wval[order[i]]+=distance(freq.lower_bound(order[i]),freq.end());
    freq.insert(order[i]);
  }
  multiset<dta> dafter;
  multiset<oppdata>dbefore;
  dta ntemp;
  oppdata otemp;
  cout << totalinv <<' ';
  for(int i=0; i<n-2; i++) {
    cin >> x;
    ntemp.val=otemp.val=x;
    otemp.ind=ntemp.ind=inverse[x];
    otemp.key=ntemp.key=i+1;
    totalinv-=wval[x];
    totalinv+=distance(dafter.begin(),dafter.lower_bound(ntemp))+distance(dbefore.begin(),dbefore.lower_bound(otemp));
    dafter.insert(ntemp);
    dbefore.insert(otemp);
    cout << totalinv <<' ';
  }
  return 0;
}
