#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
#include <set>
#include <map>
#include <math.h>
#include <queue>
#include <unordered_map>

using namespace std;

typedef long long ll;
const int INF = INT_MAX;

unordered_map <int, int> m;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef HOME_DIDUK001
    freopen("in", "r", stdin);
    freopen("out", "w", stdout);
#endif

    int n;
    cin >> n;

    vector<int> a(n);
    vector<int> pts(n);


    set<int> prikol;
    int glob_pts = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        auto lb = lower_bound(prikol.begin(), prikol.end(), a[i]);
        pts[i] = distance(lb, prikol.end());

        glob_pts += pts[i];
        prikol.insert(a[i]);
        m[a[i]] = i;
    }

    cout << glob_pts << '\n';

    for (int i = 0; i < n - 2; i++) {
        int temp;
        cin >> temp;
        prikol.erase(temp);
        int ind = m[temp];

        glob_pts -= pts[ind];
        pts[ind] = 0;

        for (auto e = prikol.begin(); e != lower_bound(prikol.begin(), prikol.end(), temp); e++) {
            if (m[*e] > ind) {
                pts[m[*e]]--;
                glob_pts--;
            }
        }

        cout << glob_pts << ' ';
    }
}