#include <bits/stdc++.h>

#include <ext/pb_ds/detail/standard_policies.hpp>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define whole(Pudge) (Pudge).begin (), (Pudge).end ()

#define sqr(Pudge) (Pudge) * (Pudge)
#define pw(Pudge) (1LL << (Pudge))

using namespace std;

using namespace __gnu_pbds;

const int MaXn = 1 * 1e5 + 15;

template <typename key> using Ordered_Set = tree <key, null_type, less <key>, rb_tree_tag, tree_order_statistics_node_update>;

Ordered_Set <int> haveL, haveR;

int d[MaXn], L[MaXn], r[MaXn], g[MaXn];

int main () {

    ios_base :: sync_with_stdio (0);
    cin.tie (0); cout.tie (0);

#ifdef Local

    freopen ("Pudge.in", "r", stdin);
    freopen ("Pudge.out", "w", stdout);

#endif // Local

    int n;
    cin >> n;

    for (int now = 0; now < n; now++) {

        cin >> d[now];
        g[d[now]] = now + 0;
    }

    for (int now = 0; now < n; now++) {

        L[d[now]] = (int)haveL.size () - haveL.order_of_key (d[now]);
        haveL.insert (d[now]);
    }

    int answer = 0;
    for (int now = n - 1; now > -1; now--) {

        haveR.insert (d[now]);

        int delta = haveR.order_of_key (d[now]);

        r[d[now]] = r[d[now]] + delta;
        answer = answer + delta;
    }

    cout << answer << " ";

    int Q = n - 2;
    while (Q--) {

        int x;
        cin >> x;

        answer = answer - L[x] - r[x];

        for (int w = 1; w < x; w++)
            if (g[w] > g[x])
                L[w]--;

        for (int w = x + 1; w < n + 1; w++)
            if (g[w] < g[x])
                r[w]--;

        cout << answer << " ";
    }

    cout << "\n";
    return 0;
}
