#include <iostream>
#pragma gcc optimize ("Ofast")
#pragma gcc target ("ssa4")
using namespace std;
const int maxn = 1e5+10;
const int BUFF_LENGHT = 100000;
char buff[BUFF_LENGHT];
int buff_ix = 0;
int a[maxn], ix[maxn], n, x, len;
void read_char() {
    if (++buff_ix == BUFF_LENGHT) fread(buff, BUFF_LENGHT, 1, stdin), buff_ix = 0;
}
void read_int() {
    for(; buff[buff_ix] < '0' || buff[buff_ix] > '9' ; read_char());
    ++len;
    for(; buff[buff_ix] >= '0' && buff[buff_ix] <= '9' ; read_char()) {
        a[len] = a[len]*10 + buff[buff_ix] - '0';
    }
}
int tree[maxn], inv[maxn], ans;
bool rem[maxn];
void add(int ix) {
    for (int i = ix ; i <= n ; i += i & (-i))
        ++tree[i];
}
int sum(int ix) {
    int sum = 0;
    for (int i = ix ; i > 0 ; i -= i & (-i))
        sum += tree[i];
    return sum;
}
void smaller(int x) {
    for (int i = ix[x]+1 ; i <= n ; ++i) {
        if (rem[i]) continue;
        if (a[i] < x) {
            --ans;
            --inv[i];
        }
        //cerr << "inv[" << i << "]: " << inv[i] << '\n';
    }
}
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read_int();
    n = a[1]; --len;
    a[1] = 0;
    for (int i = 1 ; i <= n ; ++i) {
        read_int();
        ix[a[i]] = i;
        ans += inv[i] = sum(n) - sum(a[i]);
        add(a[i]);
    }
    len = 0;
    cout << ans << ' ';
    for (int i = 1 ; i <= n-2 ; ++i) {
        a[i] = 0;
        read_int();
        x = a[i];
        rem[ix[x]] = 1;
        ans -= inv[ix[x]];
        smaller(x);
        cout << ans << ' ';
    }
    return 0;
}
/*
6
6 1 2 5 3 4
3 5 4 6
*/
