#include <iostream>
#include <vector>
using namespace std;
const int maxn = 1e4+10;
int t[maxn], l[maxn], n, k;
vector < int > v[maxn];
int bruteforce(int x) {
    if (x == n) {
        int ans = 0, sum = 0;
        for (int i = 0 ; i < n ; ++i) {
            sum = 0;
            for (auto j : v[i])
                sum += (j == i || j == t[i] ? k : 1);
            ans += (sum >= 2*k)*l[i];
        }
        return ans;
    }
    int ans = 0;
    for (int i = 0 ; i < n ; ++i) {
        v[i].push_back(x);
        ans = max(ans, bruteforce(x+1));
        v[i].pop_back();
    }
    return ans;
}
int main () {
    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> k;
    for (int i = 0 ; i < n ; ++i)
        cin >> t[i] >> l[i];
    cout << bruteforce(0) << '\n';
    return 0;
}
