#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 30
int br, k;
vector<pair<int, int> > edges;
int fav[MAXN];
vector<int> gen;
int score[MAXN], need[MAXN];
vector<int> gen2;
int rem;
int global;
void recurse2()
{
    if(gen2.size() == br){
        int sum = 0;
        int use = 0;
        for(int i = 0; i < br; ++i){
            if(gen2[i] == 1){
                use += need[i];
                sum += fav[i];
            }
        }
        if(use > rem) return;
        global = max(global, sum);
        return;
    }
    gen2.push_back(1); recurse2(); gen2.pop_back();
    gen2.push_back(0); recurse2(); gen2.pop_back();
}
void check()
{
    rem = 0;
    for(int i = 0; i < br; ++i){
        score[i] = 0; need[i] = 0;
    }
    for(int i = 0; i < edges.size(); ++i){
        if(gen[i] == 0) score[edges[i].first] += k;
        if(gen[i] == 1) score[edges[i].second] += k;
        if(gen[i] == 2) ++rem;
    }
    for(int i = 0; i < br; ++i){
        if(score[i] >= 2 * k) need[i] = 0;
        else need[i] = 2 * k - score[i];
    }
    recurse2();
}
void recurse()
{
    if(gen.size() == edges.size()){
        check(); return;
    }
    gen.push_back(1); recurse(); gen.pop_back();
    gen.push_back(0); recurse(); gen.pop_back();
    gen.push_back(2); recurse(); gen.pop_back();
}
signed main()
{
    cin.tie(0); ios::sync_with_stdio(false);
    cin >> br >> k;
    for(int i = 0; i < br; ++i){
        int t, l; cin >> t >> l;
        edges.push_back({i, t});
        fav[i] = l;
    }
    recurse();
    cout << global << endl;
}
