#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 10000;

bool used[MAXN + 5];
int t[MAXN + 5], l[MAXN + 5];

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.first > b.first;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, k;
    cin >> n >> k;

    vector< pair<int, int> > v;
    for (int i = 0; i < n; ++ i)
    {
        cin >> t[i] >> l[i];
        v.push_back(make_pair(l[i], i));
    }

    sort(v.begin(), v.end(), cmp);

    long long ans = 0;
    for (int ii = 0; ii < n; ++ ii)
    {
        int cnt1 = 0, cnt2 = 0;
        long long ans1 = 0;
        for (int i = 0; i < n; ++ i)
        {
            used[i] = false;
        }
        for (int i = ii; i < n; ++ i)
        {
            int idx = v[i].second;
            int c1 = cnt1, c2 = cnt2;
            cnt1++;
            if (!used[idx]) cnt2++;
            if (!used[t[idx]]) cnt2++;
            if (cnt1 * 2 * k <= cnt2 * k + (n - cnt2))
            {
                if (!used[idx]) used[idx] = true;
                if (!used[t[idx]]) used[t[idx]] = true;
                ans1 += l[idx];
            }
            else
            {
                cnt1 = c1;
                cnt2 = c2;
            }
        }
        ans = max(ans, ans1);
    }

    cout << ans << endl;

    return 0;
}
